/* SourceList.c generated by valac 0.20.1, the Vala compiler
 * generated from SourceList.vala, do not modify */

/***
    Copyright (C) 2012-2013 Victor Eduardo <victoreduardm@gmal.com>

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/
/**
     * = WORKING INTERNALS =
     *
     * In order to offer a transparent Item-based API, and avoid the need of providing methods
     * to deal with items directly on the SourceList widget, it was decided to follow a monitor-like
     * implementation, where the source list permanently monitors its root item and any other
     * child item added to it. The task of monitoring the properties of the items has been
     * divided between different objects, as shown below:
     *
     * Monitored by: Object::method that receives the signals indicating the property change.
     * Applied by: Object::method that actually updates the tree to reflect the property changes
     *             (directly or indirectly, as in the case of the tree data model).
     *
     * ---------------------------------------------------------------------------------------------
     *   PROPERTY        |  MONITORED BY                     |  APPLIED BY
     * ---------------------------------------------------------------------------------------------
     * + Item            |                                   |
     *   - parent        | Not monitored                     | N/A
     *   - name          | DataModel::on_item_prop_changed   | Tree::name_cell_data_func
     *   - editable      | DataModel::on_item_prop_changed   | Queried when needed (See Tree::start_editing_item)
     *   - visible       | DataModel::on_item_prop_changed   | DataModel::filter_visible_func
     *   - icon          | DataModel::on_item_prop_changed   | Tree::icon_cell_data_func
     *   - activatable   | Same as @icon                     | Same as @icon
     * + ExpandableItem  |                                   |
     *   - no_caption    | DataModel::on_item_prop_changed   | Tree::name_cell_data_func
     *   - collapsible   | DataModel::on_item_prop_changed   | Tree::update_expansion
     *                   |                                   | Tree::expander_cell_data_func
     *   - expanded      | Same as @collapsible              | Same as @collapsible
     * ---------------------------------------------------------------------------------------------
     * * Only automatic properties are monitored. ExpandableItem's additions/removals are handled by
     *   DataModel::add_item() and DataModel::remove_item()
     *
     * Other features:
     * - Sorting: this happens on the tree-model level (DataModel). Also see SourceList::SortFunc.
     */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gio/gio.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define GRANITE_WIDGETS_TYPE_SOURCE_LIST (granite_widgets_source_list_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList))
#define GRANITE_WIDGETS_SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListClass))
#define GRANITE_WIDGETS_IS_SOURCE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST))
#define GRANITE_WIDGETS_SOURCE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListClass))

typedef struct _GraniteWidgetsSourceList GraniteWidgetsSourceList;
typedef struct _GraniteWidgetsSourceListClass GraniteWidgetsSourceListClass;
typedef struct _GraniteWidgetsSourceListPrivate GraniteWidgetsSourceListPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM (granite_widgets_source_list_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem))
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemClass))

typedef struct _GraniteWidgetsSourceListItem GraniteWidgetsSourceListItem;
typedef struct _GraniteWidgetsSourceListItemClass GraniteWidgetsSourceListItemClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM (granite_widgets_source_list_expandable_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem))
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemClass))

typedef struct _GraniteWidgetsSourceListExpandableItem GraniteWidgetsSourceListExpandableItem;
typedef struct _GraniteWidgetsSourceListExpandableItemClass GraniteWidgetsSourceListExpandableItemClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE (granite_widgets_source_list_tree_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree))
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreeClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreeClass))

typedef struct _GraniteWidgetsSourceListTree GraniteWidgetsSourceListTree;
typedef struct _GraniteWidgetsSourceListTreeClass GraniteWidgetsSourceListTreeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL (granite_widgets_source_list_data_model_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelClass))

typedef struct _GraniteWidgetsSourceListDataModel GraniteWidgetsSourceListDataModel;
typedef struct _GraniteWidgetsSourceListDataModelClass GraniteWidgetsSourceListDataModelClass;
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListItemPrivate GraniteWidgetsSourceListItemPrivate;
typedef struct _GraniteWidgetsSourceListExpandableItemPrivate GraniteWidgetsSourceListExpandableItemPrivate;
typedef struct _GraniteWidgetsSourceListDataModelPrivate GraniteWidgetsSourceListDataModelPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER (granite_widgets_source_list_data_model_node_wrapper_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapper))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperClass))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperClass))

typedef struct _GraniteWidgetsSourceListDataModelNodeWrapper GraniteWidgetsSourceListDataModelNodeWrapper;
typedef struct _GraniteWidgetsSourceListDataModelNodeWrapperClass GraniteWidgetsSourceListDataModelNodeWrapperClass;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR (granite_widgets_source_list_data_model_item_monitor_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitor))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorClass))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_IS_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorClass))

typedef struct _GraniteWidgetsSourceListDataModelItemMonitor GraniteWidgetsSourceListDataModelItemMonitor;
typedef struct _GraniteWidgetsSourceListDataModelItemMonitorClass GraniteWidgetsSourceListDataModelItemMonitorClass;

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_SORT_COLUMN (granite_widgets_source_list_data_model_sort_column_get_type ())

#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_COLUMN (granite_widgets_source_list_data_model_column_get_type ())
#define _granite_widgets_source_list_data_model_node_wrapper_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_data_model_node_wrapper_unref (var), NULL)))
#define _granite_widgets_source_list_data_model_item_monitor_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_data_model_item_monitor_unref (var), NULL)))
typedef struct _Block16Data Block16Data;
typedef struct _GraniteWidgetsSourceListDataModelNodeWrapperPrivate GraniteWidgetsSourceListDataModelNodeWrapperPrivate;
#define _gtk_tree_row_reference_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_row_reference_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListDataModelParamSpecNodeWrapper GraniteWidgetsSourceListDataModelParamSpecNodeWrapper;
typedef struct _GraniteWidgetsSourceListDataModelItemMonitorPrivate GraniteWidgetsSourceListDataModelItemMonitorPrivate;
typedef struct _GraniteWidgetsSourceListDataModelParamSpecItemMonitor GraniteWidgetsSourceListDataModelParamSpecItemMonitor;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON (granite_widgets_source_list_cell_renderer_icon_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIcon))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIconClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListCellRendererIconClass))

typedef struct _GraniteWidgetsSourceListCellRendererIcon GraniteWidgetsSourceListCellRendererIcon;
typedef struct _GraniteWidgetsSourceListCellRendererIconClass GraniteWidgetsSourceListCellRendererIconClass;
typedef struct _GraniteWidgetsSourceListCellRendererIconPrivate GraniteWidgetsSourceListCellRendererIconPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER (granite_widgets_source_list_cell_renderer_spacer_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerClass))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_IS_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerClass))

typedef struct _GraniteWidgetsSourceListCellRendererSpacer GraniteWidgetsSourceListCellRendererSpacer;
typedef struct _GraniteWidgetsSourceListCellRendererSpacerClass GraniteWidgetsSourceListCellRendererSpacerClass;
typedef struct _GraniteWidgetsSourceListCellRendererSpacerPrivate GraniteWidgetsSourceListCellRendererSpacerPrivate;
typedef struct _GraniteWidgetsSourceListTreePrivate GraniteWidgetsSourceListTreePrivate;

#define GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE (granite_widgets_cell_renderer_badge_get_type ())
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadge))
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadgeClass))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_BADGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_BADGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE))
#define GRANITE_WIDGETS_CELL_RENDERER_BADGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE, GraniteWidgetsCellRendererBadgeClass))

typedef struct _GraniteWidgetsCellRendererBadge GraniteWidgetsCellRendererBadge;
typedef struct _GraniteWidgetsCellRendererBadgeClass GraniteWidgetsCellRendererBadgeClass;

#define GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER (granite_widgets_cell_renderer_expander_get_type ())
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpander))
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpanderClass))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_EXPANDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER))
#define GRANITE_WIDGETS_IS_CELL_RENDERER_EXPANDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER))
#define GRANITE_WIDGETS_CELL_RENDERER_EXPANDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_CELL_RENDERER_EXPANDER, GraniteWidgetsCellRendererExpanderClass))

typedef struct _GraniteWidgetsCellRendererExpander GraniteWidgetsCellRendererExpander;
typedef struct _GraniteWidgetsCellRendererExpanderClass GraniteWidgetsCellRendererExpanderClass;

#define GRANITE_WIDGETS_SOURCE_LIST_TREE_TYPE_COLUMN (granite_widgets_source_list_tree_column_get_type ())
#define __g_list_free__gtk_tree_path_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__gtk_tree_path_free0_ (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GraniteWidgetsSourceList {
	GtkScrolledWindow parent_instance;
	GraniteWidgetsSourceListPrivate * priv;
};

struct _GraniteWidgetsSourceListClass {
	GtkScrolledWindowClass parent_class;
	void (*item_selected) (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
};

struct _GraniteWidgetsSourceListPrivate {
	GraniteWidgetsSourceListExpandableItem* _root;
	GraniteWidgetsSourceListTree* tree;
};

typedef gint (*GraniteWidgetsSourceListSortFunc) (GraniteWidgetsSourceListItem* a, GraniteWidgetsSourceListItem* b, void* user_data);
typedef gboolean (*GraniteWidgetsSourceListVisibleFunc) (GraniteWidgetsSourceListItem* item, void* user_data);
struct _GraniteWidgetsSourceListItem {
	GObject parent_instance;
	GraniteWidgetsSourceListItemPrivate * priv;
};

struct _GraniteWidgetsSourceListItemClass {
	GObjectClass parent_class;
	GtkMenu* (*get_context_menu) (GraniteWidgetsSourceListItem* self);
	void (*edited) (GraniteWidgetsSourceListItem* self, const gchar* new_name);
	void (*action_activated) (GraniteWidgetsSourceListItem* self);
	void (*activated) (GraniteWidgetsSourceListItem* self);
};

struct _GraniteWidgetsSourceListItemPrivate {
	GraniteWidgetsSourceListExpandableItem* _parent;
	gchar* _name;
	gchar* _badge;
	gboolean _editable;
	gboolean _visible;
	gboolean _selectable;
	GIcon* _icon;
	GIcon* _activatable;
};

struct _GraniteWidgetsSourceListExpandableItem {
	GraniteWidgetsSourceListItem parent_instance;
	GraniteWidgetsSourceListExpandableItemPrivate * priv;
};

struct _GraniteWidgetsSourceListExpandableItemClass {
	GraniteWidgetsSourceListItemClass parent_class;
	void (*toggled) (GraniteWidgetsSourceListExpandableItem* self);
};

struct _GraniteWidgetsSourceListExpandableItemPrivate {
	gboolean _collapsible;
	gboolean _expanded;
	GeeSet* children_set;
};

struct _GraniteWidgetsSourceListDataModel {
	GtkTreeModelFilter parent_instance;
	GraniteWidgetsSourceListDataModelPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelClass {
	GtkTreeModelFilterClass parent_class;
};

typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_UNSORTED = GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_SORTED = GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID + 1
} GraniteWidgetsSourceListDataModelSortColumn;

struct _GraniteWidgetsSourceListDataModelPrivate {
	GtkSortType sort_dir;
	GraniteWidgetsSourceListExpandableItem* _root;
	GeeHashMap* items;
	GeeHashMap* monitors;
	GtkTreeStore* child_tree;
	GraniteWidgetsSourceListSortFunc sort_func;
	gpointer sort_func_target;
	GDestroyNotify sort_func_target_destroy_notify;
	GraniteWidgetsSourceListVisibleFunc filter_func;
	gpointer filter_func_target;
	GraniteWidgetsSourceListDataModelSortColumn sort_column;
};

typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS
} GraniteWidgetsSourceListDataModelColumn;

struct _Block16Data {
	int _ref_count_;
	GraniteWidgetsSourceListDataModel * self;
	GraniteWidgetsSourceListExpandableItem* parent;
};

struct _GraniteWidgetsSourceListDataModelNodeWrapper {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListDataModelNodeWrapperPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelNodeWrapperClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListDataModelNodeWrapper *self);
};

struct _GraniteWidgetsSourceListDataModelNodeWrapperPrivate {
	GtkTreeRowReference* row_reference;
};

struct _GraniteWidgetsSourceListDataModelParamSpecNodeWrapper {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListDataModelItemMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListDataModelItemMonitorPrivate * priv;
};

struct _GraniteWidgetsSourceListDataModelItemMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListDataModelItemMonitor *self);
};

struct _GraniteWidgetsSourceListDataModelItemMonitorPrivate {
	GraniteWidgetsSourceListItem* item;
};

struct _GraniteWidgetsSourceListDataModelParamSpecItemMonitor {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListCellRendererIcon {
	GtkCellRendererPixbuf parent_instance;
	GraniteWidgetsSourceListCellRendererIconPrivate * priv;
};

struct _GraniteWidgetsSourceListCellRendererIconClass {
	GtkCellRendererPixbufClass parent_class;
};

struct _GraniteWidgetsSourceListCellRendererSpacer {
	GtkCellRenderer parent_instance;
	GraniteWidgetsSourceListCellRendererSpacerPrivate * priv;
};

struct _GraniteWidgetsSourceListCellRendererSpacerClass {
	GtkCellRendererClass parent_class;
};

struct _GraniteWidgetsSourceListCellRendererSpacerPrivate {
	gint _level;
};

struct _GraniteWidgetsSourceListTree {
	GtkTreeView parent_instance;
	GraniteWidgetsSourceListTreePrivate * priv;
};

struct _GraniteWidgetsSourceListTreeClass {
	GtkTreeViewClass parent_class;
};

struct _GraniteWidgetsSourceListTreePrivate {
	GraniteWidgetsSourceListDataModel* _data_model;
	GraniteWidgetsSourceListItem* selected;
	GraniteWidgetsSourceListItem* edited;
	GtkEntry* editable_entry;
	GtkCellRendererText* text_cell;
	GraniteWidgetsSourceListCellRendererIcon* icon_cell;
	GraniteWidgetsSourceListCellRendererIcon* activatable_cell;
	GraniteWidgetsCellRendererBadge* badge_cell;
	GraniteWidgetsCellRendererExpander* primary_expander_cell;
	GraniteWidgetsCellRendererExpander* secondary_expander_cell;
	GeeHashMap* spacer_cells;
};

typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS
} GraniteWidgetsSourceListTreeColumn;


static gpointer granite_widgets_source_list_parent_class = NULL;
static gpointer granite_widgets_source_list_item_parent_class = NULL;
static gpointer granite_widgets_source_list_expandable_item_parent_class = NULL;
static gpointer granite_widgets_source_list_data_model_parent_class = NULL;
static gpointer granite_widgets_source_list_data_model_node_wrapper_parent_class = NULL;
static gpointer granite_widgets_source_list_data_model_item_monitor_parent_class = NULL;
static gpointer granite_widgets_source_list_cell_renderer_icon_parent_class = NULL;
static gpointer granite_widgets_source_list_cell_renderer_spacer_parent_class = NULL;
static gpointer granite_widgets_source_list_tree_parent_class = NULL;

GType granite_widgets_source_list_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_expandable_item_get_type (void) G_GNUC_CONST;
static GType granite_widgets_source_list_tree_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceListPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ROOT,
	GRANITE_WIDGETS_SOURCE_LIST_SELECTED,
	GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE,
	GRANITE_WIDGETS_SOURCE_LIST_EDITING,
	GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION
};
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_new (const gchar* name);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_construct (GType object_type, const gchar* name);
GraniteWidgetsSourceList* granite_widgets_source_list_new (void);
GraniteWidgetsSourceList* granite_widgets_source_list_construct (GType object_type);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_new (void);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_construct (GType object_type);
static GType granite_widgets_source_list_data_model_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_get_root (GraniteWidgetsSourceList* self);
static void granite_widgets_source_list_data_model_set_root (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* value);
static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_new (GraniteWidgetsSourceListDataModel* data_model);
static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_construct (GType object_type, GraniteWidgetsSourceListDataModel* data_model);
static void __lambda66_ (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static void ___lambda66__granite_widgets_source_list_tree_item_selected (GraniteWidgetsSourceListTree* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
gboolean granite_widgets_source_list_has_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_get_data_model (GraniteWidgetsSourceList* self);
static gboolean granite_widgets_source_list_data_model_has_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_set_sort_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListSortFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify);
static void granite_widgets_source_list_data_model_set_sort_func (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListSortFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify);
void granite_widgets_source_list_set_filter_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target, gboolean refilter);
static void granite_widgets_source_list_data_model_set_filter_func (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target);
void granite_widgets_source_list_refilter (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_is_item_expanded (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static GtkTreePath* granite_widgets_source_list_data_model_get_item_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
gboolean granite_widgets_source_list_start_editing_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
static gboolean granite_widgets_source_list_tree_start_editing_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_stop_editing (GraniteWidgetsSourceList* self);
gboolean granite_widgets_source_list_get_editing (GraniteWidgetsSourceList* self);
static void granite_widgets_source_list_tree_stop_editing (GraniteWidgetsSourceListTree* self);
gboolean granite_widgets_source_list_scroll_to_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item, gboolean expand_parents, gboolean use_align, gfloat row_align);
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_item_get_parent (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_expandable_item_expand_with_parents (GraniteWidgetsSourceListExpandableItem* self);
static gboolean granite_widgets_source_list_tree_scroll_to_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean use_align, gfloat row_align);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_previous_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference);
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_next_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_first_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_get_nth_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent, gint index);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_last_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent);
guint granite_widgets_source_list_get_n_visible_children (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent);
static void granite_widgets_source_list_set_root (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* value);
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_selected (GraniteWidgetsSourceList* self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_selected_item (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_set_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* value);
static void granite_widgets_source_list_tree_set_selected_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* value);
PangoEllipsizeMode granite_widgets_source_list_get_ellipsize_mode (GraniteWidgetsSourceList* self);
static PangoEllipsizeMode granite_widgets_source_list_tree_get_ellipsize_mode (GraniteWidgetsSourceListTree* self);
void granite_widgets_source_list_set_ellipsize_mode (GraniteWidgetsSourceList* self, PangoEllipsizeMode value);
static void granite_widgets_source_list_tree_set_ellipsize_mode (GraniteWidgetsSourceListTree* self, PangoEllipsizeMode value);
static gboolean granite_widgets_source_list_tree_get_editing (GraniteWidgetsSourceListTree* self);
GtkSortType granite_widgets_source_list_get_sort_direction (GraniteWidgetsSourceList* self);
static GtkSortType granite_widgets_source_list_data_model_get_sort_direction (GraniteWidgetsSourceListDataModel* self);
void granite_widgets_source_list_set_sort_direction (GraniteWidgetsSourceList* self, GtkSortType value);
static void granite_widgets_source_list_data_model_set_sort_direction (GraniteWidgetsSourceListDataModel* self, GtkSortType value);
static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_tree_get_data_model (GraniteWidgetsSourceListTree* self);
static void granite_widgets_source_list_real_item_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item);
#define GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItemPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON,
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE
};
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_new (const gchar* name);
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_construct (GType object_type, const gchar* name);
void granite_widgets_source_list_item_set_name (GraniteWidgetsSourceListItem* self, const gchar* value);
GtkMenu* granite_widgets_source_list_item_get_context_menu (GraniteWidgetsSourceListItem* self);
static GtkMenu* granite_widgets_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_parent (GraniteWidgetsSourceListItem* self, GraniteWidgetsSourceListExpandableItem* value);
const gchar* granite_widgets_source_list_item_get_name (GraniteWidgetsSourceListItem* self);
const gchar* granite_widgets_source_list_item_get_badge (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_badge (GraniteWidgetsSourceListItem* self, const gchar* value);
gboolean granite_widgets_source_list_item_get_editable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_editable (GraniteWidgetsSourceListItem* self, gboolean value);
gboolean granite_widgets_source_list_item_get_visible (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_visible (GraniteWidgetsSourceListItem* self, gboolean value);
gboolean granite_widgets_source_list_item_get_selectable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_selectable (GraniteWidgetsSourceListItem* self, gboolean value);
GIcon* granite_widgets_source_list_item_get_icon (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_icon (GraniteWidgetsSourceListItem* self, GIcon* value);
GIcon* granite_widgets_source_list_item_get_activatable (GraniteWidgetsSourceListItem* self);
void granite_widgets_source_list_item_set_activatable (GraniteWidgetsSourceListItem* self, GIcon* value);
static void granite_widgets_source_list_item_real_edited (GraniteWidgetsSourceListItem* self, const gchar* new_name);
static void granite_widgets_source_list_item_real_action_activated (GraniteWidgetsSourceListItem* self);
static void granite_widgets_source_list_item_real_activated (GraniteWidgetsSourceListItem* self);
static void granite_widgets_source_list_item_finalize (GObject* obj);
static void _vala_granite_widgets_source_list_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItemPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN,
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN
};
gboolean granite_widgets_source_list_expandable_item_contains (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_add (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_remove (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item);
void granite_widgets_source_list_expandable_item_clear (GraniteWidgetsSourceListExpandableItem* self);
GeeCollection* granite_widgets_source_list_expandable_item_get_children (GraniteWidgetsSourceListExpandableItem* self);
void granite_widgets_source_list_expandable_item_expand_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive);
static void granite_widgets_source_list_expandable_item_set_expansion (GraniteWidgetsSourceListExpandableItem* item, gboolean inclusive, gboolean recursive, gboolean expanded);
void granite_widgets_source_list_expandable_item_collapse_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive);
void granite_widgets_source_list_expandable_item_set_expanded (GraniteWidgetsSourceListExpandableItem* self, gboolean value);
void granite_widgets_source_list_expandable_item_collapse_with_parents (GraniteWidgetsSourceListExpandableItem* self);
gboolean granite_widgets_source_list_expandable_item_get_collapsible (GraniteWidgetsSourceListExpandableItem* self);
void granite_widgets_source_list_expandable_item_set_collapsible (GraniteWidgetsSourceListExpandableItem* self, gboolean value);
gboolean granite_widgets_source_list_expandable_item_get_expanded (GraniteWidgetsSourceListExpandableItem* self);
guint granite_widgets_source_list_expandable_item_get_n_children (GraniteWidgetsSourceListExpandableItem* self);
static void granite_widgets_source_list_expandable_item_real_toggled (GraniteWidgetsSourceListExpandableItem* self);
static void granite_widgets_source_list_expandable_item_finalize (GObject* obj);
static void _vala_granite_widgets_source_list_expandable_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_expandable_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gpointer granite_widgets_source_list_data_model_node_wrapper_ref (gpointer instance);
static void granite_widgets_source_list_data_model_node_wrapper_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_data_model_param_spec_node_wrapper (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_set_node_wrapper (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_take_node_wrapper (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_value_get_node_wrapper (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_node_wrapper_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_item_monitor_ref (gpointer instance);
static void granite_widgets_source_list_data_model_item_monitor_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_data_model_param_spec_item_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_set_item_monitor (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_data_model_value_take_item_monitor (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_data_model_value_get_item_monitor (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_item_monitor_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_sort_column_get_type (void) G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModelPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_DIRECTION,
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT
};
static GType granite_widgets_source_list_data_model_column_get_type (void) G_GNUC_UNUSED;
static GType granite_widgets_source_list_data_model_column_type (GraniteWidgetsSourceListDataModelColumn self);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE "item-parent-needs-update"
static gboolean granite_widgets_source_list_data_model_filter_visible_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* child_model, GtkTreeIter* iter);
static gboolean _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self);
static void granite_widgets_source_list_data_model_update_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_data_model_get_root (GraniteWidgetsSourceListDataModel* self);
static GtkTreePath* granite_widgets_source_list_data_model_node_wrapper_get_path (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static GtkTreeIter* granite_widgets_source_list_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static void granite_widgets_source_list_data_model_add_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_child_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_new (GtkTreeModel* model, GtkTreeIter* iter);
static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_construct (GType object_type, GtkTreeModel* model, GtkTreeIter* iter);
static void granite_widgets_source_list_data_model_add_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_push_parent_update (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* parent);
static void granite_widgets_source_list_data_model_add_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item);
static void granite_widgets_source_list_data_model_remove_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_remove_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_remove_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item);
static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_new (GraniteWidgetsSourceListItem* item);
static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_construct (GType object_type, GraniteWidgetsSourceListItem* item);
static void granite_widgets_source_list_data_model_on_item_prop_changed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, const gchar* prop_name);
static void _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed (GraniteWidgetsSourceListDataModelItemMonitor* _sender, GraniteWidgetsSourceListItem* _self_, const gchar* prop_name, gpointer self);
static void granite_widgets_source_list_data_model_on_item_child_added (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
static void granite_widgets_source_list_data_model_on_item_child_removed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static gboolean ___lambda65_ (Block16Data* _data16_);
static gboolean ____lambda65__gsource_func (gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item_from_path (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path);
static GtkTreePath* granite_widgets_source_list_data_model_get_item_child_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item);
static gint granite_widgets_source_list_data_model_child_model_sort_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b);
static gint _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self);
static gboolean granite_widgets_source_list_data_model_is_category (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, GtkTreeIter* iter, GtkTreePath* path);
static gboolean granite_widgets_source_list_data_model_is_iter_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter);
static gboolean granite_widgets_source_list_data_model_is_path_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapperPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_DUMMY_PROPERTY
};
static gboolean granite_widgets_source_list_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListDataModelNodeWrapper* self);
static void granite_widgets_source_list_data_model_node_wrapper_finalize (GraniteWidgetsSourceListDataModelNodeWrapper* obj);
#define GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitorPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_DUMMY_PROPERTY
};
static void granite_widgets_source_list_data_model_item_monitor_on_notify (GraniteWidgetsSourceListDataModelItemMonitor* self, GParamSpec* prop);
static void _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void granite_widgets_source_list_data_model_item_monitor_finalize (GraniteWidgetsSourceListDataModelItemMonitor* obj);
static void granite_widgets_source_list_data_model_finalize (GObject* obj);
static void _vala_granite_widgets_source_list_data_model_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_data_model_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static GType granite_widgets_source_list_cell_renderer_icon_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_DUMMY_PROPERTY
};
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ICON_SIZE GTK_ICON_SIZE_MENU
static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_new (void);
static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_construct (GType object_type);
static gboolean granite_widgets_source_list_cell_renderer_icon_real_activate (GtkCellRenderer* base, GdkEvent* event, GtkWidget* widget, const gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags);
static GType granite_widgets_source_list_cell_renderer_spacer_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacerPrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL
};
static GtkSizeRequestMode granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base, GtkWidget* widget, gint* min_size, gint* natural_size);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base, GtkWidget* widget, gint width, gint* min_height, gint* natural_height);
static void granite_widgets_source_list_cell_renderer_spacer_real_render (GtkCellRenderer* base, cairo_t* context, GtkWidget* widget, GdkRectangle* bg_area, GdkRectangle* cell_area, GtkCellRendererState flags);
static void granite_widgets_source_list_cell_renderer_spacer_real_get_size (GtkCellRenderer* base, GtkWidget* widget, GdkRectangle* cell_area, gint* x_offset, gint* y_offset, gint* width, gint* height);
static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_new (void);
static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_construct (GType object_type);
static gint granite_widgets_source_list_cell_renderer_spacer_get_level (GraniteWidgetsSourceListCellRendererSpacer* self);
static void granite_widgets_source_list_cell_renderer_spacer_set_level (GraniteWidgetsSourceListCellRendererSpacer* self, gint value);
static void granite_widgets_source_list_cell_renderer_spacer_finalize (GObject* obj);
static void _vala_granite_widgets_source_list_cell_renderer_spacer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_cell_renderer_spacer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType granite_widgets_cell_renderer_badge_get_type (void) G_GNUC_CONST;
GType granite_widgets_cell_renderer_expander_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTreePrivate))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_TREE_DUMMY_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING,
	GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE
};
static void granite_widgets_source_list_tree_on_editing_started (GraniteWidgetsSourceListTree* self, GtkCellEditable* editable, const gchar* path);
static void _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender, GtkCellEditable* editable, const gchar* path, gpointer self);
static void granite_widgets_source_list_tree_on_editing_canceled (GraniteWidgetsSourceListTree* self);
static void _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender, gpointer self);
static void granite_widgets_source_list_tree_on_model_item_updated (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item);
static void _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated (GraniteWidgetsSourceListDataModel* _sender, GraniteWidgetsSourceListItem* item, gpointer self);
static GType granite_widgets_source_list_tree_column_get_type (void) G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_DEFAULT_STYLESHEET "\n" \
"            .source-list.badge {\n" \
"                border-radius: 10px;\n" \
"                border-width: 0;\n" \
"                padding: 1px 2px 1px 2px;\n" \
"                font-weight: bold;\n" \
"            }\n" \
"        "
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION "level-indentation"
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING "left-padding"
#define GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING "expander-spacing"
GtkCssProvider* granite_widgets_utils_set_theming (GtkWidget* widget, const gchar* stylesheet, const gchar* class_name, gint priority);
#define GRANITE_STYLE_CLASS_SOURCE_LIST "source-list"
static void granite_widgets_source_list_tree_set_data_model (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListDataModel* value);
GraniteWidgetsCellRendererExpander* granite_widgets_cell_renderer_expander_new (void);
GraniteWidgetsCellRendererExpander* granite_widgets_cell_renderer_expander_construct (GType object_type);
void granite_widgets_cell_renderer_expander_set_is_category_expander (GraniteWidgetsCellRendererExpander* self, gboolean value);
static void granite_widgets_source_list_tree_expander_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void granite_widgets_source_list_tree_on_activatable_activated (GraniteWidgetsSourceListTree* self, const gchar* item_path_str);
static void _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated (GraniteWidgetsSourceListCellRendererIcon* _sender, const gchar* path, gpointer self);
static void granite_widgets_source_list_tree_icon_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
GraniteWidgetsCellRendererBadge* granite_widgets_cell_renderer_badge_new (void);
GraniteWidgetsCellRendererBadge* granite_widgets_cell_renderer_badge_construct (GType object_type);
static void granite_widgets_source_list_tree_badge_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static void granite_widgets_source_list_tree_name_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static gboolean granite_widgets_source_list_tree_select_func (GraniteWidgetsSourceListTree* self, GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected);
static gboolean _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer self);
static void granite_widgets_source_list_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListTree* self, gint level, gboolean check_previous);
static void granite_widgets_source_list_tree_update_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* expandable_item);
static void granite_widgets_source_list_tree_spacer_cell_data_func (GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter);
static void _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static GtkTreePath* granite_widgets_source_list_tree_get_selected_path (GraniteWidgetsSourceListTree* self);
static void _gtk_tree_path_free0_ (gpointer var);
static void _g_list_free__gtk_tree_path_free0_ (GList* self);
static void granite_widgets_source_list_tree_set_selected (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean scroll_to_item);
static void granite_widgets_source_list_tree_real_cursor_changed (GtkTreeView* base);
static void granite_widgets_source_list_tree_on_editing_done (GraniteWidgetsSourceListTree* self);
static void _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender, gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_path_string (GraniteWidgetsSourceListTree* self, const gchar* item_path_str);
static gboolean granite_widgets_source_list_tree_toggle_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* item);
static void granite_widgets_source_list_tree_real_row_activated (GtkTreeView* base, GtkTreePath* path, GtkTreeViewColumn* column);
static gboolean granite_widgets_source_list_tree_real_key_release_event (GtkWidget* base, GdkEventKey* event);
static gboolean granite_widgets_source_list_tree_real_button_press_event (GtkWidget* base, GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_popup_context_menu (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, GdkEventButton* event);
static gboolean granite_widgets_source_list_tree_over_primary_expander (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, gint x);
static gboolean granite_widgets_source_list_tree_over_cell (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, GtkCellRenderer* cell, gint x);
static gint granite_widgets_source_list_tree_get_cell_width (GraniteWidgetsSourceListTree* self, GtkCellRenderer* cell_renderer);
gboolean granite_widgets_utils_is_left_to_right (GtkWidget* widget);
static gboolean granite_widgets_source_list_tree_real_popup_menu (GtkWidget* base);
static void granite_widgets_source_list_tree_menu_position_func (GraniteWidgetsSourceListTree* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in);
static void _granite_widgets_source_list_tree_menu_position_func_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_model (GtkTreeModel* model, GtkTreeIter* iter);
void granite_widgets_cell_renderer_badge_set_text (GraniteWidgetsCellRendererBadge* self, const gchar* value);
static void granite_widgets_source_list_tree_finalize (GObject* obj);
static void _vala_granite_widgets_source_list_tree_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_tree_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void granite_widgets_source_list_finalize (GObject* obj);
static void _vala_granite_widgets_source_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_source_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Creates a new {@link Granite.Widgets.SourceList}.
     *
     * @return (transfer full) a new {@link Granite.Widgets.SourceList}.
     * @since 0.2
     */
static void __lambda66_ (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	_tmp0_ = item;
	g_signal_emit_by_name (self, "item-selected", _tmp0_);
}


static void ___lambda66__granite_widgets_source_list_tree_item_selected (GraniteWidgetsSourceListTree* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	__lambda66_ (self, item);
}


GraniteWidgetsSourceList* granite_widgets_source_list_construct (GType object_type) {
	GraniteWidgetsSourceList * self = NULL;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* model;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListTree* _tmp2_;
	GraniteWidgetsSourceListTree* _tmp3_;
	GraniteWidgetsSourceListTree* _tmp4_;
	GraniteWidgetsSourceListTree* _tmp5_;
	self = (GraniteWidgetsSourceList*) g_object_new (object_type, NULL);
	_tmp0_ = granite_widgets_source_list_data_model_new ();
	model = _tmp0_;
	_tmp1_ = self->priv->_root;
	granite_widgets_source_list_data_model_set_root (model, _tmp1_);
	gtk_widget_push_composite_child ();
	_tmp2_ = granite_widgets_source_list_tree_new (model);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->tree);
	self->priv->tree = _tmp2_;
	_tmp3_ = self->priv->tree;
	gtk_widget_set_composite_name ((GtkWidget*) _tmp3_, "treeview");
	gtk_widget_pop_composite_child ();
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	_tmp4_ = self->priv->tree;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp5_ = self->priv->tree;
	g_signal_connect_object (_tmp5_, "item-selected", (GCallback) ___lambda66__granite_widgets_source_list_tree_item_selected, self, 0);
	_g_object_unref0 (model);
	return self;
}


GraniteWidgetsSourceList* granite_widgets_source_list_new (void) {
	return granite_widgets_source_list_construct (GRANITE_WIDGETS_TYPE_SOURCE_LIST);
}


/**
     * Checks whether //item// is part of the source list.
     *
     * @param item The item to query.
     * @return //true// if the item belongs to the source list; //false// otherwise.
     * @since 0.2
     */
gboolean granite_widgets_source_list_has_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	gboolean _tmp3_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = item;
	_tmp3_ = granite_widgets_source_list_data_model_has_item (_tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


/**
     * Sets the method used for sorting items.
     *
     * @param sort_func The method to use for sorting items.
     * @see Granite.Widgets.SourceList.SortFunc
     * @since 0.2
     */
void granite_widgets_source_list_set_sort_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListSortFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListSortFunc _tmp2_;
	void* _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = sort_func;
	_tmp2__target = sort_func_target;
	_tmp2__target_destroy_notify = sort_func_target_destroy_notify;
	sort_func_target_destroy_notify = NULL;
	granite_widgets_source_list_data_model_set_sort_func (_tmp1_, _tmp2_, _tmp2__target, _tmp2__target_destroy_notify);
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


/**
     * Sets the method used for filtering out items.
     *
     * @param visible_func The method to use for filtering items.
     * @param refilter Whether to call {@link Granite.Widgets.SourceList.refilter} using the new function.
     * @see Granite.Widgets.SourceList.VisibleFunc
     * @see Granite.Widgets.SourceList.refilter
     * @since 0.2
     */
void granite_widgets_source_list_set_filter_func (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target, gboolean refilter) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListVisibleFunc _tmp2_;
	void* _tmp2__target;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = visible_func;
	_tmp2__target = visible_func_target;
	granite_widgets_source_list_data_model_set_filter_func (_tmp1_, _tmp2_, _tmp2__target);
	_tmp3_ = refilter;
	if (_tmp3_) {
		granite_widgets_source_list_refilter (self);
	}
}


/**
     * Applies the filter method set by {@link Granite.Widgets.SourceList.set_filter_func}
     * to all the items that are part of the current tree.
     *
     * @see Granite.Widgets.SourceList.VisibleFunc
     * @see Granite.Widgets.SourceList.set_filter_func
     * @since 0.2
     */
void granite_widgets_source_list_refilter (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	gtk_tree_model_filter_refilter ((GtkTreeModelFilter*) _tmp1_);
}


/**
     * Queries the actual expansion state of //item//.
     *
     * @see Granite.Widgets.SourceList.ExpandableItem.expanded
     * @return Whether //item// is expanded or not.
     * @since 0.2
     */
gboolean granite_widgets_source_list_is_item_expanded (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListDataModel* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GtkTreePath* _tmp5_ = NULL;
	GtkTreePath* path;
	gboolean _tmp6_ = FALSE;
	GtkTreePath* _tmp7_;
	gboolean _tmp11_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	g_return_val_if_fail (_tmp1_, FALSE);
	_tmp2_ = granite_widgets_source_list_get_data_model (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = item;
	_tmp5_ = granite_widgets_source_list_data_model_get_item_path (_tmp3_, _tmp4_);
	path = _tmp5_;
	_tmp7_ = path;
	if (_tmp7_ != NULL) {
		GraniteWidgetsSourceListTree* _tmp8_;
		GtkTreePath* _tmp9_;
		gboolean _tmp10_ = FALSE;
		_tmp8_ = self->priv->tree;
		_tmp9_ = path;
		_tmp10_ = gtk_tree_view_row_expanded ((GtkTreeView*) _tmp8_, _tmp9_);
		_tmp6_ = _tmp10_;
	} else {
		_tmp6_ = FALSE;
	}
	_tmp11_ = _tmp6_;
	result = _tmp11_;
	_gtk_tree_path_free0 (path);
	return result;
}


/**
     * If //item// is editable, this activates the editor; otherwise, it does nothing.
     * If an item was already being edited, this will fail.
     *
     * @param item Item to edit.
     * @see Granite.Widgets.SourceList.Item.editable
     * @see Granite.Widgets.SourceList.editing
     * @see Granite.Widgets.SourceList.stop_editing
     * @return true if the editing started successfully; false otherwise.
     * @since 0.2
     */
gboolean granite_widgets_source_list_start_editing_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListTree* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	g_return_val_if_fail (_tmp1_, FALSE);
	_tmp2_ = self->priv->tree;
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_tree_start_editing_item (_tmp2_, _tmp3_);
	result = _tmp4_;
	return result;
}


/**
     * Cancels any editing operation going on.
     *
     * @see Granite.Widgets.SourceList.editing
     * @see Granite.Widgets.SourceList.start_editing_item
     * @since 0.2
     */
void granite_widgets_source_list_stop_editing (GraniteWidgetsSourceList* self) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_get_editing (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GraniteWidgetsSourceListTree* _tmp2_;
		_tmp2_ = self->priv->tree;
		granite_widgets_source_list_tree_stop_editing (_tmp2_);
	}
}


/**
     * Scrolls the source list tree to make //item// visible.
     *
     * {@link Granite.Widgets.SourceList.ExpandableItem.expand_with_parents} is called
     * for the item's parent if //expand_parents// is //true//, to make sure it's not
     * hidden behind a collapsed row.
     *
     * If use_align is //false//, then the row_align argument is ignored, and the tree
     * does the minimum amount of work to scroll the item onto the screen. This means that
     * the item will be scrolled to the edge closest to its current position. If the item
     * is currently visible on the screen, nothing is done.
     *
     * @param item Item to scroll to.
     * @param expand_parents Whether to recursively expand item's parent in case they are collapsed.
     * @param use_align Whether to use the //row_align// argument.
     * @param row_align The vertical alignment of //item//. 0.0 means top, 0.5 center, and 1.0 bottom.
     * @return //true// if successful; //false// otherwise.
     * @since 0.2
     */
gboolean granite_widgets_source_list_scroll_to_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item, gboolean expand_parents, gboolean use_align, gfloat row_align) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp7_;
	GraniteWidgetsSourceListTree* _tmp11_;
	GraniteWidgetsSourceListItem* _tmp12_;
	gboolean _tmp13_;
	gfloat _tmp14_;
	gboolean _tmp15_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	g_return_val_if_fail (_tmp1_, FALSE);
	_tmp3_ = expand_parents;
	if (_tmp3_) {
		GraniteWidgetsSourceListItem* _tmp4_;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		_tmp4_ = item;
		_tmp5_ = granite_widgets_source_list_item_get_parent (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_ != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp7_ = _tmp2_;
	if (_tmp7_) {
		GraniteWidgetsSourceListItem* _tmp8_;
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
		_tmp8_ = item;
		_tmp9_ = granite_widgets_source_list_item_get_parent (_tmp8_);
		_tmp10_ = _tmp9_;
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp10_);
	}
	_tmp11_ = self->priv->tree;
	_tmp12_ = item;
	_tmp13_ = use_align;
	_tmp14_ = row_align;
	_tmp15_ = granite_widgets_source_list_tree_scroll_to_item (_tmp11_, _tmp12_, _tmp13_, _tmp14_);
	result = _tmp15_;
	return result;
}


/**
     * Gets the previous item with respect to //reference//.
     *
     * @param reference Item to use as reference.
     * @return The item that appears before //reference//, or //null// if there's none.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_previous_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListDataModel* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GtkTreeIter* _tmp5_ = NULL;
	GtkTreeIter* iter;
	GtkTreeIter* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (reference != NULL, NULL);
	_tmp0_ = reference;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	g_return_val_if_fail (_tmp1_, NULL);
	_tmp2_ = granite_widgets_source_list_get_data_model (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = reference;
	_tmp5_ = granite_widgets_source_list_data_model_get_item_iter (_tmp3_, _tmp4_);
	iter = _tmp5_;
	_tmp6_ = iter;
	if (_tmp6_ != NULL) {
		GtkTreeIter* _tmp7_;
		GtkTreeIter new_iter;
		GraniteWidgetsSourceListDataModel* _tmp8_;
		GraniteWidgetsSourceListDataModel* _tmp9_;
		gboolean _tmp10_ = FALSE;
		_tmp7_ = iter;
		new_iter = *_tmp7_;
		_tmp8_ = granite_widgets_source_list_get_data_model (self);
		_tmp9_ = _tmp8_;
		_tmp10_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp9_, &new_iter);
		if (_tmp10_) {
			GraniteWidgetsSourceListDataModel* _tmp11_;
			GraniteWidgetsSourceListDataModel* _tmp12_;
			GtkTreeIter _tmp13_;
			GraniteWidgetsSourceListItem* _tmp14_ = NULL;
			_tmp11_ = granite_widgets_source_list_get_data_model (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = new_iter;
			_tmp14_ = granite_widgets_source_list_data_model_get_item (_tmp12_, &_tmp13_);
			result = _tmp14_;
			_g_free0 (iter);
			return result;
		}
	}
	result = NULL;
	_g_free0 (iter);
	return result;
}


/**
     * Gets the next item with respect to //reference//.
     *
     * @param reference Item to use as reference.
     * @return The item that appears after //reference//, or //null// if there's none.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_next_item (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* reference) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListDataModel* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GtkTreeIter* _tmp5_ = NULL;
	GtkTreeIter* iter;
	GtkTreeIter* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (reference != NULL, NULL);
	_tmp0_ = reference;
	_tmp1_ = granite_widgets_source_list_has_item (self, _tmp0_);
	g_return_val_if_fail (_tmp1_, NULL);
	_tmp2_ = granite_widgets_source_list_get_data_model (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = reference;
	_tmp5_ = granite_widgets_source_list_data_model_get_item_iter (_tmp3_, _tmp4_);
	iter = _tmp5_;
	_tmp6_ = iter;
	if (_tmp6_ != NULL) {
		GtkTreeIter* _tmp7_;
		GtkTreeIter new_iter;
		GraniteWidgetsSourceListDataModel* _tmp8_;
		GraniteWidgetsSourceListDataModel* _tmp9_;
		gboolean _tmp10_ = FALSE;
		_tmp7_ = iter;
		new_iter = *_tmp7_;
		_tmp8_ = granite_widgets_source_list_get_data_model (self);
		_tmp9_ = _tmp8_;
		_tmp10_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp9_, &new_iter);
		if (_tmp10_) {
			GraniteWidgetsSourceListDataModel* _tmp11_;
			GraniteWidgetsSourceListDataModel* _tmp12_;
			GtkTreeIter _tmp13_;
			GraniteWidgetsSourceListItem* _tmp14_ = NULL;
			_tmp11_ = granite_widgets_source_list_get_data_model (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = new_iter;
			_tmp14_ = granite_widgets_source_list_data_model_get_item (_tmp12_, &_tmp13_);
			result = _tmp14_;
			_g_free0 (iter);
			return result;
		}
	}
	result = NULL;
	_g_free0 (iter);
	return result;
}


/**
     * Gets the first visible child of an expandable item.
     *
     * @param parent Parent of the child to look up.
     * @return The first visible child of //parent//, or null if it was not found.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_first_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	_tmp0_ = parent;
	_tmp1_ = granite_widgets_source_list_get_nth_child (self, _tmp0_, 0);
	result = _tmp1_;
	return result;
}


/**
     * Gets the last visible child of an expandable item.
     *
     * @param parent Parent of the child to look up.
     * @return The last visible child of //parent//, or null if it was not found.
     * @since 0.2
     */
GraniteWidgetsSourceListItem* granite_widgets_source_list_get_last_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	guint _tmp2_ = 0U;
	GraniteWidgetsSourceListItem* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	_tmp0_ = parent;
	_tmp1_ = parent;
	_tmp2_ = granite_widgets_source_list_get_n_visible_children (self, _tmp1_);
	_tmp3_ = granite_widgets_source_list_get_nth_child (self, _tmp0_, ((gint) _tmp2_) - 1);
	result = _tmp3_;
	return result;
}


/**
     * Gets the number of visible children of an expandable item.
     *
     * @param parent Item to query.
     * @return Number of visible children of //parent//.
     * @since 0.2
     */
guint granite_widgets_source_list_get_n_visible_children (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent) {
	guint result = 0U;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GtkTreeIter* _tmp3_ = NULL;
	GtkTreeIter* parent_iter;
	GraniteWidgetsSourceListDataModel* _tmp4_;
	GraniteWidgetsSourceListDataModel* _tmp5_;
	gint _tmp6_ = 0;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (parent != NULL, 0U);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = parent;
	_tmp3_ = granite_widgets_source_list_data_model_get_item_iter (_tmp1_, (GraniteWidgetsSourceListItem*) _tmp2_);
	parent_iter = _tmp3_;
	_tmp4_ = granite_widgets_source_list_get_data_model (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp5_, parent_iter);
	result = (guint) _tmp6_;
	_g_free0 (parent_iter);
	return result;
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_get_nth_child (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* parent, gint index) {
	GraniteWidgetsSourceListItem* result = NULL;
	gint _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GtkTreeIter* _tmp4_ = NULL;
	GtkTreeIter* parent_iter;
	GtkTreeIter child_iter = {0};
	GraniteWidgetsSourceListDataModel* _tmp5_;
	GraniteWidgetsSourceListDataModel* _tmp6_;
	GtkTreeIter* _tmp7_;
	gint _tmp8_;
	GtkTreeIter _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	_tmp0_ = index;
	if (_tmp0_ < 0) {
		result = NULL;
		return result;
	}
	_tmp1_ = granite_widgets_source_list_get_data_model (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = parent;
	_tmp4_ = granite_widgets_source_list_data_model_get_item_iter (_tmp2_, (GraniteWidgetsSourceListItem*) _tmp3_);
	parent_iter = _tmp4_;
	_tmp5_ = granite_widgets_source_list_get_data_model (self);
	_tmp6_ = _tmp5_;
	_tmp7_ = parent_iter;
	_tmp8_ = index;
	_tmp10_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp6_, &_tmp9_, _tmp7_, _tmp8_);
	child_iter = _tmp9_;
	if (_tmp10_) {
		GraniteWidgetsSourceListDataModel* _tmp11_;
		GraniteWidgetsSourceListDataModel* _tmp12_;
		GtkTreeIter _tmp13_;
		GraniteWidgetsSourceListItem* _tmp14_ = NULL;
		_tmp11_ = granite_widgets_source_list_get_data_model (self);
		_tmp12_ = _tmp11_;
		_tmp13_ = child_iter;
		_tmp14_ = granite_widgets_source_list_data_model_get_item (_tmp12_, &_tmp13_);
		result = _tmp14_;
		_g_free0 (parent_iter);
		return result;
	}
	result = NULL;
	_g_free0 (parent_iter);
	return result;
}


GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_get_root (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_root;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void granite_widgets_source_list_set_root (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListExpandableItem* value) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_root);
	self->priv->_root = _tmp1_;
	g_object_notify ((GObject *) self, "root");
}


GraniteWidgetsSourceListItem* granite_widgets_source_list_get_selected (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListItem* result;
	GraniteWidgetsSourceListTree* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_selected_item (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void granite_widgets_source_list_set_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* value) {
	gboolean _tmp0_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp1_;
	gboolean _tmp5_;
	GraniteWidgetsSourceListTree* _tmp9_;
	GraniteWidgetsSourceListItem* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp1_ = value;
	if (_tmp1_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
		_tmp2_ = value;
		_tmp3_ = granite_widgets_source_list_item_get_parent (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = _tmp0_;
	if (_tmp5_) {
		GraniteWidgetsSourceListItem* _tmp6_;
		GraniteWidgetsSourceListExpandableItem* _tmp7_;
		GraniteWidgetsSourceListExpandableItem* _tmp8_;
		_tmp6_ = value;
		_tmp7_ = granite_widgets_source_list_item_get_parent (_tmp6_);
		_tmp8_ = _tmp7_;
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp8_);
	}
	_tmp9_ = self->priv->tree;
	_tmp10_ = value;
	granite_widgets_source_list_tree_set_selected_item (_tmp9_, _tmp10_);
	g_object_notify ((GObject *) self, "selected");
}


PangoEllipsizeMode granite_widgets_source_list_get_ellipsize_mode (GraniteWidgetsSourceList* self) {
	PangoEllipsizeMode result;
	GraniteWidgetsSourceListTree* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_ellipsize_mode (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


void granite_widgets_source_list_set_ellipsize_mode (GraniteWidgetsSourceList* self, PangoEllipsizeMode value) {
	GraniteWidgetsSourceListTree* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = value;
	granite_widgets_source_list_tree_set_ellipsize_mode (_tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "ellipsize-mode");
}


gboolean granite_widgets_source_list_get_editing (GraniteWidgetsSourceList* self) {
	gboolean result;
	GraniteWidgetsSourceListTree* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_editing (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


GtkSortType granite_widgets_source_list_get_sort_direction (GraniteWidgetsSourceList* self) {
	GtkSortType result;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GtkSortType _tmp2_;
	GtkSortType _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = granite_widgets_source_list_data_model_get_sort_direction (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}


void granite_widgets_source_list_set_sort_direction (GraniteWidgetsSourceList* self, GtkSortType value) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GtkSortType _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_get_data_model (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = value;
	granite_widgets_source_list_data_model_set_sort_direction (_tmp1_, _tmp2_);
	g_object_notify ((GObject *) self, "sort-direction");
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_get_data_model (GraniteWidgetsSourceList* self) {
	GraniteWidgetsSourceListDataModel* result;
	GraniteWidgetsSourceListTree* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tree;
	_tmp1_ = granite_widgets_source_list_tree_get_data_model (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void granite_widgets_source_list_real_item_selected (GraniteWidgetsSourceList* self, GraniteWidgetsSourceListItem* item) {
}


/**
         * Creates a new {@link Granite.Widgets.SourceList.Item}.
         *
         * @param name Name of the item.
         * @return (transfer full) A new {@link Granite.Widgets.SourceList.Item}.
         * @since 0.2
         */
GraniteWidgetsSourceListItem* granite_widgets_source_list_item_construct (GType object_type, const gchar* name) {
	GraniteWidgetsSourceListItem * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (GraniteWidgetsSourceListItem*) g_object_new (object_type, NULL);
	_tmp0_ = name;
	granite_widgets_source_list_item_set_name (self, _tmp0_);
	return self;
}


GraniteWidgetsSourceListItem* granite_widgets_source_list_item_new (const gchar* name) {
	return granite_widgets_source_list_item_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, name);
}


/**
         * Invoked when the item is secondary-clicked or when the usual menu keys are pressed.
         *
         * @return A {@link Gtk.Menu} or //null// if nothing should be displayed.
         * @since 0.2
         */
static GtkMenu* granite_widgets_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* self) {
	GtkMenu* result = NULL;
	result = NULL;
	return result;
}


GtkMenu* granite_widgets_source_list_item_get_context_menu (GraniteWidgetsSourceListItem* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_CLASS (self)->get_context_menu (self);
}


GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_item_get_parent (GraniteWidgetsSourceListItem* self) {
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_parent (GraniteWidgetsSourceListItem* self, GraniteWidgetsSourceListExpandableItem* value) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_parent);
	self->priv->_parent = _tmp1_;
	g_object_notify ((GObject *) self, "parent");
}


const gchar* granite_widgets_source_list_item_get_name (GraniteWidgetsSourceListItem* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_name (GraniteWidgetsSourceListItem* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


const gchar* granite_widgets_source_list_item_get_badge (GraniteWidgetsSourceListItem* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_badge;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_badge (GraniteWidgetsSourceListItem* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_badge);
	self->priv->_badge = _tmp1_;
	g_object_notify ((GObject *) self, "badge");
}


gboolean granite_widgets_source_list_item_get_editable (GraniteWidgetsSourceListItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_editable;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_editable (GraniteWidgetsSourceListItem* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_editable = _tmp0_;
	g_object_notify ((GObject *) self, "editable");
}


gboolean granite_widgets_source_list_item_get_visible (GraniteWidgetsSourceListItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_visible;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_visible (GraniteWidgetsSourceListItem* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_visible = _tmp0_;
	g_object_notify ((GObject *) self, "visible");
}


gboolean granite_widgets_source_list_item_get_selectable (GraniteWidgetsSourceListItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_selectable;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_selectable (GraniteWidgetsSourceListItem* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_selectable = _tmp0_;
	g_object_notify ((GObject *) self, "selectable");
}


GIcon* granite_widgets_source_list_item_get_icon (GraniteWidgetsSourceListItem* self) {
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_icon (GraniteWidgetsSourceListItem* self, GIcon* value) {
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_icon);
	self->priv->_icon = _tmp1_;
	g_object_notify ((GObject *) self, "icon");
}


GIcon* granite_widgets_source_list_item_get_activatable (GraniteWidgetsSourceListItem* self) {
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_activatable;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_item_set_activatable (GraniteWidgetsSourceListItem* self, GIcon* value) {
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_activatable);
	self->priv->_activatable = _tmp1_;
	g_object_notify ((GObject *) self, "activatable");
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void granite_widgets_source_list_item_real_edited (GraniteWidgetsSourceListItem* self, const gchar* new_name) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp5_;
	g_return_if_fail (new_name != NULL);
	_tmp1_ = self->priv->_editable;
	if (_tmp1_) {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp2_ = new_name;
		_tmp3_ = string_strip (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 (_tmp4_, "") != 0;
		_g_free0 (_tmp4_);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp5_ = _tmp0_;
	if (_tmp5_) {
		const gchar* _tmp6_;
		_tmp6_ = new_name;
		granite_widgets_source_list_item_set_name (self, _tmp6_);
	}
}


static void granite_widgets_source_list_item_real_action_activated (GraniteWidgetsSourceListItem* self) {
}


static void granite_widgets_source_list_item_real_activated (GraniteWidgetsSourceListItem* self) {
}


static void granite_widgets_source_list_item_class_init (GraniteWidgetsSourceListItemClass * klass) {
	granite_widgets_source_list_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListItemPrivate));
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS (klass)->get_context_menu = granite_widgets_source_list_item_real_get_context_menu;
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS (klass)->edited = granite_widgets_source_list_item_real_edited;
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS (klass)->action_activated = granite_widgets_source_list_item_real_action_activated;
	GRANITE_WIDGETS_SOURCE_LIST_ITEM_CLASS (klass)->activated = granite_widgets_source_list_item_real_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_item_finalize;
	/**
	         * Parent {@link Granite.Widgets.SourceList.ExpandableItem} of the item.
	         * ''Must not'' be modified.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT, g_param_spec_object ("parent", "parent", "parent", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * The item's name. Primary and most important information.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * A badge shown next to the item's name.
	         *
	         * It can be used for displaying the number of unread messages in the "Inbox" item,
	         * for instance.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE, g_param_spec_string ("badge", "badge", "badge", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether the item's name can be edited from within the source list.
	         *
	         * When this property is set to //true//, users can edit the item by pressing
	         * the F2 key, or by double-clicking its name.
	         *
	         * ''This property only works for selectable items''.
	         *
	         * @see Granite.Widgets.SourceList.Item.selectable
	         * @see Granite.Widgets.SourceList.start_editing_item
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE, g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether the item should appear in the source list's tree or not.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE, g_param_spec_boolean ("visible", "visible", "visible", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Whether the item can be selected or not.
	         *
	         * Setting this property to true doesn't guarantee that the item will actually be
	         * selectable, since there are other external factors to take into account, like the
	         * item's {@link Granite.Widgets.SourceList.Item.visible} property; whether the item is
	         * a category; the parent item is collapsed, etc.
	         *
	         * @see Granite.Widgets.SourceList.Item.visible
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE, g_param_spec_boolean ("selectable", "selectable", "selectable", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Primary icon.
	         *
	         * This property should be used to give the user an idea of what the item represents
	         * (i.e. content type.)
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON, g_param_spec_object ("icon", "icon", "icon", G_TYPE_ICON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * An activatable icon that works like a button.
	         *
	         * It can be used for e.g. showing an //"eject"// icon on a device's item.
	         *
	         * @see Granite.Widgets.SourceList.Item.action_activated
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE, g_param_spec_object ("activatable", "activatable", "activatable", G_TYPE_ICON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Emitted when the user has finished editing the item's name.
	         *
	         * By default, if the name doesn't consist of white space, it is automatically assigned
	         * to the {@link Granite.Widgets.SourceList.Item.name} property. The default behavior can
	         * be changed by overriding this signal.
	         * @param new_name The item's new name (result of editing.)
	         * @since 0.2
	         */
	g_signal_new ("edited", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, edited), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	/**
	         * The {@link Granite.Widgets.SourceList.Item.activatable} icon was activated.
	         *
	         * @see Granite.Widgets.SourceList.Item.activatable
	         * @since 0.2
	         */
	g_signal_new ("action_activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, action_activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	         * Emitted when the item is double-clicked or when it is selected and one of the keys:
	         * Space, Shift+Space, Return or Enter is pressed. This signal is //also// for
	         * editable items.
	         *
	         * @since 0.2
	         */
	g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListItemClass, activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_widgets_source_list_item_instance_init (GraniteWidgetsSourceListItem * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_ITEM_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("");
	self->priv->_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->_badge = _tmp1_;
	self->priv->_editable = FALSE;
	self->priv->_visible = TRUE;
	self->priv->_selectable = TRUE;
}


static void granite_widgets_source_list_item_finalize (GObject* obj) {
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
	_g_object_unref0 (self->priv->_parent);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_badge);
	_g_object_unref0 (self->priv->_icon);
	_g_object_unref0 (self->priv->_activatable);
	G_OBJECT_CLASS (granite_widgets_source_list_item_parent_class)->finalize (obj);
}


/**
     * A source list entry.
     *
     * Any change made to any of its properties will be ''automatically'' reflected
     * by the {@link Granite.Widgets.SourceList} widget.
     *
     * @since 0.2
     */
GType granite_widgets_source_list_item_get_type (void) {
	static volatile gsize granite_widgets_source_list_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListItem), 0, (GInstanceInitFunc) granite_widgets_source_list_item_instance_init, NULL };
		GType granite_widgets_source_list_item_type_id;
		granite_widgets_source_list_item_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteWidgetsSourceListItem", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_item_type_id__volatile, granite_widgets_source_list_item_type_id);
	}
	return granite_widgets_source_list_item_type_id__volatile;
}


static void _vala_granite_widgets_source_list_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT:
		g_value_set_object (value, granite_widgets_source_list_item_get_parent (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME:
		g_value_set_string (value, granite_widgets_source_list_item_get_name (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE:
		g_value_set_string (value, granite_widgets_source_list_item_get_badge (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE:
		g_value_set_boolean (value, granite_widgets_source_list_item_get_editable (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE:
		g_value_set_boolean (value, granite_widgets_source_list_item_get_visible (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE:
		g_value_set_boolean (value, granite_widgets_source_list_item_get_selectable (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON:
		g_value_set_object (value, granite_widgets_source_list_item_get_icon (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE:
		g_value_set_object (value, granite_widgets_source_list_item_get_activatable (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, GraniteWidgetsSourceListItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_PARENT:
		granite_widgets_source_list_item_set_parent (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_NAME:
		granite_widgets_source_list_item_set_name (self, g_value_get_string (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_BADGE:
		granite_widgets_source_list_item_set_badge (self, g_value_get_string (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_EDITABLE:
		granite_widgets_source_list_item_set_editable (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_VISIBLE:
		granite_widgets_source_list_item_set_visible (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_SELECTABLE:
		granite_widgets_source_list_item_set_selectable (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ICON:
		granite_widgets_source_list_item_set_icon (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ITEM_ACTIVATABLE:
		granite_widgets_source_list_item_set_activatable (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


/**
         * Creates a new {@link Granite.Widgets.SourceList.ExpandableItem}
         *
         * @param name Title of the item.
         * @return (transfer full) A new {@link Granite.Widgets.SourceList.ExpandableItem}.
         * @since 0.2
         */
GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_construct (GType object_type, const gchar* name) {
	GraniteWidgetsSourceListExpandableItem * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	self = (GraniteWidgetsSourceListExpandableItem*) granite_widgets_source_list_item_construct (object_type, _tmp0_);
	granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) self, FALSE);
	return self;
}


GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_expandable_item_new (const gchar* name) {
	return granite_widgets_source_list_expandable_item_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, name);
}


/**
         * Checks whether the item contains the specified child.
         *
         * This method only considers the item's immediate children.
         *
         * @param item Item to search.
         * @return Whether the item was found or not.
         * @since 0.2
         */
gboolean granite_widgets_source_list_expandable_item_contains (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GeeSet* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = self->priv->children_set;
	_tmp1_ = item;
	_tmp2_ = gee_collection_contains ((GeeCollection*) _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


/**
         * Adds an item.
         *
         * {@link Granite.Widgets.SourceList.ExpandableItem.child_added} is fired after the item is added.
         *
         * While adding a child item, //the item it's being added to will set itself as the parent//.
         * Please note that items are required to have their //parent// property set to //null// before
         * being added, so make sure you remove the item from its previous parent before attempting
         * to add it to another item. For instance:
         * {{{
         * if (item.parent != null)
         *     item.parent.remove (item); // this will set item's parent to null
         * new_parent.add (item);
         * }}}
         *
         * @param item The item to add. Its parent __must__ be //null//.
         * @see Granite.Widgets.SourceList.ExpandableItem.child_added
         * @see Granite.Widgets.SourceList.ExpandableItem.remove
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_add (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp5_;
	GeeSet* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsSourceListItem* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_item_get_parent (_tmp0_);
	_tmp2_ = _tmp1_;
	g_return_if_fail (_tmp2_ == NULL);
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_expandable_item_contains (self, _tmp3_);
	g_return_if_fail (!_tmp4_);
	_tmp5_ = item;
	granite_widgets_source_list_item_set_parent (_tmp5_, self);
	_tmp6_ = self->priv->children_set;
	_tmp7_ = item;
	gee_collection_add ((GeeCollection*) _tmp6_, _tmp7_);
	_tmp8_ = item;
	g_signal_emit_by_name (self, "child-added", _tmp8_);
}


/**
         * Removes an item.
         *
         * The {@link Granite.Widgets.SourceList.ExpandableItem.child_removed} signal is fired
         * //after removing the item//. Finally (i.e. after all the handlers have been invoked),
         * the item's {@link Granite.Widgets.SourceList.Item.parent} property is set to //null//.
         * This has the advantage of letting signal handlers know the parent from which //item//
         * is being removed.
         *
         * @param item The item to remove. This will fail if item has a different parent.
         * @see Granite.Widgets.SourceList.ExpandableItem.child_removed
         * @see Granite.Widgets.SourceList.ExpandableItem.clear
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_remove (GraniteWidgetsSourceListExpandableItem* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GeeSet* _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsSourceListItem* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_item_get_parent (_tmp0_);
	_tmp2_ = _tmp1_;
	g_return_if_fail (_tmp2_ == self);
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_expandable_item_contains (self, _tmp3_);
	g_return_if_fail (_tmp4_);
	_tmp5_ = self->priv->children_set;
	_tmp6_ = item;
	gee_collection_remove ((GeeCollection*) _tmp5_, _tmp6_);
	_tmp7_ = item;
	g_signal_emit_by_name (self, "child-removed", _tmp7_);
	_tmp8_ = item;
	granite_widgets_source_list_item_set_parent (_tmp8_, NULL);
}


/**
         * Removes all the items contained by the item. It works similarly to
         * {@link Granite.Widgets.SourceList.ExpandableItem.remove}.
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.remove
         * @see Granite.Widgets.SourceList.ExpandableItem.child_removed
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_clear (GraniteWidgetsSourceListExpandableItem* self) {
	g_return_if_fail (self != NULL);
	{
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _item_it;
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_item_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			GraniteWidgetsSourceListItem* item;
			GraniteWidgetsSourceListItem* _tmp9_;
			_tmp5_ = _item_it;
			_tmp6_ = gee_iterator_next (_tmp5_);
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = _item_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			item = (GraniteWidgetsSourceListItem*) _tmp8_;
			_tmp9_ = item;
			granite_widgets_source_list_expandable_item_remove (self, _tmp9_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_it);
	}
}


/**
         * Expands the item and/or its children.
         *
         * @param inclusive Whether to also expand this item (true), or only its children (false).
         * @param recursive Whether to recursively expand all the children (true), or only
         * immediate children (false).
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_expand_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = inclusive;
	_tmp1_ = recursive;
	granite_widgets_source_list_expandable_item_set_expansion (self, _tmp0_, _tmp1_, TRUE);
}


/**
         * Collapses the item and/or its children.
         *
         * @param inclusive Whether to also collapse this item (true), or only its children (false).
         * @param recursive Whether to recursively collapse all the children (true), or only
         * immediate children (false). The latter case might appear contradictory, given that collapsing
         * immediate children will also //visually// collapse non-immediate children, but it makes total
         * sense once you've understood what the {@link Granite.Widgets.SourceList.ExpandableItem.expanded}
         * property actually means. If you set //recursive// to //true,// the non-immediate children's
         * //expanded// property will be set to //false//, and therefore they will __stay collapsed__
         * the next time their parents are expanded; otherwise (i.e. if //recursive// is //false//),
         * __their previous expansion state will be restored__ once their parents are expanded again.
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_collapse_all (GraniteWidgetsSourceListExpandableItem* self, gboolean inclusive, gboolean recursive) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = inclusive;
	_tmp1_ = recursive;
	granite_widgets_source_list_expandable_item_set_expansion (self, _tmp0_, _tmp1_, FALSE);
}


static void granite_widgets_source_list_expandable_item_set_expansion (GraniteWidgetsSourceListExpandableItem* item, gboolean inclusive, gboolean recursive, gboolean expanded) {
	gboolean _tmp0_;
	g_return_if_fail (item != NULL);
	_tmp0_ = inclusive;
	if (_tmp0_) {
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = item;
		_tmp2_ = expanded;
		granite_widgets_source_list_expandable_item_set_expanded (_tmp1_, _tmp2_);
	}
	{
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_;
		GeeIterator* _child_item_it;
		_tmp3_ = item;
		_tmp4_ = granite_widgets_source_list_expandable_item_get_children (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_child_item_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeIterator* _tmp11_;
			gpointer _tmp12_ = NULL;
			GraniteWidgetsSourceListItem* child_item;
			GraniteWidgetsSourceListItem* _tmp13_;
			GraniteWidgetsSourceListExpandableItem* _tmp14_;
			GraniteWidgetsSourceListExpandableItem* child_expandable_item;
			GraniteWidgetsSourceListExpandableItem* _tmp15_;
			_tmp9_ = _child_item_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _child_item_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			child_item = (GraniteWidgetsSourceListItem*) _tmp12_;
			_tmp13_ = child_item;
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp13_) : NULL);
			child_expandable_item = _tmp14_;
			_tmp15_ = child_expandable_item;
			if (_tmp15_ != NULL) {
				gboolean _tmp16_;
				_tmp16_ = recursive;
				if (_tmp16_) {
					GraniteWidgetsSourceListExpandableItem* _tmp17_;
					gboolean _tmp18_;
					_tmp17_ = child_expandable_item;
					_tmp18_ = expanded;
					granite_widgets_source_list_expandable_item_set_expansion (_tmp17_, TRUE, TRUE, _tmp18_);
				} else {
					GraniteWidgetsSourceListExpandableItem* _tmp19_;
					gboolean _tmp20_;
					_tmp19_ = child_expandable_item;
					_tmp20_ = expanded;
					granite_widgets_source_list_expandable_item_set_expanded (_tmp19_, _tmp20_);
				}
			}
			_g_object_unref0 (child_expandable_item);
			_g_object_unref0 (child_item);
		}
		_g_object_unref0 (_child_item_it);
	}
}


/**
         * Recursively expands the item along with its parent(s).
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_expand_with_parents (GraniteWidgetsSourceListExpandableItem* self) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		_tmp2_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
		_tmp3_ = _tmp2_;
		granite_widgets_source_list_expandable_item_expand_with_parents (_tmp3_);
	}
	granite_widgets_source_list_expandable_item_set_expanded (self, TRUE);
}


/**
         * Recursively collapses the item along with its parent(s).
         *
         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
         * @since 0.2
         */
void granite_widgets_source_list_expandable_item_collapse_with_parents (GraniteWidgetsSourceListExpandableItem* self) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		_tmp2_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) self);
		_tmp3_ = _tmp2_;
		granite_widgets_source_list_expandable_item_collapse_with_parents (_tmp3_);
	}
	granite_widgets_source_list_expandable_item_set_expanded (self, FALSE);
}


gboolean granite_widgets_source_list_expandable_item_get_collapsible (GraniteWidgetsSourceListExpandableItem* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_collapsible;
	result = _tmp0_;
	return result;
}


void granite_widgets_source_list_expandable_item_set_collapsible (GraniteWidgetsSourceListExpandableItem* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_collapsible = _tmp0_;
	g_object_notify ((GObject *) self, "collapsible");
}


gboolean granite_widgets_source_list_expandable_item_get_expanded (GraniteWidgetsSourceListExpandableItem* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->_expanded;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_collapsible;
		_tmp0_ = !_tmp2_;
	}
	_tmp3_ = _tmp0_;
	result = _tmp3_;
	return result;
}


void granite_widgets_source_list_expandable_item_set_expanded (GraniteWidgetsSourceListExpandableItem* self, gboolean value) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = self->priv->_expanded;
	if (_tmp0_ != _tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = value;
		self->priv->_expanded = _tmp2_;
		g_signal_emit_by_name (self, "toggled");
	}
	g_object_notify ((GObject *) self, "expanded");
}


guint granite_widgets_source_list_expandable_item_get_n_children (GraniteWidgetsSourceListExpandableItem* self) {
	guint result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->children_set;
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (guint) _tmp2_;
	return result;
}


GeeCollection* granite_widgets_source_list_expandable_item_get_children (GraniteWidgetsSourceListExpandableItem* self) {
	GeeCollection* result;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* copy;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_linked_list_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	copy = _tmp0_;
	{
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _item_it;
		_tmp1_ = self->priv->children_set;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_item_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			GraniteWidgetsSourceListItem* item;
			GeeLinkedList* _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
			_tmp3_ = _item_it;
			_tmp4_ = gee_iterator_next (_tmp3_);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = _item_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			item = (GraniteWidgetsSourceListItem*) _tmp6_;
			_tmp7_ = copy;
			_tmp8_ = item;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_it);
	}
	result = (GeeCollection*) copy;
	return result;
}


static void granite_widgets_source_list_expandable_item_real_toggled (GraniteWidgetsSourceListExpandableItem* self) {
}


static void granite_widgets_source_list_expandable_item_class_init (GraniteWidgetsSourceListExpandableItemClass * klass) {
	granite_widgets_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListExpandableItemPrivate));
	GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS (klass)->toggled = granite_widgets_source_list_expandable_item_real_toggled;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_expandable_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_expandable_item_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_expandable_item_finalize;
	/**
	         * Whether the item is collapsible or not.
	         *
	         * When set to //false//, the item is //always// expanded and the expander is
	         * not shown. Please note that this will also affect the value returned by the
	         * {@link Granite.Widgets.SourceList.ExpandableItem.expanded} property.
	         *
	         * @see Granite.Widgets.SourceList.ExpandableItem.expanded
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE, g_param_spec_boolean ("collapsible", "collapsible", "collapsible", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED, g_param_spec_boolean ("expanded", "expanded", "expanded", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Number of children contained by the item.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN, g_param_spec_uint ("n-children", "n-children", "n-children", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	         * The item's children.
	         *
	         * @since 0.2
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN, g_param_spec_object ("children", "children", "children", GEE_TYPE_COLLECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	         * Emitted when an item is added.
	         *
	         * @param item Item added.
	         * @see Granite.Widgets.SourceList.ExpandableItem.add
	         * @since 0.2
	         */
	g_signal_new ("child_added", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	/**
	         * Emitted when an item is removed.
	         *
	         * @param item Item removed.
	         * @see Granite.Widgets.SourceList.ExpandableItem.remove
	         * @since 0.2
	         */
	g_signal_new ("child_removed", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	/**
	         * Emitted when the item is expanded or collapsed.
	         *
	         * @since 0.2
	         */
	g_signal_new ("toggled", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListExpandableItemClass, toggled), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void granite_widgets_source_list_expandable_item_instance_init (GraniteWidgetsSourceListExpandableItem * self) {
	GeeHashSet* _tmp0_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_GET_PRIVATE (self);
	self->priv->_collapsible = TRUE;
	self->priv->_expanded = FALSE;
	_tmp0_ = gee_hash_set_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->children_set = (GeeSet*) _tmp0_;
}


static void granite_widgets_source_list_expandable_item_finalize (GObject* obj) {
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
	_g_object_unref0 (self->priv->children_set);
	G_OBJECT_CLASS (granite_widgets_source_list_expandable_item_parent_class)->finalize (obj);
}


/**
     * An item that can contain more items.
     *
     * It supports all the properties inherited from {@link Granite.Widgets.SourceList.Item},
     * and behaves like a normal item, except when it is located at the root level; in that case,
     * the following properties are ignored by the widget:
     *
     * * {@link Granite.Widgets.SourceList.Item.selectable}
     * * {@link Granite.Widgets.SourceList.Item.editable}
     * * {@link Granite.Widgets.SourceList.Item.icon}
     * * {@link Granite.Widgets.SourceList.Item.activatable}
     * * {@link Granite.Widgets.SourceList.Item.badge}
     *
     * Root-level expandable items (i.e. Main Categories) are ''not'' displayed when they contain
     * zero visible children.
     *
     * @since 0.2
     */
GType granite_widgets_source_list_expandable_item_get_type (void) {
	static volatile gsize granite_widgets_source_list_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListExpandableItem), 0, (GInstanceInitFunc) granite_widgets_source_list_expandable_item_instance_init, NULL };
		GType granite_widgets_source_list_expandable_item_type_id;
		granite_widgets_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "GraniteWidgetsSourceListExpandableItem", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_expandable_item_type_id__volatile, granite_widgets_source_list_expandable_item_type_id);
	}
	return granite_widgets_source_list_expandable_item_type_id__volatile;
}


static void _vala_granite_widgets_source_list_expandable_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE:
		g_value_set_boolean (value, granite_widgets_source_list_expandable_item_get_collapsible (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED:
		g_value_set_boolean (value, granite_widgets_source_list_expandable_item_get_expanded (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_N_CHILDREN:
		g_value_set_uint (value, granite_widgets_source_list_expandable_item_get_n_children (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_CHILDREN:
		g_value_take_object (value, granite_widgets_source_list_expandable_item_get_children (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_expandable_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_COLLAPSIBLE:
		granite_widgets_source_list_expandable_item_set_collapsible (self, g_value_get_boolean (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EXPANDABLE_ITEM_EXPANDED:
		granite_widgets_source_list_expandable_item_set_expanded (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static GType granite_widgets_source_list_data_model_column_type (GraniteWidgetsSourceListDataModelColumn self) {
	GType result = 0UL;
	switch (self) {
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM:
		{
			result = GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


static GType granite_widgets_source_list_data_model_column_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_data_model_column_type_id;
		granite_widgets_source_list_data_model_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListDataModelColumn", values);
		g_once_init_leave (&granite_widgets_source_list_data_model_column_type_id__volatile, granite_widgets_source_list_data_model_column_type_id);
	}
	return granite_widgets_source_list_data_model_column_type_id__volatile;
}


static GType granite_widgets_source_list_data_model_sort_column_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_sort_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_sort_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_UNSORTED, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_UNSORTED", "unsorted"}, {GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_SORTED, "GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_SORTED", "sorted"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_data_model_sort_column_type_id;
		granite_widgets_source_list_data_model_sort_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListDataModelSortColumn", values);
		g_once_init_leave (&granite_widgets_source_list_data_model_sort_column_type_id__volatile, granite_widgets_source_list_data_model_sort_column_type_id);
	}
	return granite_widgets_source_list_data_model_sort_column_type_id__volatile;
}


static gboolean _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self) {
	gboolean result;
	result = granite_widgets_source_list_data_model_filter_visible_func (self, model, iter);
	return result;
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_construct (GType object_type) {
	GraniteWidgetsSourceListDataModel * self = NULL;
	GType _tmp0_ = 0UL;
	GtkTreeStore* _tmp1_;
	GtkTreeStore* child_tree;
	GtkTreeStore* _tmp2_;
	_tmp0_ = granite_widgets_source_list_data_model_column_type (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM);
	_tmp1_ = gtk_tree_store_new ((gint) GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_N_COLUMNS, _tmp0_);
	child_tree = _tmp1_;
	self = (GraniteWidgetsSourceListDataModel*) g_object_new (object_type, "child-model", child_tree, "virtual-root", NULL, NULL);
	_tmp2_ = _g_object_ref0 (child_tree);
	_g_object_unref0 (self->priv->child_tree);
	self->priv->child_tree = _tmp2_;
	gtk_tree_model_filter_set_visible_func ((GtkTreeModelFilter*) self, _granite_widgets_source_list_data_model_filter_visible_func_gtk_tree_model_filter_visible_func, g_object_ref (self), g_object_unref);
	_g_object_unref0 (child_tree);
	return self;
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_data_model_new (void) {
	return granite_widgets_source_list_data_model_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL);
}


static gboolean granite_widgets_source_list_data_model_has_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = self->priv->items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


static void granite_widgets_source_list_data_model_update_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GeeHashMap* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	gpointer _tmp6_ = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* node_reference;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_has_item (self, _tmp0_);
	g_return_if_fail (_tmp1_);
	_tmp2_ = granite_widgets_source_list_data_model_get_root (self);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ != NULL, "root != null");
	_tmp4_ = self->priv->items;
	_tmp5_ = item;
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
	node_reference = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp6_;
	_tmp7_ = node_reference;
	if (_tmp7_ != NULL) {
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreePath* _tmp10_;
		GtkTreePath* path;
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp11_;
		GtkTreeIter* _tmp12_;
		GtkTreeIter* _tmp13_;
		GtkTreeIter* iter;
		gboolean _tmp14_ = FALSE;
		GtkTreePath* _tmp15_;
		gboolean _tmp17_;
		_tmp8_ = node_reference;
		_tmp9_ = granite_widgets_source_list_data_model_node_wrapper_get_path (_tmp8_);
		_tmp10_ = _tmp9_;
		path = _tmp10_;
		_tmp11_ = node_reference;
		_tmp12_ = granite_widgets_source_list_data_model_node_wrapper_get_iter (_tmp11_);
		_tmp13_ = _tmp12_;
		iter = _tmp13_;
		_tmp15_ = path;
		if (_tmp15_ != NULL) {
			GtkTreeIter* _tmp16_;
			_tmp16_ = iter;
			_tmp14_ = _tmp16_ != NULL;
		} else {
			_tmp14_ = FALSE;
		}
		_tmp17_ = _tmp14_;
		if (_tmp17_) {
			GtkTreeStore* _tmp18_;
			GtkTreePath* _tmp19_;
			GtkTreeIter* _tmp20_;
			GtkTreeIter _tmp21_;
			GraniteWidgetsSourceListItem* _tmp22_;
			_tmp18_ = self->priv->child_tree;
			_tmp19_ = path;
			_tmp20_ = iter;
			_tmp21_ = *_tmp20_;
			gtk_tree_model_row_changed ((GtkTreeModel*) _tmp18_, _tmp19_, &_tmp21_);
			_tmp22_ = item;
			g_signal_emit_by_name (self, "item-updated", _tmp22_);
		}
		_g_free0 (iter);
		_gtk_tree_path_free0 (path);
	}
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (node_reference);
}


static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self) {
	GtkTreeIter* dup;
	dup = g_new0 (GtkTreeIter, 1);
	memcpy (dup, self, sizeof (GtkTreeIter));
	return dup;
}


static gpointer __gtk_tree_iter_dup0 (gpointer self) {
	return self ? _gtk_tree_iter_dup (self) : NULL;
}


static void granite_widgets_source_list_data_model_add_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GtkTreeIter* parent_child_iter;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListExpandableItem* _tmp5_;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* parent;
	gboolean _tmp8_ = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	gboolean _tmp13_;
	GtkTreeStore* _tmp20_;
	GtkTreeIter* _tmp21_;
	GtkTreeIter _tmp22_ = {0};
	GtkTreeIter _tmp23_;
	GtkTreeIter* _tmp24_;
	GtkTreeStore* _tmp25_;
	GtkTreeIter* _tmp26_;
	GraniteWidgetsSourceListItem* _tmp27_;
	GtkTreeIter _tmp28_;
	GeeHashMap* _tmp29_;
	GraniteWidgetsSourceListItem* _tmp30_;
	GtkTreeStore* _tmp31_;
	GtkTreeIter* _tmp32_;
	GtkTreeIter _tmp33_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp34_;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp35_;
	GraniteWidgetsSourceListItem* _tmp36_;
	GraniteWidgetsSourceListItem* _tmp37_;
	GraniteWidgetsSourceListExpandableItem* _tmp38_;
	GraniteWidgetsSourceListItem* _tmp39_;
	GraniteWidgetsSourceListExpandableItem* _tmp40_;
	GraniteWidgetsSourceListExpandableItem* expandable;
	GraniteWidgetsSourceListExpandableItem* _tmp41_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_has_item (self, _tmp0_);
	g_return_if_fail (!_tmp1_);
	_tmp2_ = granite_widgets_source_list_data_model_get_root (self);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ != NULL, "root != null");
	parent_child_iter = NULL;
	_tmp4_ = item;
	_tmp5_ = granite_widgets_source_list_item_get_parent (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _g_object_ref0 (_tmp6_);
	parent = _tmp7_;
	_tmp9_ = parent;
	if (_tmp9_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp10_;
		GraniteWidgetsSourceListExpandableItem* _tmp11_;
		GraniteWidgetsSourceListExpandableItem* _tmp12_;
		_tmp10_ = parent;
		_tmp11_ = granite_widgets_source_list_data_model_get_root (self);
		_tmp12_ = _tmp11_;
		_tmp8_ = _tmp10_ != _tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp13_ = _tmp8_;
	if (_tmp13_) {
		GraniteWidgetsSourceListExpandableItem* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GraniteWidgetsSourceListExpandableItem* _tmp17_;
		GtkTreeIter* _tmp18_ = NULL;
		GtkTreeIter* _tmp19_;
		_tmp14_ = parent;
		_tmp15_ = granite_widgets_source_list_data_model_has_item (self, (GraniteWidgetsSourceListItem*) _tmp14_);
		if (!_tmp15_) {
			GraniteWidgetsSourceListExpandableItem* _tmp16_;
			_tmp16_ = parent;
			granite_widgets_source_list_data_model_add_item (self, (GraniteWidgetsSourceListItem*) _tmp16_);
		}
		_tmp17_ = parent;
		_tmp18_ = granite_widgets_source_list_data_model_get_item_child_iter (self, (GraniteWidgetsSourceListItem*) _tmp17_);
		_g_free0 (parent_child_iter);
		parent_child_iter = _tmp18_;
		_tmp19_ = parent_child_iter;
		_vala_assert (_tmp19_ != NULL, "parent_child_iter != null");
	}
	_tmp20_ = self->priv->child_tree;
	_tmp21_ = parent_child_iter;
	gtk_tree_store_append (_tmp20_, &_tmp22_, _tmp21_);
	_g_free0 (child_iter);
	_tmp23_ = _tmp22_;
	_tmp24_ = __gtk_tree_iter_dup0 (&_tmp23_);
	child_iter = _tmp24_;
	_tmp25_ = self->priv->child_tree;
	_tmp26_ = child_iter;
	_tmp27_ = item;
	_tmp28_ = *_tmp26_;
	gtk_tree_store_set (_tmp25_, &_tmp28_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, _tmp27_, -1, -1);
	_tmp29_ = self->priv->items;
	_tmp30_ = item;
	_tmp31_ = self->priv->child_tree;
	_tmp32_ = child_iter;
	_tmp33_ = *_tmp32_;
	_tmp34_ = granite_widgets_source_list_data_model_node_wrapper_new ((GtkTreeModel*) _tmp31_, &_tmp33_);
	_tmp35_ = _tmp34_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp30_, _tmp35_);
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (_tmp35_);
	_tmp36_ = item;
	g_signal_emit_by_name (self, "item-updated", _tmp36_);
	_tmp37_ = item;
	granite_widgets_source_list_data_model_add_property_monitor (self, _tmp37_);
	_tmp38_ = parent;
	granite_widgets_source_list_data_model_push_parent_update (self, _tmp38_);
	_tmp39_ = item;
	_tmp40_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp39_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp39_) : NULL);
	expandable = _tmp40_;
	_tmp41_ = expandable;
	if (_tmp41_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp53_;
		{
			GraniteWidgetsSourceListExpandableItem* _tmp42_;
			GeeCollection* _tmp43_;
			GeeCollection* _tmp44_;
			GeeCollection* _tmp45_;
			GeeIterator* _tmp46_ = NULL;
			GeeIterator* _tmp47_;
			GeeIterator* _child_item_it;
			_tmp42_ = expandable;
			_tmp43_ = granite_widgets_source_list_expandable_item_get_children (_tmp42_);
			_tmp44_ = _tmp43_;
			_tmp45_ = _tmp44_;
			_tmp46_ = gee_iterable_iterator ((GeeIterable*) _tmp45_);
			_tmp47_ = _tmp46_;
			_g_object_unref0 (_tmp45_);
			_child_item_it = _tmp47_;
			while (TRUE) {
				GeeIterator* _tmp48_;
				gboolean _tmp49_ = FALSE;
				GeeIterator* _tmp50_;
				gpointer _tmp51_ = NULL;
				GraniteWidgetsSourceListItem* child_item;
				GraniteWidgetsSourceListItem* _tmp52_;
				_tmp48_ = _child_item_it;
				_tmp49_ = gee_iterator_next (_tmp48_);
				if (!_tmp49_) {
					break;
				}
				_tmp50_ = _child_item_it;
				_tmp51_ = gee_iterator_get (_tmp50_);
				child_item = (GraniteWidgetsSourceListItem*) _tmp51_;
				_tmp52_ = child_item;
				granite_widgets_source_list_data_model_add_item (self, _tmp52_);
				_g_object_unref0 (child_item);
			}
			_g_object_unref0 (_child_item_it);
		}
		_tmp53_ = expandable;
		granite_widgets_source_list_data_model_add_children_monitor (self, _tmp53_);
	}
	_g_object_unref0 (expandable);
	_g_object_unref0 (parent);
	_g_free0 (child_iter);
	_g_free0 (parent_child_iter);
}


static void granite_widgets_source_list_data_model_remove_item (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListItem* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	GtkTreeIter* _tmp6_ = NULL;
	GtkTreeIter* child_iter;
	GeeHashMap* _tmp7_;
	GraniteWidgetsSourceListItem* _tmp8_;
	GtkTreeIter* _tmp9_;
	GraniteWidgetsSourceListItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* expandable;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_has_item (self, _tmp0_);
	g_return_if_fail (_tmp1_);
	_tmp2_ = granite_widgets_source_list_data_model_get_root (self);
	_tmp3_ = _tmp2_;
	_vala_assert (_tmp3_ != NULL, "root != null");
	_tmp4_ = item;
	granite_widgets_source_list_data_model_remove_property_monitor (self, _tmp4_);
	_tmp5_ = item;
	_tmp6_ = granite_widgets_source_list_data_model_get_item_child_iter (self, _tmp5_);
	child_iter = _tmp6_;
	_tmp7_ = self->priv->items;
	_tmp8_ = item;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp8_, NULL);
	_tmp9_ = child_iter;
	if (_tmp9_ != NULL) {
		GtkTreeStore* _tmp10_;
		_tmp10_ = self->priv->child_tree;
		gtk_tree_store_remove (_tmp10_, child_iter);
	}
	_tmp11_ = item;
	_tmp12_ = granite_widgets_source_list_item_get_parent (_tmp11_);
	_tmp13_ = _tmp12_;
	granite_widgets_source_list_data_model_push_parent_update (self, _tmp13_);
	_tmp14_ = item;
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp14_) : NULL);
	expandable = _tmp15_;
	_tmp16_ = expandable;
	if (_tmp16_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp17_;
		_tmp17_ = expandable;
		granite_widgets_source_list_data_model_remove_children_monitor (self, _tmp17_);
		{
			GraniteWidgetsSourceListExpandableItem* _tmp18_;
			GeeCollection* _tmp19_;
			GeeCollection* _tmp20_;
			GeeCollection* _tmp21_;
			GeeIterator* _tmp22_ = NULL;
			GeeIterator* _tmp23_;
			GeeIterator* _child_item_it;
			_tmp18_ = expandable;
			_tmp19_ = granite_widgets_source_list_expandable_item_get_children (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = _tmp20_;
			_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
			_tmp23_ = _tmp22_;
			_g_object_unref0 (_tmp21_);
			_child_item_it = _tmp23_;
			while (TRUE) {
				GeeIterator* _tmp24_;
				gboolean _tmp25_ = FALSE;
				GeeIterator* _tmp26_;
				gpointer _tmp27_ = NULL;
				GraniteWidgetsSourceListItem* child_item;
				GraniteWidgetsSourceListItem* _tmp28_;
				_tmp24_ = _child_item_it;
				_tmp25_ = gee_iterator_next (_tmp24_);
				if (!_tmp25_) {
					break;
				}
				_tmp26_ = _child_item_it;
				_tmp27_ = gee_iterator_get (_tmp26_);
				child_item = (GraniteWidgetsSourceListItem*) _tmp27_;
				_tmp28_ = child_item;
				granite_widgets_source_list_data_model_remove_item (self, _tmp28_);
				_g_object_unref0 (child_item);
			}
			_g_object_unref0 (_child_item_it);
		}
	}
	_g_object_unref0 (expandable);
	_g_free0 (child_iter);
}


static void _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed (GraniteWidgetsSourceListDataModelItemMonitor* _sender, GraniteWidgetsSourceListItem* _self_, const gchar* prop_name, gpointer self) {
	granite_widgets_source_list_data_model_on_item_prop_changed (self, _self_, prop_name);
}


static void granite_widgets_source_list_data_model_add_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListDataModelItemMonitor* _tmp1_;
	GraniteWidgetsSourceListDataModelItemMonitor* wrapper;
	GeeHashMap* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_item_monitor_new (_tmp0_);
	wrapper = _tmp1_;
	_tmp2_ = self->priv->monitors;
	_tmp3_ = item;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, _tmp3_, wrapper);
	g_signal_connect_object (wrapper, "changed", (GCallback) _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed, self, 0);
	_granite_widgets_source_list_data_model_item_monitor_unref0 (wrapper);
}


static void granite_widgets_source_list_data_model_remove_property_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gpointer _tmp2_ = NULL;
	GraniteWidgetsSourceListDataModelItemMonitor* wrapper;
	GraniteWidgetsSourceListDataModelItemMonitor* _tmp3_;
	GeeHashMap* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = self->priv->monitors;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	wrapper = (GraniteWidgetsSourceListDataModelItemMonitor*) _tmp2_;
	_tmp3_ = wrapper;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModelItemMonitor* _tmp4_;
		guint _tmp5_ = 0U;
		_tmp4_ = wrapper;
		g_signal_parse_name ("changed", GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, &_tmp5_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_prop_changed_granite_widgets_source_list_data_model_item_monitor_changed, self);
	}
	_tmp6_ = self->priv->monitors;
	_tmp7_ = item;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp6_, _tmp7_, NULL);
	_granite_widgets_source_list_data_model_item_monitor_unref0 (wrapper);
}


static void _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	granite_widgets_source_list_data_model_on_item_child_added (self, item);
}


static void _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed (GraniteWidgetsSourceListExpandableItem* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	granite_widgets_source_list_data_model_on_item_child_removed (self, item);
}


static void granite_widgets_source_list_data_model_add_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	g_signal_connect_object (_tmp0_, "child-added", (GCallback) _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added, self, G_CONNECT_AFTER);
	_tmp1_ = item;
	g_signal_connect_object (_tmp1_, "child-removed", (GCallback) _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed, self, G_CONNECT_AFTER);
}


static void granite_widgets_source_list_data_model_remove_children_monitor (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* item) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	guint _tmp1_ = 0U;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	guint _tmp3_ = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	g_signal_parse_name ("child-added", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_child_added_granite_widgets_source_list_expandable_item_child_added, self);
	_tmp2_ = item;
	g_signal_parse_name ("child-removed", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_on_item_child_removed_granite_widgets_source_list_expandable_item_child_removed, self);
}


static void granite_widgets_source_list_data_model_on_item_child_added (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	granite_widgets_source_list_data_model_add_item (self, _tmp0_);
}


static void granite_widgets_source_list_data_model_on_item_child_removed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	granite_widgets_source_list_data_model_remove_item (self, _tmp0_);
}


static void granite_widgets_source_list_data_model_on_item_prop_changed (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, const gchar* prop_name) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	g_return_if_fail (prop_name != NULL);
	_tmp0_ = prop_name;
	if (g_strcmp0 (_tmp0_, "parent") != 0) {
		GraniteWidgetsSourceListItem* _tmp1_;
		_tmp1_ = item;
		granite_widgets_source_list_data_model_update_item (self, _tmp1_);
	}
}


/**
         * Pushes a call to update_item() if //parent// is not //null//.
         *
         * This is needed because the visibility of categories depends on their n_children property,
         * and also because item expansion should be updated after adding or removing items.
         * If many updates are pushed, and the item has still not been updated, only one is processed.
         * This guarantees efficiency as updating a category item could trigger expensive actions.
         */
static Block16Data* block16_data_ref (Block16Data* _data16_) {
	g_atomic_int_inc (&_data16_->_ref_count_);
	return _data16_;
}


static void block16_data_unref (void * _userdata_) {
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
		GraniteWidgetsSourceListDataModel * self;
		self = _data16_->self;
		_g_object_unref0 (_data16_->parent);
		_g_object_unref0 (self);
		g_slice_free (Block16Data, _data16_);
	}
}


static gboolean ___lambda65_ (Block16Data* _data16_) {
	GraniteWidgetsSourceListDataModel * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	self = _data16_->self;
	_tmp0_ = _data16_->parent;
	if (_tmp0_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GraniteWidgetsSourceListExpandableItem* _tmp2_;
		_tmp1_ = _data16_->parent;
		granite_widgets_source_list_data_model_update_item (self, (GraniteWidgetsSourceListItem*) _tmp1_);
		_tmp2_ = _data16_->parent;
		g_object_set_data_full ((GObject*) _tmp2_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) FALSE), NULL);
	}
	result = FALSE;
	return result;
}


static gboolean ____lambda65__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda65_ (self);
	return result;
}


static void granite_widgets_source_list_data_model_push_parent_update (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* parent) {
	Block16Data* _data16_;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	gconstpointer _tmp4_ = NULL;
	gboolean needs_update;
	gboolean _tmp5_;
	GraniteWidgetsSourceListExpandableItem* _tmp6_;
	GtkTreePath* _tmp7_ = NULL;
	GtkTreePath* path;
	GtkTreePath* _tmp8_;
	g_return_if_fail (self != NULL);
	_data16_ = g_slice_new0 (Block16Data);
	_data16_->_ref_count_ = 1;
	_data16_->self = g_object_ref (self);
	_tmp0_ = parent;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data16_->parent);
	_data16_->parent = _tmp1_;
	_tmp2_ = _data16_->parent;
	if (_tmp2_ == NULL) {
		block16_data_unref (_data16_);
		_data16_ = NULL;
		return;
	}
	_tmp3_ = _data16_->parent;
	_tmp4_ = g_object_get_data ((GObject*) _tmp3_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE);
	needs_update = (gboolean) ((gintptr) _tmp4_);
	_tmp5_ = needs_update;
	if (_tmp5_) {
		block16_data_unref (_data16_);
		_data16_ = NULL;
		return;
	}
	_tmp6_ = _data16_->parent;
	_tmp7_ = granite_widgets_source_list_data_model_get_item_path (self, (GraniteWidgetsSourceListItem*) _tmp6_);
	path = _tmp7_;
	_tmp8_ = path;
	if (_tmp8_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
		_tmp9_ = _data16_->parent;
		g_object_set_data_full ((GObject*) _tmp9_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) TRUE), NULL);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda65__gsource_func, block16_data_ref (_data16_), block16_data_unref);
	}
	_gtk_tree_path_free0 (path);
	block16_data_unref (_data16_);
	_data16_ = NULL;
}


/**
         * Returns the Item pointed by iter, or null if the iter doesn't refer to a valid item.
         */
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter) {
	GraniteWidgetsSourceListItem* result = NULL;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeIter _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item, -1, -1);
	result = item;
	return result;
}


/**
         * Returns the Item pointed by path, or null if the path doesn't refer to a valid item.
         */
static GraniteWidgetsSourceListItem* granite_widgets_source_list_data_model_get_item_from_path (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path) {
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeIter iter = {0};
	GtkTreePath* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = path;
	_tmp2_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp1_, _tmp0_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkTreeIter _tmp3_;
		GraniteWidgetsSourceListItem* _tmp4_ = NULL;
		_tmp3_ = iter;
		_tmp4_ = granite_widgets_source_list_data_model_get_item (self, &_tmp3_);
		result = _tmp4_;
		return result;
	}
	result = NULL;
	return result;
}


/**
         * Returns a newly-created path pointing to the item, or null in case a valid path
         * is not found.
         */
static gpointer _gtk_tree_path_copy0 (gpointer self) {
	return self ? gtk_tree_path_copy (self) : NULL;
}


static GtkTreePath* granite_widgets_source_list_data_model_get_item_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreePath* result = NULL;
	GtkTreePath* path;
	GraniteWidgetsSourceListItem* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreePath* child_path;
	GtkTreePath* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	path = NULL;
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_get_item_child_path (self, _tmp0_);
	child_path = _tmp1_;
	_tmp2_ = child_path;
	if (_tmp2_ != NULL) {
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_ = NULL;
		GtkTreePath* _tmp5_;
		_tmp3_ = child_path;
		_tmp4_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp3_);
		_tmp5_ = _gtk_tree_path_copy0 (_tmp4_);
		_gtk_tree_path_free0 (path);
		path = _tmp5_;
	}
	result = path;
	_gtk_tree_path_free0 (child_path);
	return result;
}


/**
         * Returns a newly-created iterator pointing to the item, or null in case a valid iter
         * was not found.
         */
static GtkTreeIter* granite_widgets_source_list_data_model_get_item_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreeIter* result = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GtkTreeIter* _tmp1_ = NULL;
	GtkTreeIter* child_iter;
	GtkTreeIter* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_data_model_get_item_child_iter (self, _tmp0_);
	child_iter = _tmp1_;
	_tmp2_ = child_iter;
	if (_tmp2_ != NULL) {
		GtkTreeIter iter = {0};
		GtkTreeIter* _tmp3_;
		GtkTreeIter _tmp4_ = {0};
		GtkTreeIter _tmp5_;
		gboolean _tmp6_ = FALSE;
		_tmp3_ = child_iter;
		_tmp5_ = *_tmp3_;
		_tmp6_ = gtk_tree_model_filter_convert_child_iter_to_iter ((GtkTreeModelFilter*) self, &_tmp4_, &_tmp5_);
		iter = _tmp4_;
		if (_tmp6_) {
			GtkTreeIter* _tmp7_;
			_tmp7_ = __gtk_tree_iter_dup0 (&iter);
			result = _tmp7_;
			_g_free0 (child_iter);
			return result;
		}
	}
	result = NULL;
	_g_free0 (child_iter);
	return result;
}


/**
         * Sets the sort function, or "unsets" it if null is passed. Please note though
         * that unsetting the sort function doesn't bring the items back to their initial
         * order.
         */
static gint _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self) {
	gint result;
	result = granite_widgets_source_list_data_model_child_model_sort_func (self, model, a, b);
	return result;
}


static void granite_widgets_source_list_data_model_set_sort_func (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListSortFunc sort_func, void* sort_func_target, GDestroyNotify sort_func_target_destroy_notify) {
	GraniteWidgetsSourceListSortFunc _tmp0_;
	void* _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GraniteWidgetsSourceListDataModelSortColumn _tmp1_ = 0;
	GraniteWidgetsSourceListSortFunc _tmp2_;
	void* _tmp2__target;
	GraniteWidgetsSourceListDataModelSortColumn _tmp3_;
	GtkTreeStore* _tmp4_;
	GtkSortType _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sort_func;
	_tmp0__target = sort_func_target;
	_tmp0__target_destroy_notify = sort_func_target_destroy_notify;
	sort_func_target_destroy_notify = NULL;
	(self->priv->sort_func_target_destroy_notify == NULL) ? NULL : (self->priv->sort_func_target_destroy_notify (self->priv->sort_func_target), NULL);
	self->priv->sort_func = NULL;
	self->priv->sort_func_target = NULL;
	self->priv->sort_func_target_destroy_notify = NULL;
	self->priv->sort_func = _tmp0_;
	self->priv->sort_func_target = _tmp0__target;
	self->priv->sort_func_target_destroy_notify = _tmp0__target_destroy_notify;
	_tmp2_ = self->priv->sort_func;
	_tmp2__target = self->priv->sort_func_target;
	if (_tmp2_ != NULL) {
		_tmp1_ = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_SORTED;
	} else {
		_tmp1_ = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_UNSORTED;
	}
	_tmp3_ = _tmp1_;
	self->priv->sort_column = _tmp3_;
	_tmp4_ = self->priv->child_tree;
	gtk_tree_sortable_set_sort_func ((GtkTreeSortable*) _tmp4_, (gint) GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_SORTED, _granite_widgets_source_list_data_model_child_model_sort_func_gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
	_tmp5_ = self->priv->sort_dir;
	granite_widgets_source_list_data_model_set_sort_direction (self, _tmp5_);
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}


/**
         * External "extra" filter method.
         */
static void granite_widgets_source_list_data_model_set_filter_func (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListVisibleFunc visible_func, void* visible_func_target) {
	GraniteWidgetsSourceListVisibleFunc _tmp0_;
	void* _tmp0__target;
	g_return_if_fail (self != NULL);
	_tmp0_ = visible_func;
	_tmp0__target = visible_func_target;
	self->priv->filter_func = _tmp0_;
	self->priv->filter_func_target = _tmp0__target;
}


/**
         * Checks whether an item is a category (i.e. a root-level expandable item).
         * The caller must pass an iter or path pointing to the item, but not both
         * (one of them must be null.)
         *
         * TODO: instead of checking the position of the iter or path, we should simply
         * check whether the item's parent is the root item and whether the item is
         * expandable. We don't do so right now because vala still allows client code
         * to access the Item.parent property, even though its setter is defined as internal.
         */
static gboolean granite_widgets_source_list_data_model_is_category (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item, GtkTreeIter* iter, GtkTreePath* path) {
	gboolean result = FALSE;
	gboolean is_category;
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	is_category = FALSE;
	_tmp0_ = item;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM)) {
		GtkTreeIter* _tmp1_;
		_tmp1_ = iter;
		if (_tmp1_ != NULL) {
			GtkTreePath* _tmp2_;
			GtkTreeIter* _tmp3_;
			GtkTreeIter _tmp4_;
			gboolean _tmp5_ = FALSE;
			_tmp2_ = path;
			_vala_assert (_tmp2_ == NULL, "path == null");
			_tmp3_ = iter;
			_tmp4_ = *_tmp3_;
			_tmp5_ = granite_widgets_source_list_data_model_is_iter_at_root_level (self, &_tmp4_);
			is_category = _tmp5_;
		} else {
			GtkTreeIter* _tmp6_;
			GtkTreePath* _tmp7_;
			gboolean _tmp8_ = FALSE;
			_tmp6_ = iter;
			_vala_assert (_tmp6_ == NULL, "iter == null");
			_tmp7_ = path;
			_tmp8_ = granite_widgets_source_list_data_model_is_path_at_root_level (self, _tmp7_);
			is_category = _tmp8_;
		}
	}
	result = is_category;
	return result;
}


static gboolean granite_widgets_source_list_data_model_is_iter_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreeIter* iter) {
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_tmp1_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = granite_widgets_source_list_data_model_is_path_at_root_level (self, _tmp2_);
	_tmp4_ = _tmp3_;
	_gtk_tree_path_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static gboolean granite_widgets_source_list_data_model_is_path_at_root_level (GraniteWidgetsSourceListDataModel* self, GtkTreePath* path) {
	gboolean result = FALSE;
	GtkTreePath* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = path;
	_tmp1_ = gtk_tree_path_get_depth (_tmp0_);
	result = _tmp1_ == 1;
	return result;
}


/**
         * Actual sort function. It simply returns zero if sort_func is null.
         */
static gint granite_widgets_source_list_data_model_child_model_sort_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b) {
	gint result = 0;
	gint sort;
	GraniteWidgetsSourceListItem* item_a = NULL;
	GraniteWidgetsSourceListItem* item_b = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GtkTreeStore* _tmp2_;
	GtkTreeIter _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	GraniteWidgetsSourceListSortFunc _tmp6_;
	void* _tmp6__target;
	gboolean _tmp8_;
	gboolean _tmp10_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (model != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	sort = 0;
	_tmp0_ = self->priv->child_tree;
	_tmp1_ = *a;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item_a, -1, -1);
	_tmp2_ = self->priv->child_tree;
	_tmp3_ = *b;
	gtk_tree_model_get ((GtkTreeModel*) _tmp2_, &_tmp3_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item_b, -1, -1);
	_tmp6_ = self->priv->sort_func;
	_tmp6__target = self->priv->sort_func_target;
	if (_tmp6_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp7_;
		_tmp7_ = item_a;
		_tmp5_ = _tmp7_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	_tmp8_ = _tmp5_;
	if (_tmp8_) {
		GraniteWidgetsSourceListItem* _tmp9_;
		_tmp9_ = item_b;
		_tmp4_ = _tmp9_ != NULL;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp10_ = _tmp4_;
	if (_tmp10_) {
		GraniteWidgetsSourceListSortFunc _tmp11_;
		void* _tmp11__target;
		GraniteWidgetsSourceListItem* _tmp12_;
		GraniteWidgetsSourceListItem* _tmp13_;
		gint _tmp14_ = 0;
		_tmp11_ = self->priv->sort_func;
		_tmp11__target = self->priv->sort_func_target;
		_tmp12_ = item_a;
		_tmp13_ = item_b;
		_tmp14_ = _tmp11_ (_tmp12_, _tmp13_, _tmp11__target);
		sort = _tmp14_;
	}
	result = sort;
	_g_object_unref0 (item_b);
	_g_object_unref0 (item_a);
	return result;
}


static GtkTreeIter* granite_widgets_source_list_data_model_get_item_child_iter (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gpointer _tmp2_ = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* child_node_wrapper;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	child_iter = NULL;
	_tmp0_ = self->priv->items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	child_node_wrapper = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp2_;
	_tmp3_ = child_node_wrapper;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp4_;
		GtkTreeIter* _tmp5_;
		GtkTreeIter* _tmp6_;
		_tmp4_ = child_node_wrapper;
		_tmp5_ = granite_widgets_source_list_data_model_node_wrapper_get_iter (_tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (child_iter);
		child_iter = _tmp6_;
	}
	result = child_iter;
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (child_node_wrapper);
	return result;
}


static GtkTreePath* granite_widgets_source_list_data_model_get_item_child_path (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListItem* item) {
	GtkTreePath* result = NULL;
	GtkTreePath* child_path;
	GeeHashMap* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	gpointer _tmp2_ = NULL;
	GraniteWidgetsSourceListDataModelNodeWrapper* child_node_wrapper;
	GraniteWidgetsSourceListDataModelNodeWrapper* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	child_path = NULL;
	_tmp0_ = self->priv->items;
	_tmp1_ = item;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	child_node_wrapper = (GraniteWidgetsSourceListDataModelNodeWrapper*) _tmp2_;
	_tmp3_ = child_node_wrapper;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModelNodeWrapper* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreePath* _tmp6_;
		_tmp4_ = child_node_wrapper;
		_tmp5_ = granite_widgets_source_list_data_model_node_wrapper_get_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_gtk_tree_path_free0 (child_path);
		child_path = _tmp6_;
	}
	result = child_path;
	_granite_widgets_source_list_data_model_node_wrapper_unref0 (child_node_wrapper);
	return result;
}


/**
         * Filters the child-tree items based on their "visible" property.
         */
static gboolean granite_widgets_source_list_data_model_filter_visible_func (GraniteWidgetsSourceListDataModel* self, GtkTreeModel* child_model, GtkTreeIter* iter) {
	gboolean result = FALSE;
	gboolean item_visible;
	GraniteWidgetsSourceListItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListVisibleFunc _tmp32_;
	void* _tmp32__target;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (child_model != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	item_visible = FALSE;
	_tmp0_ = self->priv->child_tree;
	_tmp1_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_COLUMN_ITEM, &item, -1, -1);
	_tmp2_ = item;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GraniteWidgetsSourceListItem* _tmp6_;
		GraniteWidgetsSourceListExpandableItem* _tmp7_;
		GraniteWidgetsSourceListExpandableItem* expandable;
		gboolean _tmp8_ = FALSE;
		GraniteWidgetsSourceListExpandableItem* _tmp9_;
		gboolean _tmp13_;
		_tmp3_ = item;
		_tmp4_ = granite_widgets_source_list_item_get_visible (_tmp3_);
		_tmp5_ = _tmp4_;
		item_visible = _tmp5_;
		_tmp6_ = item;
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp6_) : NULL);
		expandable = _tmp7_;
		_tmp9_ = expandable;
		if (_tmp9_ != NULL) {
			GtkTreeStore* _tmp10_;
			GtkTreeIter _tmp11_;
			gint _tmp12_ = 0;
			_tmp10_ = self->priv->child_tree;
			_tmp11_ = *iter;
			_tmp12_ = gtk_tree_store_iter_depth (_tmp10_, &_tmp11_);
			_tmp8_ = _tmp12_ == 0;
		} else {
			_tmp8_ = FALSE;
		}
		_tmp13_ = _tmp8_;
		if (_tmp13_) {
			guint n_visible_children;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_;
			gboolean _tmp31_;
			n_visible_children = (guint) 0;
			{
				GraniteWidgetsSourceListExpandableItem* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				GeeCollection* _tmp17_;
				GeeIterator* _tmp18_ = NULL;
				GeeIterator* _tmp19_;
				GeeIterator* _child_item_it;
				_tmp14_ = expandable;
				_tmp15_ = granite_widgets_source_list_expandable_item_get_children (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = _tmp16_;
				_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
				_tmp19_ = _tmp18_;
				_g_object_unref0 (_tmp17_);
				_child_item_it = _tmp19_;
				while (TRUE) {
					GeeIterator* _tmp20_;
					gboolean _tmp21_ = FALSE;
					GeeIterator* _tmp22_;
					gpointer _tmp23_ = NULL;
					GraniteWidgetsSourceListItem* child_item;
					GraniteWidgetsSourceListItem* _tmp24_;
					gboolean _tmp25_;
					gboolean _tmp26_;
					_tmp20_ = _child_item_it;
					_tmp21_ = gee_iterator_next (_tmp20_);
					if (!_tmp21_) {
						break;
					}
					_tmp22_ = _child_item_it;
					_tmp23_ = gee_iterator_get (_tmp22_);
					child_item = (GraniteWidgetsSourceListItem*) _tmp23_;
					_tmp24_ = child_item;
					_tmp25_ = granite_widgets_source_list_item_get_visible (_tmp24_);
					_tmp26_ = _tmp25_;
					if (_tmp26_) {
						guint _tmp27_;
						_tmp27_ = n_visible_children;
						n_visible_children = _tmp27_ + 1;
					}
					_g_object_unref0 (child_item);
				}
				_g_object_unref0 (_child_item_it);
			}
			_tmp29_ = item_visible;
			if (_tmp29_) {
				guint _tmp30_;
				_tmp30_ = n_visible_children;
				_tmp28_ = _tmp30_ > ((guint) 0);
			} else {
				_tmp28_ = FALSE;
			}
			_tmp31_ = _tmp28_;
			item_visible = _tmp31_;
		}
		_g_object_unref0 (expandable);
	}
	_tmp32_ = self->priv->filter_func;
	_tmp32__target = self->priv->filter_func_target;
	if (_tmp32_ != NULL) {
		gboolean _tmp33_ = FALSE;
		gboolean _tmp34_;
		gboolean _tmp38_;
		_tmp34_ = item_visible;
		if (_tmp34_) {
			GraniteWidgetsSourceListVisibleFunc _tmp35_;
			void* _tmp35__target;
			GraniteWidgetsSourceListItem* _tmp36_;
			gboolean _tmp37_ = FALSE;
			_tmp35_ = self->priv->filter_func;
			_tmp35__target = self->priv->filter_func_target;
			_tmp36_ = item;
			_tmp37_ = _tmp35_ (_tmp36_, _tmp35__target);
			_tmp33_ = _tmp37_;
		} else {
			_tmp33_ = FALSE;
		}
		_tmp38_ = _tmp33_;
		item_visible = _tmp38_;
	}
	result = item_visible;
	_g_object_unref0 (item);
	return result;
}


static GtkSortType granite_widgets_source_list_data_model_get_sort_direction (GraniteWidgetsSourceListDataModel* self) {
	GtkSortType result;
	GtkSortType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->sort_dir;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_data_model_set_sort_direction (GraniteWidgetsSourceListDataModel* self, GtkSortType value) {
	GtkSortType _tmp0_;
	GtkTreeStore* _tmp1_;
	GraniteWidgetsSourceListDataModelSortColumn _tmp2_;
	GtkSortType _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->sort_dir = _tmp0_;
	_tmp1_ = self->priv->child_tree;
	_tmp2_ = self->priv->sort_column;
	_tmp3_ = self->priv->sort_dir;
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp1_, (gint) _tmp2_, _tmp3_);
	g_object_notify ((GObject *) self, "sort-direction");
}


static GraniteWidgetsSourceListExpandableItem* granite_widgets_source_list_data_model_get_root (GraniteWidgetsSourceListDataModel* self) {
	GraniteWidgetsSourceListExpandableItem* result;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_root;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_data_model_set_root (GraniteWidgetsSourceListDataModel* self, GraniteWidgetsSourceListExpandableItem* value) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_root;
	if (_tmp0_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		_tmp1_ = self->priv->_root;
		granite_widgets_source_list_data_model_remove_children_monitor (self, _tmp1_);
		{
			GraniteWidgetsSourceListExpandableItem* _tmp2_;
			GeeCollection* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_ = NULL;
			GeeIterator* _tmp7_;
			GeeIterator* _item_it;
			_tmp2_ = self->priv->_root;
			_tmp3_ = granite_widgets_source_list_expandable_item_get_children (_tmp2_);
			_tmp4_ = _tmp3_;
			_tmp5_ = _tmp4_;
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
			_tmp7_ = _tmp6_;
			_g_object_unref0 (_tmp5_);
			_item_it = _tmp7_;
			while (TRUE) {
				GeeIterator* _tmp8_;
				gboolean _tmp9_ = FALSE;
				GeeIterator* _tmp10_;
				gpointer _tmp11_ = NULL;
				GraniteWidgetsSourceListItem* item;
				GraniteWidgetsSourceListItem* _tmp12_;
				_tmp8_ = _item_it;
				_tmp9_ = gee_iterator_next (_tmp8_);
				if (!_tmp9_) {
					break;
				}
				_tmp10_ = _item_it;
				_tmp11_ = gee_iterator_get (_tmp10_);
				item = (GraniteWidgetsSourceListItem*) _tmp11_;
				_tmp12_ = item;
				granite_widgets_source_list_data_model_remove_item (self, _tmp12_);
				_g_object_unref0 (item);
			}
			_g_object_unref0 (_item_it);
		}
	}
	_tmp13_ = value;
	_tmp14_ = _g_object_ref0 (_tmp13_);
	_g_object_unref0 (self->priv->_root);
	self->priv->_root = _tmp14_;
	_tmp15_ = self->priv->_root;
	granite_widgets_source_list_data_model_add_children_monitor (self, _tmp15_);
	{
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_ = NULL;
		GeeIterator* _tmp21_;
		GeeIterator* _item_it;
		_tmp16_ = self->priv->_root;
		_tmp17_ = granite_widgets_source_list_expandable_item_get_children (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_;
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
		_tmp21_ = _tmp20_;
		_g_object_unref0 (_tmp19_);
		_item_it = _tmp21_;
		while (TRUE) {
			GeeIterator* _tmp22_;
			gboolean _tmp23_ = FALSE;
			GeeIterator* _tmp24_;
			gpointer _tmp25_ = NULL;
			GraniteWidgetsSourceListItem* item;
			GraniteWidgetsSourceListItem* _tmp26_;
			_tmp22_ = _item_it;
			_tmp23_ = gee_iterator_next (_tmp22_);
			if (!_tmp23_) {
				break;
			}
			_tmp24_ = _item_it;
			_tmp25_ = gee_iterator_get (_tmp24_);
			item = (GraniteWidgetsSourceListItem*) _tmp25_;
			_tmp26_ = item;
			granite_widgets_source_list_data_model_add_item (self, _tmp26_);
			_g_object_unref0 (item);
		}
		_g_object_unref0 (_item_it);
	}
	g_object_notify ((GObject *) self, "root");
}


static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_construct (GType object_type, GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListDataModelNodeWrapper* self = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeIter _tmp2_;
	GtkTreePath* _tmp3_ = NULL;
	GtkTreePath* _tmp4_;
	GtkTreeRowReference* _tmp5_;
	g_return_val_if_fail (model != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	self = (GraniteWidgetsSourceListDataModelNodeWrapper*) g_type_create_instance (object_type);
	_tmp0_ = model;
	_tmp1_ = model;
	_tmp2_ = *iter;
	_tmp3_ = gtk_tree_model_get_path (_tmp1_, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = gtk_tree_row_reference_new (_tmp0_, _tmp4_);
	_gtk_tree_row_reference_free0 (self->priv->row_reference);
	self->priv->row_reference = _tmp5_;
	_gtk_tree_path_free0 (_tmp4_);
	return self;
}


static GraniteWidgetsSourceListDataModelNodeWrapper* granite_widgets_source_list_data_model_node_wrapper_new (GtkTreeModel* model, GtkTreeIter* iter) {
	return granite_widgets_source_list_data_model_node_wrapper_construct (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, model, iter);
}


static GtkTreeIter* granite_widgets_source_list_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListDataModelNodeWrapper* self) {
	GtkTreeIter* result;
	GtkTreeIter* rv;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = granite_widgets_source_list_data_model_node_wrapper_get_valid (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		GtkTreePath* _tmp2_;
		GtkTreePath* _tmp3_;
		GtkTreePath* _path;
		GtkTreePath* _tmp4_;
		_tmp2_ = granite_widgets_source_list_data_model_node_wrapper_get_path (self);
		_tmp3_ = _tmp2_;
		_path = _tmp3_;
		_tmp4_ = _path;
		if (_tmp4_ != NULL) {
			GtkTreeIter _iter = {0};
			const GtkTreeRowReference* _tmp5_;
			GtkTreeModel* _tmp6_ = NULL;
			GtkTreePath* _tmp7_;
			GtkTreeIter _tmp8_ = {0};
			gboolean _tmp9_ = FALSE;
			_tmp5_ = self->priv->row_reference;
			_tmp6_ = gtk_tree_row_reference_get_model (_tmp5_);
			_tmp7_ = _path;
			_tmp9_ = gtk_tree_model_get_iter (_tmp6_, &_tmp8_, _tmp7_);
			_iter = _tmp8_;
			if (_tmp9_) {
				GtkTreeIter _tmp10_;
				GtkTreeIter* _tmp11_;
				_tmp10_ = _iter;
				_tmp11_ = __gtk_tree_iter_dup0 (&_tmp10_);
				_g_free0 (rv);
				rv = _tmp11_;
			}
		}
		_gtk_tree_path_free0 (_path);
	}
	result = rv;
	return result;
}


static GtkTreePath* granite_widgets_source_list_data_model_node_wrapper_get_path (GraniteWidgetsSourceListDataModelNodeWrapper* self) {
	GtkTreePath* result;
	GtkTreePath* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = granite_widgets_source_list_data_model_node_wrapper_get_valid (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		const GtkTreeRowReference* _tmp3_;
		GtkTreePath* _tmp4_ = NULL;
		_tmp3_ = self->priv->row_reference;
		_tmp4_ = gtk_tree_row_reference_get_path (_tmp3_);
		_gtk_tree_path_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		_gtk_tree_path_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


static gboolean granite_widgets_source_list_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListDataModelNodeWrapper* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	const GtkTreeRowReference* _tmp1_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->row_reference;
	if (_tmp1_ != NULL) {
		const GtkTreeRowReference* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp2_ = self->priv->row_reference;
		_tmp3_ = gtk_tree_row_reference_valid (_tmp2_);
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = _tmp0_;
	result = _tmp4_;
	return result;
}


static void granite_widgets_source_list_data_model_value_node_wrapper_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void granite_widgets_source_list_data_model_value_node_wrapper_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		granite_widgets_source_list_data_model_node_wrapper_unref (value->data[0].v_pointer);
	}
}


static void granite_widgets_source_list_data_model_value_node_wrapper_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = granite_widgets_source_list_data_model_node_wrapper_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer granite_widgets_source_list_data_model_value_node_wrapper_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* granite_widgets_source_list_data_model_value_node_wrapper_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GraniteWidgetsSourceListDataModelNodeWrapper* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = granite_widgets_source_list_data_model_node_wrapper_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* granite_widgets_source_list_data_model_value_node_wrapper_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GraniteWidgetsSourceListDataModelNodeWrapper** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = granite_widgets_source_list_data_model_node_wrapper_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* granite_widgets_source_list_data_model_param_spec_node_wrapper (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GraniteWidgetsSourceListDataModelParamSpecNodeWrapper* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer granite_widgets_source_list_data_model_value_get_node_wrapper (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
	return value->data[0].v_pointer;
}


static void granite_widgets_source_list_data_model_value_set_node_wrapper (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelNodeWrapper* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		granite_widgets_source_list_data_model_node_wrapper_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_node_wrapper_unref (old);
	}
}


static void granite_widgets_source_list_data_model_value_take_node_wrapper (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelNodeWrapper* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_node_wrapper_unref (old);
	}
}


static void granite_widgets_source_list_data_model_node_wrapper_class_init (GraniteWidgetsSourceListDataModelNodeWrapperClass * klass) {
	granite_widgets_source_list_data_model_node_wrapper_parent_class = g_type_class_peek_parent (klass);
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_CLASS (klass)->finalize = granite_widgets_source_list_data_model_node_wrapper_finalize;
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListDataModelNodeWrapperPrivate));
}


static void granite_widgets_source_list_data_model_node_wrapper_instance_init (GraniteWidgetsSourceListDataModelNodeWrapper * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void granite_widgets_source_list_data_model_node_wrapper_finalize (GraniteWidgetsSourceListDataModelNodeWrapper* obj) {
	GraniteWidgetsSourceListDataModelNodeWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListDataModelNodeWrapper);
	_gtk_tree_row_reference_free0 (self->priv->row_reference);
}


/**
         * An object that references a particular row in a model. This class is a wrapper built around
         * Gtk.TreeRowReference, and exists with the purpose of ensuring we never use invalid tree paths
         * or iters in the model, since most of these errors provoke failures due to GTK+ assertions
         * or, even worse, unexpected behavior.
         */
static GType granite_widgets_source_list_data_model_node_wrapper_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_node_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_node_wrapper_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_data_model_value_node_wrapper_init, granite_widgets_source_list_data_model_value_node_wrapper_free_value, granite_widgets_source_list_data_model_value_node_wrapper_copy_value, granite_widgets_source_list_data_model_value_node_wrapper_peek_pointer, "p", granite_widgets_source_list_data_model_value_node_wrapper_collect_value, "p", granite_widgets_source_list_data_model_value_node_wrapper_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelNodeWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_node_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModelNodeWrapper), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_node_wrapper_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_data_model_node_wrapper_type_id;
		granite_widgets_source_list_data_model_node_wrapper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListDataModelNodeWrapper", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&granite_widgets_source_list_data_model_node_wrapper_type_id__volatile, granite_widgets_source_list_data_model_node_wrapper_type_id);
	}
	return granite_widgets_source_list_data_model_node_wrapper_type_id__volatile;
}


static gpointer granite_widgets_source_list_data_model_node_wrapper_ref (gpointer instance) {
	GraniteWidgetsSourceListDataModelNodeWrapper* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void granite_widgets_source_list_data_model_node_wrapper_unref (gpointer instance) {
	GraniteWidgetsSourceListDataModelNodeWrapper* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_NODE_WRAPPER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	granite_widgets_source_list_data_model_item_monitor_on_notify (self, pspec);
}


static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_construct (GType object_type, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListDataModelItemMonitor* self = NULL;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_val_if_fail (item != NULL, NULL);
	self = (GraniteWidgetsSourceListDataModelItemMonitor*) g_type_create_instance (object_type);
	_tmp0_ = item;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->item);
	self->priv->item = _tmp1_;
	_tmp2_ = item;
	g_signal_connect_after ((GObject*) _tmp2_, "notify", (GCallback) _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify, self);
	return self;
}


static GraniteWidgetsSourceListDataModelItemMonitor* granite_widgets_source_list_data_model_item_monitor_new (GraniteWidgetsSourceListItem* item) {
	return granite_widgets_source_list_data_model_item_monitor_construct (GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, item);
}


static void granite_widgets_source_list_data_model_item_monitor_on_notify (GraniteWidgetsSourceListDataModelItemMonitor* self, GParamSpec* prop) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GParamSpec* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (prop != NULL);
	_tmp0_ = self->priv->item;
	_tmp1_ = prop;
	_tmp2_ = _tmp1_->name;
	g_signal_emit_by_name (self, "changed", _tmp0_, _tmp2_);
}


static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
}


static void granite_widgets_source_list_data_model_value_item_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void granite_widgets_source_list_data_model_value_item_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		granite_widgets_source_list_data_model_item_monitor_unref (value->data[0].v_pointer);
	}
}


static void granite_widgets_source_list_data_model_value_item_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = granite_widgets_source_list_data_model_item_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer granite_widgets_source_list_data_model_value_item_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* granite_widgets_source_list_data_model_value_item_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GraniteWidgetsSourceListDataModelItemMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = granite_widgets_source_list_data_model_item_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* granite_widgets_source_list_data_model_value_item_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GraniteWidgetsSourceListDataModelItemMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = granite_widgets_source_list_data_model_item_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* granite_widgets_source_list_data_model_param_spec_item_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GraniteWidgetsSourceListDataModelParamSpecItemMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer granite_widgets_source_list_data_model_value_get_item_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
	return value->data[0].v_pointer;
}


static void granite_widgets_source_list_data_model_value_set_item_monitor (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelItemMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		granite_widgets_source_list_data_model_item_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_item_monitor_unref (old);
	}
}


static void granite_widgets_source_list_data_model_value_take_item_monitor (GValue* value, gpointer v_object) {
	GraniteWidgetsSourceListDataModelItemMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		granite_widgets_source_list_data_model_item_monitor_unref (old);
	}
}


static void granite_widgets_source_list_data_model_item_monitor_class_init (GraniteWidgetsSourceListDataModelItemMonitorClass * klass) {
	granite_widgets_source_list_data_model_item_monitor_parent_class = g_type_class_peek_parent (klass);
	GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_CLASS (klass)->finalize = granite_widgets_source_list_data_model_item_monitor_finalize;
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListDataModelItemMonitorPrivate));
	g_signal_new ("changed", GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_TYPE_STRING);
}


static void granite_widgets_source_list_data_model_item_monitor_instance_init (GraniteWidgetsSourceListDataModelItemMonitor * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void granite_widgets_source_list_data_model_item_monitor_finalize (GraniteWidgetsSourceListDataModelItemMonitor* obj) {
	GraniteWidgetsSourceListDataModelItemMonitor * self;
	GraniteWidgetsSourceListItem* _tmp0_;
	guint _tmp1_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListDataModelItemMonitor);
	_tmp0_ = self->priv->item;
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_data_model_item_monitor_on_notify_g_object_notify, self);
	_g_object_unref0 (self->priv->item);
}


/**
         * Helper object used to monitor item property changes.
         */
static GType granite_widgets_source_list_data_model_item_monitor_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_item_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_item_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_data_model_value_item_monitor_init, granite_widgets_source_list_data_model_value_item_monitor_free_value, granite_widgets_source_list_data_model_value_item_monitor_copy_value, granite_widgets_source_list_data_model_value_item_monitor_peek_pointer, "p", granite_widgets_source_list_data_model_value_item_monitor_collect_value, "p", granite_widgets_source_list_data_model_value_item_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelItemMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_item_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModelItemMonitor), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_item_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_data_model_item_monitor_type_id;
		granite_widgets_source_list_data_model_item_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListDataModelItemMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&granite_widgets_source_list_data_model_item_monitor_type_id__volatile, granite_widgets_source_list_data_model_item_monitor_type_id);
	}
	return granite_widgets_source_list_data_model_item_monitor_type_id__volatile;
}


static gpointer granite_widgets_source_list_data_model_item_monitor_ref (gpointer instance) {
	GraniteWidgetsSourceListDataModelItemMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void granite_widgets_source_list_data_model_item_monitor_unref (gpointer instance) {
	GraniteWidgetsSourceListDataModelItemMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ITEM_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void granite_widgets_source_list_data_model_class_init (GraniteWidgetsSourceListDataModelClass * klass) {
	granite_widgets_source_list_data_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListDataModelPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_data_model_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_data_model_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_data_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_DIRECTION, g_param_spec_enum ("sort-direction", "sort-direction", "sort-direction", GTK_TYPE_SORT_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * Root item.
	         *
	         * This item is not actually part of the model. It's only used as a proxy
	         * for adding and removing items.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT, g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("item_updated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
}


static void granite_widgets_source_list_data_model_instance_init (GraniteWidgetsSourceListDataModel * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_GET_PRIVATE (self);
	self->priv->sort_dir = GTK_SORT_ASCENDING;
	_tmp0_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_NODE_WRAPPER, (GBoxedCopyFunc) granite_widgets_source_list_data_model_node_wrapper_ref, granite_widgets_source_list_data_model_node_wrapper_unref, NULL, NULL, NULL);
	self->priv->items = _tmp0_;
	_tmp1_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_TYPE_ITEM_MONITOR, (GBoxedCopyFunc) granite_widgets_source_list_data_model_item_monitor_ref, granite_widgets_source_list_data_model_item_monitor_unref, NULL, NULL, NULL);
	self->priv->monitors = _tmp1_;
	self->priv->sort_column = GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_COLUMN_UNSORTED;
}


static void granite_widgets_source_list_data_model_finalize (GObject* obj) {
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
	_g_object_unref0 (self->priv->_root);
	_g_object_unref0 (self->priv->items);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->child_tree);
	(self->priv->sort_func_target_destroy_notify == NULL) ? NULL : (self->priv->sort_func_target_destroy_notify (self->priv->sort_func_target), NULL);
	self->priv->sort_func = NULL;
	self->priv->sort_func_target = NULL;
	self->priv->sort_func_target_destroy_notify = NULL;
	G_OBJECT_CLASS (granite_widgets_source_list_data_model_parent_class)->finalize (obj);
}


/**
     * The model backing the SourceList tree.
     *
     * It monitors item property changes, and handles children additions and removals. It also controls
     * the visibility of the items based on their "visible" property, and on their number of children,
     * if they happen to be categories. Its main purpose is to provide an easy and practical interface
     * for sorting, adding, removing and updating items, eliminating the need of repeatedly dealing with
     * the Gtk.TreeModel API directly.
     */
static GType granite_widgets_source_list_data_model_get_type (void) {
	static volatile gsize granite_widgets_source_list_data_model_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_data_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListDataModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_data_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListDataModel), 0, (GInstanceInitFunc) granite_widgets_source_list_data_model_instance_init, NULL };
		GType granite_widgets_source_list_data_model_type_id;
		granite_widgets_source_list_data_model_type_id = g_type_register_static (GTK_TYPE_TREE_MODEL_FILTER, "GraniteWidgetsSourceListDataModel", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_data_model_type_id__volatile, granite_widgets_source_list_data_model_type_id);
	}
	return granite_widgets_source_list_data_model_type_id__volatile;
}


static void _vala_granite_widgets_source_list_data_model_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_DIRECTION:
		g_value_set_enum (value, granite_widgets_source_list_data_model_get_sort_direction (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT:
		g_value_set_object (value, granite_widgets_source_list_data_model_get_root (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_data_model_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, GraniteWidgetsSourceListDataModel);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_SORT_DIRECTION:
		granite_widgets_source_list_data_model_set_sort_direction (self, g_value_get_enum (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_DATA_MODEL_ROOT:
		granite_widgets_source_list_data_model_set_root (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_construct (GType object_type) {
	GraniteWidgetsSourceListCellRendererIcon * self = NULL;
	self = (GraniteWidgetsSourceListCellRendererIcon*) g_object_new (object_type, NULL);
	g_object_set ((GtkCellRenderer*) self, "mode", GTK_CELL_RENDERER_MODE_ACTIVATABLE, NULL);
	g_object_set ((GtkCellRendererPixbuf*) self, "stock-size", (guint) GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_ICON_ICON_SIZE, NULL);
	g_object_set ((GtkCellRendererPixbuf*) self, "follow-state", TRUE, NULL);
	return self;
}


static GraniteWidgetsSourceListCellRendererIcon* granite_widgets_source_list_cell_renderer_icon_new (void) {
	return granite_widgets_source_list_cell_renderer_icon_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON);
}


static gboolean granite_widgets_source_list_cell_renderer_icon_real_activate (GtkCellRenderer* base, GdkEvent* event, GtkWidget* widget, const gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags) {
	GraniteWidgetsSourceListCellRendererIcon * self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	self = (GraniteWidgetsSourceListCellRendererIcon*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (background_area != NULL, FALSE);
	g_return_val_if_fail (cell_area != NULL, FALSE);
	_tmp0_ = path;
	g_signal_emit_by_name (self, "activated", _tmp0_);
	result = TRUE;
	return result;
}


static void granite_widgets_source_list_cell_renderer_icon_class_init (GraniteWidgetsSourceListCellRendererIconClass * klass) {
	granite_widgets_source_list_cell_renderer_icon_parent_class = g_type_class_peek_parent (klass);
	GTK_CELL_RENDERER_CLASS (klass)->activate = granite_widgets_source_list_cell_renderer_icon_real_activate;
	g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void granite_widgets_source_list_cell_renderer_icon_instance_init (GraniteWidgetsSourceListCellRendererIcon * self) {
}


/**
     * Class responsible for rendering Item.icon and Item.activatable. It also
     * notifies about clicks through the activated() signal.
     */
static GType granite_widgets_source_list_cell_renderer_icon_get_type (void) {
	static volatile gsize granite_widgets_source_list_cell_renderer_icon_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_cell_renderer_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListCellRendererIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_cell_renderer_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListCellRendererIcon), 0, (GInstanceInitFunc) granite_widgets_source_list_cell_renderer_icon_instance_init, NULL };
		GType granite_widgets_source_list_cell_renderer_icon_type_id;
		granite_widgets_source_list_cell_renderer_icon_type_id = g_type_register_static (GTK_TYPE_CELL_RENDERER_PIXBUF, "GraniteWidgetsSourceListCellRendererIcon", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_cell_renderer_icon_type_id__volatile, granite_widgets_source_list_cell_renderer_icon_type_id);
	}
	return granite_widgets_source_list_cell_renderer_icon_type_id__volatile;
}


static GtkSizeRequestMode granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	GtkSizeRequestMode result = 0;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}


static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base, GtkWidget* widget, gint* min_size, gint* natural_size) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_min_size = 0;
	gint _vala_natural_size = 0;
	guint _tmp0_ = 0U;
	guint _tmp1_;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (widget != NULL);
	g_object_get ((GtkCellRenderer*) self, "xpad", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_vala_natural_size = 2 * ((gint) _tmp1_);
	_vala_min_size = _vala_natural_size;
	if (min_size) {
		*min_size = _vala_min_size;
	}
	if (natural_size) {
		*natural_size = _vala_natural_size;
	}
}


static void granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base, GtkWidget* widget, gint width, gint* min_height, gint* natural_height) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_min_height = 0;
	gint _vala_natural_height = 0;
	guint _tmp0_ = 0U;
	guint _tmp1_;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (widget != NULL);
	g_object_get ((GtkCellRenderer*) self, "ypad", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_vala_natural_height = 2 * ((gint) _tmp1_);
	_vala_min_height = _vala_natural_height;
	if (min_height) {
		*min_height = _vala_min_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void granite_widgets_source_list_cell_renderer_spacer_real_render (GtkCellRenderer* base, cairo_t* context, GtkWidget* widget, GdkRectangle* bg_area, GdkRectangle* cell_area, GtkCellRendererState flags) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (context != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (bg_area != NULL);
	g_return_if_fail (cell_area != NULL);
}


static void granite_widgets_source_list_cell_renderer_spacer_real_get_size (GtkCellRenderer* base, GtkWidget* widget, GdkRectangle* cell_area, gint* x_offset, gint* y_offset, gint* width, gint* height) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) base;
	g_return_if_fail (widget != NULL);
	g_assert_not_reached ();
	if (x_offset) {
		*x_offset = _vala_x_offset;
	}
	if (y_offset) {
		*y_offset = _vala_y_offset;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}


static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_construct (GType object_type) {
	GraniteWidgetsSourceListCellRendererSpacer * self = NULL;
	self = (GraniteWidgetsSourceListCellRendererSpacer*) g_object_new (object_type, NULL);
	return self;
}


static GraniteWidgetsSourceListCellRendererSpacer* granite_widgets_source_list_cell_renderer_spacer_new (void) {
	return granite_widgets_source_list_cell_renderer_spacer_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER);
}


static gint granite_widgets_source_list_cell_renderer_spacer_get_level (GraniteWidgetsSourceListCellRendererSpacer* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_level;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_cell_renderer_spacer_set_level (GraniteWidgetsSourceListCellRendererSpacer* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_level = _tmp0_;
	g_object_notify ((GObject *) self, "level");
}


static void granite_widgets_source_list_cell_renderer_spacer_class_init (GraniteWidgetsSourceListCellRendererSpacerClass * klass) {
	granite_widgets_source_list_cell_renderer_spacer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListCellRendererSpacerPrivate));
	GTK_CELL_RENDERER_CLASS (klass)->get_request_mode = granite_widgets_source_list_cell_renderer_spacer_real_get_request_mode;
	GTK_CELL_RENDERER_CLASS (klass)->get_preferred_width = granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_width;
	GTK_CELL_RENDERER_CLASS (klass)->get_preferred_height_for_width = granite_widgets_source_list_cell_renderer_spacer_real_get_preferred_height_for_width;
	GTK_CELL_RENDERER_CLASS (klass)->render = granite_widgets_source_list_cell_renderer_spacer_real_render;
	GTK_CELL_RENDERER_CLASS (klass)->get_size = granite_widgets_source_list_cell_renderer_spacer_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_cell_renderer_spacer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_cell_renderer_spacer_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_cell_renderer_spacer_finalize;
	/**
	         * Indentation level represented by this cell renderer
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL, g_param_spec_int ("level", "level", "level", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void granite_widgets_source_list_cell_renderer_spacer_instance_init (GraniteWidgetsSourceListCellRendererSpacer * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_GET_PRIVATE (self);
	self->priv->_level = -1;
}


static void granite_widgets_source_list_cell_renderer_spacer_finalize (GObject* obj) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
	G_OBJECT_CLASS (granite_widgets_source_list_cell_renderer_spacer_parent_class)->finalize (obj);
}


/**
     * A cell renderer that only adds space.
     */
static GType granite_widgets_source_list_cell_renderer_spacer_get_type (void) {
	static volatile gsize granite_widgets_source_list_cell_renderer_spacer_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_cell_renderer_spacer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListCellRendererSpacerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_cell_renderer_spacer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListCellRendererSpacer), 0, (GInstanceInitFunc) granite_widgets_source_list_cell_renderer_spacer_instance_init, NULL };
		GType granite_widgets_source_list_cell_renderer_spacer_type_id;
		granite_widgets_source_list_cell_renderer_spacer_type_id = g_type_register_static (GTK_TYPE_CELL_RENDERER, "GraniteWidgetsSourceListCellRendererSpacer", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_cell_renderer_spacer_type_id__volatile, granite_widgets_source_list_cell_renderer_spacer_type_id);
	}
	return granite_widgets_source_list_cell_renderer_spacer_type_id__volatile;
}


static void _vala_granite_widgets_source_list_cell_renderer_spacer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL:
		g_value_set_int (value, granite_widgets_source_list_cell_renderer_spacer_get_level (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_cell_renderer_spacer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListCellRendererSpacer);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_CELL_RENDERER_SPACER_LEVEL:
		granite_widgets_source_list_cell_renderer_spacer_set_level (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender, GtkCellEditable* editable, const gchar* path, gpointer self) {
	granite_widgets_source_list_tree_on_editing_started (self, editable, path);
}


static void _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender, gpointer self) {
	granite_widgets_source_list_tree_on_editing_canceled (self);
}


static void _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated (GraniteWidgetsSourceListDataModel* _sender, GraniteWidgetsSourceListItem* item, gpointer self) {
	granite_widgets_source_list_tree_on_model_item_updated (self, item);
}


static GType granite_widgets_source_list_tree_column_get_type (void) {
	static volatile gsize granite_widgets_source_list_tree_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_tree_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS, "GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_N_COLS", "n-cols"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_tree_column_type_id;
		granite_widgets_source_list_tree_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListTreeColumn", values);
		g_once_init_leave (&granite_widgets_source_list_tree_column_type_id__volatile, granite_widgets_source_list_tree_column_type_id);
	}
	return granite_widgets_source_list_tree_column_type_id__volatile;
}


static void _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_expander_cell_data_func (self, cell_layout, cell, tree_model, iter);
}


static void _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated (GraniteWidgetsSourceListCellRendererIcon* _sender, const gchar* path, gpointer self) {
	granite_widgets_source_list_tree_on_activatable_activated (self, path);
}


static void _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_icon_cell_data_func (self, cell_layout, cell, tree_model, iter);
}


static void _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_badge_cell_data_func (self, cell_layout, cell, tree_model, iter);
}


static void _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_name_cell_data_func (self, cell_layout, cell, tree_model, iter);
}


static gboolean _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer self) {
	gboolean result;
	result = granite_widgets_source_list_tree_select_func (self, selection, model, path, path_currently_selected);
	return result;
}


static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_construct (GType object_type, GraniteWidgetsSourceListDataModel* data_model) {
	GraniteWidgetsSourceListTree * self = NULL;
	GtkCssProvider* _tmp0_ = NULL;
	GtkCssProvider* _tmp1_;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListDataModel* _tmp3_;
	GtkTreeViewColumn* _tmp4_;
	GtkTreeViewColumn* item_column;
	GraniteWidgetsCellRendererExpander* _tmp5_;
	GraniteWidgetsCellRendererExpander* _tmp6_;
	GraniteWidgetsCellRendererExpander* _tmp7_;
	GraniteWidgetsCellRendererExpander* _tmp8_;
	GraniteWidgetsCellRendererExpander* _tmp9_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp10_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp11_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp12_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp13_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp14_;
	GraniteWidgetsCellRendererBadge* _tmp15_;
	GraniteWidgetsCellRendererBadge* _tmp16_;
	GraniteWidgetsCellRendererBadge* _tmp17_;
	GraniteWidgetsCellRendererBadge* _tmp18_;
	GtkCellRendererText* _tmp19_;
	GtkCellRendererText* _tmp20_;
	GtkCellRendererText* _tmp21_;
	GtkCellRendererText* _tmp22_;
	GtkCellRendererText* _tmp23_;
	GtkCellRendererText* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkCellRendererText* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp28_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp29_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp30_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp31_;
	GraniteWidgetsCellRendererExpander* _tmp32_;
	gint expander_spacing = 0;
	GraniteWidgetsCellRendererExpander* _tmp33_;
	GraniteWidgetsCellRendererExpander* _tmp34_;
	GraniteWidgetsCellRendererExpander* _tmp35_;
	GtkTreeSelection* _tmp36_ = NULL;
	GtkTreeSelection* _tmp37_;
	GtkTreeSelection* selection;
	GraniteWidgetsSourceListDataModel* _tmp38_;
	g_return_val_if_fail (data_model != NULL, NULL);
	self = (GraniteWidgetsSourceListTree*) g_object_new (object_type, NULL);
	_tmp0_ = granite_widgets_utils_set_theming ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_DEFAULT_STYLESHEET, GRANITE_STYLE_CLASS_SOURCE_LIST, GTK_STYLE_PROVIDER_PRIORITY_FALLBACK);
	_tmp1_ = _tmp0_;
	_g_object_unref0 (_tmp1_);
	_tmp2_ = data_model;
	granite_widgets_source_list_tree_set_data_model (self, _tmp2_);
	_tmp3_ = data_model;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp3_);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, FALSE);
	g_object_set ((GtkTreeView*) self, "enable-grid-lines", GTK_TREE_VIEW_GRID_LINES_NONE, NULL);
	gtk_tree_view_set_expander_column ((GtkTreeView*) self, NULL);
	gtk_tree_view_set_show_expanders ((GtkTreeView*) self, FALSE);
	_tmp4_ = gtk_tree_view_column_new ();
	g_object_ref_sink (_tmp4_);
	item_column = _tmp4_;
	gtk_tree_view_column_set_expand (item_column, TRUE);
	gtk_tree_view_insert_column ((GtkTreeView*) self, item_column, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
	_tmp5_ = granite_widgets_cell_renderer_expander_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->secondary_expander_cell);
	self->priv->secondary_expander_cell = _tmp5_;
	_tmp6_ = self->priv->secondary_expander_cell;
	granite_widgets_cell_renderer_expander_set_is_category_expander (_tmp6_, TRUE);
	_tmp7_ = self->priv->secondary_expander_cell;
	g_object_set ((GtkCellRenderer*) _tmp7_, "xpad", (guint) 10, NULL);
	_tmp8_ = self->priv->secondary_expander_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp8_, FALSE);
	_tmp9_ = self->priv->secondary_expander_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp9_, _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp10_ = granite_widgets_source_list_cell_renderer_icon_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->activatable_cell);
	self->priv->activatable_cell = _tmp10_;
	_tmp11_ = self->priv->activatable_cell;
	g_object_set ((GtkCellRenderer*) _tmp11_, "xpad", (guint) 6, NULL);
	_tmp12_ = self->priv->activatable_cell;
	g_signal_connect_object (_tmp12_, "activated", (GCallback) _granite_widgets_source_list_tree_on_activatable_activated_granite_widgets_source_list_cell_renderer_icon_activated, self, 0);
	_tmp13_ = self->priv->activatable_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp13_, FALSE);
	_tmp14_ = self->priv->activatable_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp14_, _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp15_ = granite_widgets_cell_renderer_badge_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->badge_cell);
	self->priv->badge_cell = _tmp15_;
	_tmp16_ = self->priv->badge_cell;
	g_object_set ((GtkCellRenderer*) _tmp16_, "xpad", (guint) 1, NULL);
	_tmp17_ = self->priv->badge_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp17_, FALSE);
	_tmp18_ = self->priv->badge_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp18_, _granite_widgets_source_list_tree_badge_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp19_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->text_cell);
	self->priv->text_cell = _tmp19_;
	_tmp20_ = self->priv->text_cell;
	g_object_set (_tmp20_, "editable-set", TRUE, NULL);
	_tmp21_ = self->priv->text_cell;
	g_object_set (_tmp21_, "editable", FALSE, NULL);
	_tmp22_ = self->priv->text_cell;
	g_signal_connect_object ((GtkCellRenderer*) _tmp22_, "editing-started", (GCallback) _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started, self, 0);
	_tmp23_ = self->priv->text_cell;
	g_signal_connect_object ((GtkCellRenderer*) _tmp23_, "editing-canceled", (GCallback) _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
	_tmp24_ = self->priv->text_cell;
	g_object_set (_tmp24_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	_tmp25_ = self->priv->text_cell;
	g_object_set ((GtkCellRenderer*) _tmp25_, "xalign", (gfloat) 0, NULL);
	_tmp26_ = self->priv->text_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp26_, TRUE);
	_tmp27_ = self->priv->text_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp27_, _granite_widgets_source_list_tree_name_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp28_ = granite_widgets_source_list_cell_renderer_icon_new ();
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->icon_cell);
	self->priv->icon_cell = _tmp28_;
	_tmp29_ = self->priv->icon_cell;
	g_object_set ((GtkCellRenderer*) _tmp29_, "xpad", (guint) 2, NULL);
	_tmp30_ = self->priv->icon_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp30_, FALSE);
	_tmp31_ = self->priv->icon_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp31_, _granite_widgets_source_list_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp32_ = granite_widgets_cell_renderer_expander_new ();
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->primary_expander_cell);
	self->priv->primary_expander_cell = _tmp32_;
	gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING, &expander_spacing, NULL);
	_tmp33_ = self->priv->primary_expander_cell;
	g_object_set ((GtkCellRenderer*) _tmp33_, "xpad", (guint) (expander_spacing / 2), NULL);
	_tmp34_ = self->priv->primary_expander_cell;
	gtk_cell_layout_pack_end ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp34_, FALSE);
	_tmp35_ = self->priv->primary_expander_cell;
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) item_column, (GtkCellRenderer*) _tmp35_, _granite_widgets_source_list_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
	_tmp36_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp37_ = _g_object_ref0 (_tmp36_);
	selection = _tmp37_;
	gtk_tree_selection_set_mode (selection, GTK_SELECTION_BROWSE);
	gtk_tree_selection_set_select_function (selection, _granite_widgets_source_list_tree_select_func_gtk_tree_selection_func, g_object_ref (self), g_object_unref);
	_tmp38_ = data_model;
	g_signal_connect_object (_tmp38_, "item-updated", (GCallback) _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated, self, G_CONNECT_AFTER);
	granite_widgets_source_list_tree_add_spacer_cell_for_level (self, 1, TRUE);
	_g_object_unref0 (selection);
	_g_object_unref0 (item_column);
	return self;
}


static GraniteWidgetsSourceListTree* granite_widgets_source_list_tree_new (GraniteWidgetsSourceListDataModel* data_model) {
	return granite_widgets_source_list_tree_construct (GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, data_model);
}


static void granite_widgets_source_list_tree_on_model_item_updated (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* expandable_item;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	_tmp0_ = item;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp0_) : NULL);
	expandable_item = _tmp1_;
	_tmp2_ = expandable_item;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		_tmp3_ = expandable_item;
		granite_widgets_source_list_tree_update_expansion (self, _tmp3_);
	}
	_g_object_unref0 (expandable_item);
}


static void _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
	granite_widgets_source_list_tree_spacer_cell_data_func (cell_layout, cell, tree_model, iter);
}


static void granite_widgets_source_list_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListTree* self, gint level, gboolean check_previous) {
	gint _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = level;
	g_return_if_fail (_tmp0_ > 0);
	_tmp1_ = self->priv->spacer_cells;
	if (_tmp1_ == NULL) {
		GeeHashMap* _tmp2_;
		_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
		_g_object_unref0 (self->priv->spacer_cells);
		self->priv->spacer_cells = _tmp2_;
	}
	_tmp3_ = self->priv->spacer_cells;
	_tmp4_ = level;
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp4_));
	if (!_tmp5_) {
		GraniteWidgetsSourceListCellRendererSpacer* _tmp6_;
		GraniteWidgetsSourceListCellRendererSpacer* spacer_cell;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp7_;
		gint _tmp8_;
		GeeHashMap* _tmp9_;
		gint _tmp10_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp11_;
		guint cell_xpadding = 0U;
		gint _tmp12_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp15_;
		guint _tmp16_;
		GtkTreeViewColumn* _tmp17_ = NULL;
		GtkTreeViewColumn* _tmp18_;
		GtkTreeViewColumn* item_column;
		GtkTreeViewColumn* _tmp19_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp20_;
		GtkTreeViewColumn* _tmp21_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp22_;
		gboolean _tmp23_;
		_tmp6_ = granite_widgets_source_list_cell_renderer_spacer_new ();
		g_object_ref_sink (_tmp6_);
		spacer_cell = _tmp6_;
		_tmp7_ = spacer_cell;
		_tmp8_ = level;
		granite_widgets_source_list_cell_renderer_spacer_set_level (_tmp7_, _tmp8_);
		_tmp9_ = self->priv->spacer_cells;
		_tmp10_ = level;
		_tmp11_ = spacer_cell;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) _tmp10_), _tmp11_);
		_tmp12_ = level;
		switch (_tmp12_) {
			case 1:
			{
				gint left_padding = 0;
				gint _tmp13_;
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING, &left_padding, NULL);
				_tmp13_ = left_padding;
				cell_xpadding = (guint) (_tmp13_ / 2);
				break;
			}
			case 2:
			{
				cell_xpadding = (guint) 0;
				break;
			}
			default:
			{
				gint level_indentation = 0;
				gint _tmp14_;
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION, &level_indentation, NULL);
				_tmp14_ = level_indentation;
				cell_xpadding = (guint) (_tmp14_ / 2);
				break;
			}
		}
		_tmp15_ = spacer_cell;
		_tmp16_ = cell_xpadding;
		g_object_set ((GtkCellRenderer*) _tmp15_, "xpad", _tmp16_, NULL);
		_tmp17_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
		_tmp18_ = _g_object_ref0 (_tmp17_);
		item_column = _tmp18_;
		_tmp19_ = item_column;
		_tmp20_ = spacer_cell;
		gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp19_, (GtkCellRenderer*) _tmp20_, FALSE);
		_tmp21_ = item_column;
		_tmp22_ = spacer_cell;
		gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp21_, (GtkCellRenderer*) _tmp22_, _granite_widgets_source_list_tree_spacer_cell_data_func_gtk_cell_layout_data_func, NULL, NULL);
		_tmp23_ = check_previous;
		if (_tmp23_) {
			{
				gint _tmp24_;
				gint i;
				_tmp24_ = level;
				i = _tmp24_ - 1;
				{
					gboolean _tmp25_;
					_tmp25_ = TRUE;
					while (TRUE) {
						gboolean _tmp26_;
						gint _tmp28_;
						gint _tmp29_;
						_tmp26_ = _tmp25_;
						if (!_tmp26_) {
							gint _tmp27_;
							_tmp27_ = i;
							i = _tmp27_ - 1;
						}
						_tmp25_ = FALSE;
						_tmp28_ = i;
						if (!(_tmp28_ > 0)) {
							break;
						}
						_tmp29_ = i;
						granite_widgets_source_list_tree_add_spacer_cell_for_level (self, _tmp29_, FALSE);
					}
				}
			}
		}
		_g_object_unref0 (item_column);
		_g_object_unref0 (spacer_cell);
	}
}


/**
         * Evaluates whether the item at the specified path can be selected or not.
         */
static gboolean granite_widgets_source_list_tree_select_func (GraniteWidgetsSourceListTree* self, GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected) {
	gboolean result = FALSE;
	gboolean selectable;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_ = NULL;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (selection != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	selectable = FALSE;
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = path;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp0_, _tmp1_);
	item = _tmp2_;
	_tmp3_ = item;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListDataModel* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_;
		GtkTreePath* _tmp6_;
		gboolean _tmp7_ = FALSE;
		_tmp4_ = self->priv->_data_model;
		_tmp5_ = item;
		_tmp6_ = path;
		_tmp7_ = granite_widgets_source_list_data_model_is_category (_tmp4_, _tmp5_, NULL, _tmp6_);
		if (!_tmp7_) {
			GraniteWidgetsSourceListItem* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp8_ = item;
			_tmp9_ = granite_widgets_source_list_item_get_selectable (_tmp8_);
			_tmp10_ = _tmp9_;
			selectable = _tmp10_;
		}
	}
	result = selectable;
	_g_object_unref0 (item);
	return result;
}


static void _gtk_tree_path_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL));
}


static void _g_list_free__gtk_tree_path_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _gtk_tree_path_free0_, NULL);
	g_list_free (self);
}


static GtkTreePath* granite_widgets_source_list_tree_get_selected_path (GraniteWidgetsSourceListTree* self) {
	GtkTreePath* result = NULL;
	GtkTreePath* selected_path;
	GtkTreeSelection* _tmp0_ = NULL;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	selected_path = NULL;
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	selection = _tmp1_;
	_tmp2_ = selection;
	if (_tmp2_ != NULL) {
		GtkTreeModel* model = NULL;
		GtkTreeSelection* _tmp3_;
		GtkTreeModel* _tmp4_ = NULL;
		GList* _tmp5_ = NULL;
		GtkTreeModel* _tmp6_;
		GList* selected_rows;
		GList* _tmp7_;
		guint _tmp8_ = 0U;
		_tmp3_ = selection;
		_tmp5_ = gtk_tree_selection_get_selected_rows (_tmp3_, &_tmp4_);
		_g_object_unref0 (model);
		_tmp6_ = _g_object_ref0 (_tmp4_);
		model = _tmp6_;
		selected_rows = _tmp5_;
		_tmp7_ = selected_rows;
		_tmp8_ = g_list_length (_tmp7_);
		if (_tmp8_ == ((guint) 1)) {
			GList* _tmp9_;
			gconstpointer _tmp10_ = NULL;
			GtkTreePath* _tmp11_;
			_tmp9_ = selected_rows;
			_tmp10_ = g_list_nth_data (_tmp9_, (guint) 0);
			_tmp11_ = _gtk_tree_path_copy0 ((GtkTreePath*) _tmp10_);
			_gtk_tree_path_free0 (selected_path);
			selected_path = _tmp11_;
		}
		__g_list_free__gtk_tree_path_free0_0 (selected_rows);
		_g_object_unref0 (model);
	}
	result = selected_path;
	_g_object_unref0 (selection);
	return result;
}


static void granite_widgets_source_list_tree_set_selected (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean scroll_to_item) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = item;
	if (_tmp0_ == NULL) {
		GtkTreeSelection* _tmp1_ = NULL;
		GtkTreeSelection* _tmp2_;
		GtkTreeSelection* selection;
		GtkTreeSelection* _tmp3_;
		_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		selection = _tmp2_;
		_tmp3_ = selection;
		if (_tmp3_ != NULL) {
			GtkTreeSelection* _tmp4_;
			_tmp4_ = selection;
			gtk_tree_selection_unselect_all (_tmp4_);
		}
		_g_object_unref0 (self->priv->selected);
		self->priv->selected = NULL;
		g_signal_emit_by_name (self, "item-selected", NULL);
		_g_object_unref0 (selection);
	} else {
		GraniteWidgetsSourceListItem* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = item;
		_tmp6_ = granite_widgets_source_list_item_get_selectable (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			gboolean _tmp8_;
			GraniteWidgetsSourceListDataModel* _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
			GtkTreePath* _tmp12_ = NULL;
			GtkTreePath* to_select;
			GtkTreePath* _tmp13_;
			_tmp8_ = scroll_to_item;
			if (_tmp8_) {
				GraniteWidgetsSourceListItem* _tmp9_;
				_tmp9_ = item;
				granite_widgets_source_list_tree_scroll_to_item (self, _tmp9_, FALSE, (gfloat) 0);
			}
			_tmp10_ = self->priv->_data_model;
			_tmp11_ = item;
			_tmp12_ = granite_widgets_source_list_data_model_get_item_path (_tmp10_, _tmp11_);
			to_select = _tmp12_;
			_tmp13_ = to_select;
			if (_tmp13_ != NULL) {
				GtkTreePath* _tmp14_;
				GtkTreeViewColumn* _tmp15_ = NULL;
				GtkCellRendererText* _tmp16_;
				_tmp14_ = to_select;
				_tmp15_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
				_tmp16_ = self->priv->text_cell;
				gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp14_, _tmp15_, (GtkCellRenderer*) _tmp16_, FALSE);
			}
			_gtk_tree_path_free0 (to_select);
		}
	}
}


static void granite_widgets_source_list_tree_real_cursor_changed (GtkTreeView* base) {
	GraniteWidgetsSourceListTree * self;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* path;
	GraniteWidgetsSourceListItem* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsSourceListItem* new_item;
	gboolean _tmp8_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp9_;
	gboolean _tmp12_;
	self = (GraniteWidgetsSourceListTree*) base;
	_tmp0_ = granite_widgets_source_list_tree_get_selected_path (self);
	path = _tmp0_;
	_tmp2_ = path;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListDataModel* _tmp3_;
		GtkTreePath* _tmp4_;
		GraniteWidgetsSourceListItem* _tmp5_ = NULL;
		_tmp3_ = self->priv->_data_model;
		_tmp4_ = path;
		_tmp5_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp3_, _tmp4_);
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp5_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	_tmp6_ = _tmp1_;
	_tmp7_ = _g_object_ref0 (_tmp6_);
	new_item = _tmp7_;
	_tmp9_ = new_item;
	if (_tmp9_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp10_;
		GraniteWidgetsSourceListItem* _tmp11_;
		_tmp10_ = new_item;
		_tmp11_ = self->priv->selected;
		_tmp8_ = _tmp10_ != _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp12_ = _tmp8_;
	if (_tmp12_) {
		GraniteWidgetsSourceListItem* _tmp13_;
		GraniteWidgetsSourceListItem* _tmp14_;
		GraniteWidgetsSourceListItem* _tmp15_;
		_tmp13_ = new_item;
		_tmp14_ = _g_object_ref0 (_tmp13_);
		_g_object_unref0 (self->priv->selected);
		self->priv->selected = _tmp14_;
		_tmp15_ = new_item;
		g_signal_emit_by_name (self, "item-selected", _tmp15_);
	}
	_g_object_unref0 (new_item);
	_g_object_unref0 (_tmp1_);
	_gtk_tree_path_free0 (path);
}


static gboolean granite_widgets_source_list_tree_scroll_to_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, gboolean use_align, gfloat row_align) {
	gboolean result = FALSE;
	gboolean scrolled;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GtkTreePath* _tmp2_ = NULL;
	GtkTreePath* path;
	GtkTreePath* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	scrolled = FALSE;
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = item;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, _tmp1_);
	path = _tmp2_;
	_tmp3_ = path;
	if (_tmp3_ != NULL) {
		GtkTreePath* _tmp4_;
		gboolean _tmp5_;
		gfloat _tmp6_;
		_tmp4_ = path;
		_tmp5_ = use_align;
		_tmp6_ = row_align;
		gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp4_, NULL, _tmp5_, _tmp6_, (gfloat) 0);
		scrolled = TRUE;
	}
	result = scrolled;
	_gtk_tree_path_free0 (path);
	return result;
}


static gboolean granite_widgets_source_list_tree_start_editing_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp11_;
	GraniteWidgetsSourceListDataModel* _tmp12_;
	GraniteWidgetsSourceListItem* _tmp13_;
	GtkTreePath* _tmp14_ = NULL;
	GtkTreePath* path;
	GtkTreePath* _tmp15_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_item_get_editable (_tmp0_);
	_tmp2_ = _tmp1_;
	g_return_val_if_fail (_tmp2_, FALSE);
	_tmp3_ = item;
	_tmp4_ = granite_widgets_source_list_item_get_selectable (_tmp3_);
	_tmp5_ = _tmp4_;
	g_return_val_if_fail (_tmp5_, FALSE);
	_tmp7_ = granite_widgets_source_list_tree_get_editing (self);
	_tmp8_ = _tmp7_;
	if (_tmp8_) {
		GraniteWidgetsSourceListItem* _tmp9_;
		GraniteWidgetsSourceListItem* _tmp10_;
		_tmp9_ = item;
		_tmp10_ = self->priv->edited;
		_tmp6_ = _tmp9_ == _tmp10_;
	} else {
		_tmp6_ = FALSE;
	}
	_tmp11_ = _tmp6_;
	if (_tmp11_) {
		result = FALSE;
		return result;
	}
	_tmp12_ = self->priv->_data_model;
	_tmp13_ = item;
	_tmp14_ = granite_widgets_source_list_data_model_get_item_path (_tmp12_, _tmp13_);
	path = _tmp14_;
	_tmp15_ = path;
	if (_tmp15_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp16_;
		GtkCellRendererText* _tmp17_;
		GtkTreePath* _tmp18_;
		GtkTreeViewColumn* _tmp19_ = NULL;
		GtkCellRendererText* _tmp20_;
		_tmp16_ = item;
		self->priv->edited = _tmp16_;
		_tmp17_ = self->priv->text_cell;
		g_object_set (_tmp17_, "editable", TRUE, NULL);
		_tmp18_ = path;
		_tmp19_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
		_tmp20_ = self->priv->text_cell;
		gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp18_, _tmp19_, (GtkCellRenderer*) _tmp20_, TRUE);
	} else {
		GraniteWidgetsSourceListItem* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		_tmp21_ = item;
		_tmp22_ = granite_widgets_source_list_item_get_name (_tmp21_);
		_tmp23_ = _tmp22_;
		g_warning ("SourceList.vala:1479: Could not edit \"%s\": path not found", _tmp23_);
	}
	_tmp24_ = granite_widgets_source_list_tree_get_editing (self);
	_tmp25_ = _tmp24_;
	result = _tmp25_;
	_gtk_tree_path_free0 (path);
	return result;
}


static void granite_widgets_source_list_tree_stop_editing (GraniteWidgetsSourceListTree* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp1_ = granite_widgets_source_list_tree_get_editing (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GraniteWidgetsSourceListItem* _tmp3_;
		_tmp3_ = self->priv->edited;
		_tmp0_ = _tmp3_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = _tmp0_;
	if (_tmp4_) {
		GraniteWidgetsSourceListDataModel* _tmp5_;
		GraniteWidgetsSourceListItem* _tmp6_;
		GtkTreePath* _tmp7_ = NULL;
		GtkTreePath* path;
		GtkTreePath* _tmp8_;
		_tmp5_ = self->priv->_data_model;
		_tmp6_ = self->priv->edited;
		_tmp7_ = granite_widgets_source_list_data_model_get_item_path (_tmp5_, _tmp6_);
		path = _tmp7_;
		_tmp8_ = path;
		if (_tmp8_ != NULL) {
			GtkTreePath* _tmp9_;
			GtkTreeViewColumn* _tmp10_ = NULL;
			GtkCellRendererText* _tmp11_;
			_tmp9_ = path;
			_tmp10_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
			_tmp11_ = self->priv->text_cell;
			gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp9_, _tmp10_, (GtkCellRenderer*) _tmp11_, FALSE);
		}
		_gtk_tree_path_free0 (path);
	}
}


static void _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender, gpointer self) {
	granite_widgets_source_list_tree_on_editing_done (self);
}


static void granite_widgets_source_list_tree_on_editing_started (GraniteWidgetsSourceListTree* self, GtkCellEditable* editable, const gchar* path) {
	GtkCellEditable* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (editable != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = editable;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_ENTRY) ? ((GtkEntry*) _tmp0_) : NULL);
	_g_object_unref0 (self->priv->editable_entry);
	self->priv->editable_entry = _tmp1_;
	_tmp2_ = self->priv->editable_entry;
	if (_tmp2_ != NULL) {
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
		_tmp3_ = self->priv->editable_entry;
		g_signal_connect_object ((GtkCellEditable*) _tmp3_, "editing-done", (GCallback) _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done, self, 0);
		_tmp4_ = self->priv->editable_entry;
		g_object_set (_tmp4_, "editable", TRUE, NULL);
	}
}


static void granite_widgets_source_list_tree_on_editing_canceled (GraniteWidgetsSourceListTree* self) {
	GtkEntry* _tmp0_;
	GtkCellRendererText* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->editable_entry;
	if (_tmp0_ != NULL) {
		GtkEntry* _tmp1_;
		GtkEntry* _tmp2_;
		guint _tmp3_ = 0U;
		_tmp1_ = self->priv->editable_entry;
		g_object_set (_tmp1_, "editable", FALSE, NULL);
		_tmp2_ = self->priv->editable_entry;
		g_signal_parse_name ("editing-done", GTK_TYPE_CELL_EDITABLE, &_tmp3_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GtkCellEditable*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_done_gtk_cell_editable_editing_done, self);
	}
	_tmp4_ = self->priv->text_cell;
	g_object_set (_tmp4_, "editable", FALSE, NULL);
	self->priv->edited = NULL;
}


static void granite_widgets_source_list_tree_on_editing_done (GraniteWidgetsSourceListTree* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp2_;
	gboolean _tmp6_;
	gboolean _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp2_ = self->priv->edited;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->edited;
		_tmp4_ = granite_widgets_source_list_item_get_editable (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	_tmp6_ = _tmp1_;
	if (_tmp6_) {
		GtkEntry* _tmp7_;
		_tmp7_ = self->priv->editable_entry;
		_tmp0_ = _tmp7_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp8_ = _tmp0_;
	if (_tmp8_) {
		GraniteWidgetsSourceListItem* _tmp9_;
		GtkEntry* _tmp10_;
		const gchar* _tmp11_ = NULL;
		_tmp9_ = self->priv->edited;
		_tmp10_ = self->priv->editable_entry;
		_tmp11_ = gtk_entry_get_text (_tmp10_);
		g_signal_emit_by_name (_tmp9_, "edited", _tmp11_);
	}
	granite_widgets_source_list_tree_on_editing_canceled (self);
}


static void granite_widgets_source_list_tree_on_activatable_activated (GraniteWidgetsSourceListTree* self, const gchar* item_path_str) {
	const gchar* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_ = NULL;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceListItem* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item_path_str != NULL);
	_tmp0_ = item_path_str;
	_tmp1_ = granite_widgets_source_list_tree_get_item_from_path_string (self, _tmp0_);
	item = _tmp1_;
	_tmp2_ = item;
	if (_tmp2_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp3_;
		_tmp3_ = item;
		g_signal_emit_by_name (_tmp3_, "action-activated");
	}
	_g_object_unref0 (item);
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_path_string (GraniteWidgetsSourceListTree* self, const gchar* item_path_str) {
	GraniteWidgetsSourceListItem* result = NULL;
	const gchar* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* item_path;
	GraniteWidgetsSourceListDataModel* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (item_path_str != NULL, NULL);
	_tmp0_ = item_path_str;
	_tmp1_ = gtk_tree_path_new_from_string (_tmp0_);
	item_path = _tmp1_;
	_tmp2_ = self->priv->_data_model;
	_tmp3_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp2_, item_path);
	result = _tmp3_;
	_gtk_tree_path_free0 (item_path);
	return result;
}


static gboolean granite_widgets_source_list_tree_toggle_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* item) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (item != NULL, FALSE);
	_tmp0_ = item;
	_tmp1_ = granite_widgets_source_list_expandable_item_get_collapsible (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GraniteWidgetsSourceListExpandableItem* _tmp3_;
		GraniteWidgetsSourceListExpandableItem* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp3_ = item;
		_tmp4_ = item;
		_tmp5_ = granite_widgets_source_list_expandable_item_get_expanded (_tmp4_);
		_tmp6_ = _tmp5_;
		granite_widgets_source_list_expandable_item_set_expanded (_tmp3_, !_tmp6_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


/**
         * Updates the tree to reflect the ''expanded'' property of expandable_item.
         */
static void granite_widgets_source_list_tree_update_expansion (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListExpandableItem* expandable_item) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListExpandableItem* _tmp1_;
	GtkTreePath* _tmp2_ = NULL;
	GtkTreePath* path;
	GtkTreePath* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expandable_item != NULL);
	_tmp0_ = self->priv->_data_model;
	_tmp1_ = expandable_item;
	_tmp2_ = granite_widgets_source_list_data_model_get_item_path (_tmp0_, (GraniteWidgetsSourceListItem*) _tmp1_);
	path = _tmp2_;
	_tmp3_ = path;
	if (_tmp3_ != NULL) {
		GtkTreePath* _tmp4_;
		gint _tmp5_ = 0;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp4_ = path;
		_tmp5_ = gtk_tree_path_get_depth (_tmp4_);
		granite_widgets_source_list_tree_add_spacer_cell_for_level (self, _tmp5_ + 1, TRUE);
		_tmp6_ = expandable_item;
		_tmp7_ = granite_widgets_source_list_expandable_item_get_expanded (_tmp6_);
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			GtkTreePath* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GraniteWidgetsSourceListItem* _tmp11_;
			gboolean _tmp16_;
			_tmp9_ = path;
			gtk_tree_view_expand_row ((GtkTreeView*) self, _tmp9_, FALSE);
			_tmp11_ = self->priv->selected;
			if (_tmp11_ != NULL) {
				GraniteWidgetsSourceListItem* _tmp12_;
				GraniteWidgetsSourceListExpandableItem* _tmp13_;
				GraniteWidgetsSourceListExpandableItem* _tmp14_;
				GraniteWidgetsSourceListExpandableItem* _tmp15_;
				_tmp12_ = self->priv->selected;
				_tmp13_ = granite_widgets_source_list_item_get_parent (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = expandable_item;
				_tmp10_ = _tmp14_ == _tmp15_;
			} else {
				_tmp10_ = FALSE;
			}
			_tmp16_ = _tmp10_;
			if (_tmp16_) {
				GraniteWidgetsSourceListItem* _tmp17_;
				_tmp17_ = self->priv->selected;
				granite_widgets_source_list_tree_set_selected (self, _tmp17_, TRUE);
			}
			{
				GraniteWidgetsSourceListExpandableItem* _tmp18_;
				GeeCollection* _tmp19_;
				GeeCollection* _tmp20_;
				GeeCollection* _tmp21_;
				GeeIterator* _tmp22_ = NULL;
				GeeIterator* _tmp23_;
				GeeIterator* _child_item_it;
				_tmp18_ = expandable_item;
				_tmp19_ = granite_widgets_source_list_expandable_item_get_children (_tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = _tmp20_;
				_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
				_tmp23_ = _tmp22_;
				_g_object_unref0 (_tmp21_);
				_child_item_it = _tmp23_;
				while (TRUE) {
					GeeIterator* _tmp24_;
					gboolean _tmp25_ = FALSE;
					GeeIterator* _tmp26_;
					gpointer _tmp27_ = NULL;
					GraniteWidgetsSourceListItem* child_item;
					GraniteWidgetsSourceListItem* _tmp28_;
					GraniteWidgetsSourceListExpandableItem* _tmp29_;
					GraniteWidgetsSourceListExpandableItem* child_expandable_item;
					GraniteWidgetsSourceListExpandableItem* _tmp30_;
					_tmp24_ = _child_item_it;
					_tmp25_ = gee_iterator_next (_tmp24_);
					if (!_tmp25_) {
						break;
					}
					_tmp26_ = _child_item_it;
					_tmp27_ = gee_iterator_get (_tmp26_);
					child_item = (GraniteWidgetsSourceListItem*) _tmp27_;
					_tmp28_ = child_item;
					_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp28_) : NULL);
					child_expandable_item = _tmp29_;
					_tmp30_ = child_expandable_item;
					if (_tmp30_ != NULL) {
						GraniteWidgetsSourceListExpandableItem* _tmp31_;
						_tmp31_ = child_expandable_item;
						granite_widgets_source_list_tree_update_expansion (self, _tmp31_);
					}
					_g_object_unref0 (child_expandable_item);
					_g_object_unref0 (child_item);
				}
				_g_object_unref0 (_child_item_it);
			}
		} else {
			GtkTreePath* _tmp32_;
			_tmp32_ = path;
			gtk_tree_view_collapse_row ((GtkTreeView*) self, _tmp32_);
		}
	}
	_gtk_tree_path_free0 (path);
}


static void granite_widgets_source_list_tree_real_row_activated (GtkTreeView* base, GtkTreePath* path, GtkTreeViewColumn* column) {
	GraniteWidgetsSourceListTree * self;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_ = NULL;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = column;
	_tmp1_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
	if (_tmp0_ == _tmp1_) {
		GraniteWidgetsSourceListDataModel* _tmp2_;
		GtkTreePath* _tmp3_;
		GraniteWidgetsSourceListItem* _tmp4_ = NULL;
		GraniteWidgetsSourceListItem* item;
		GraniteWidgetsSourceListItem* _tmp5_;
		_tmp2_ = self->priv->_data_model;
		_tmp3_ = path;
		_tmp4_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp2_, _tmp3_);
		item = _tmp4_;
		_tmp5_ = item;
		if (_tmp5_ != NULL) {
			GraniteWidgetsSourceListItem* _tmp6_;
			_tmp6_ = item;
			g_signal_emit_by_name (_tmp6_, "activated");
		}
		_g_object_unref0 (item);
	}
}


static gboolean granite_widgets_source_list_tree_real_key_release_event (GtkWidget* base, GdkEventKey* event) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp1_;
	GdkEventKey _tmp16_;
	gboolean _tmp17_ = FALSE;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = granite_widgets_source_list_tree_get_selected_item (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		GdkEventKey _tmp2_;
		guint _tmp3_;
		_tmp2_ = *event;
		_tmp3_ = _tmp2_.keyval;
		switch (_tmp3_) {
			case GDK_KEY_F2:
			{
				GdkModifierType _tmp4_ = 0;
				GdkModifierType modifiers;
				gboolean _tmp5_ = FALSE;
				GdkEventKey _tmp6_;
				GdkModifierType _tmp7_;
				GdkModifierType _tmp8_;
				gboolean _tmp13_;
				_tmp4_ = gtk_accelerator_get_default_mod_mask ();
				modifiers = _tmp4_;
				_tmp6_ = *event;
				_tmp7_ = _tmp6_.state;
				_tmp8_ = modifiers;
				if ((_tmp7_ & _tmp8_) == 0) {
					GraniteWidgetsSourceListItem* _tmp9_;
					GraniteWidgetsSourceListItem* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
					_tmp9_ = granite_widgets_source_list_tree_get_selected_item (self);
					_tmp10_ = _tmp9_;
					_tmp11_ = granite_widgets_source_list_item_get_editable (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp5_ = _tmp12_;
				} else {
					_tmp5_ = FALSE;
				}
				_tmp13_ = _tmp5_;
				if (_tmp13_) {
					GraniteWidgetsSourceListItem* _tmp14_;
					GraniteWidgetsSourceListItem* _tmp15_;
					_tmp14_ = granite_widgets_source_list_tree_get_selected_item (self);
					_tmp15_ = _tmp14_;
					granite_widgets_source_list_tree_start_editing_item (self, _tmp15_);
				}
				break;
			}
			default:
			break;
		}
	}
	_tmp16_ = *event;
	_tmp17_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_VIEW, GtkTreeView), &_tmp16_);
	result = _tmp17_;
	return result;
}


static gboolean granite_widgets_source_list_tree_real_button_press_event (GtkWidget* base, GdkEventButton* event) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	GdkEventButton _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_ = NULL;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	GdkEventButton _tmp5_;
	gdouble _tmp6_;
	gint x;
	GdkEventButton _tmp7_;
	gdouble _tmp8_;
	gint y;
	gint cell_x = 0;
	gint cell_y = 0;
	gint _tmp9_;
	gint _tmp10_;
	GtkTreePath* _tmp11_ = NULL;
	GtkTreeViewColumn* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gboolean _tmp15_ = FALSE;
	GtkTreeViewColumn* _tmp16_;
	GdkEventButton _tmp97_;
	gboolean _tmp98_ = FALSE;
	self = (GraniteWidgetsSourceListTree*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.window;
	_tmp2_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
	if (_tmp1_ != _tmp2_) {
		GdkEventButton _tmp3_;
		gboolean _tmp4_ = FALSE;
		_tmp3_ = *event;
		_tmp4_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_VIEW, GtkTreeView), &_tmp3_);
		result = _tmp4_;
		return result;
	}
	_tmp5_ = *event;
	_tmp6_ = _tmp5_.x;
	x = (gint) _tmp6_;
	_tmp7_ = *event;
	_tmp8_ = _tmp7_.y;
	y = (gint) _tmp8_;
	_tmp9_ = x;
	_tmp10_ = y;
	_tmp15_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp9_, _tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
	_gtk_tree_path_free0 (path);
	path = _tmp11_;
	_g_object_unref0 (column);
	_tmp16_ = _g_object_ref0 (_tmp12_);
	column = _tmp16_;
	cell_x = _tmp13_;
	cell_y = _tmp14_;
	if (_tmp15_) {
		GraniteWidgetsSourceListDataModel* _tmp17_;
		GtkTreePath* _tmp18_;
		GraniteWidgetsSourceListItem* _tmp19_ = NULL;
		GraniteWidgetsSourceListItem* item;
		GdkRectangle start_cell_area = {0};
		GtkTreePath* _tmp20_;
		GtkTreeViewColumn* _tmp21_ = NULL;
		GdkRectangle _tmp22_ = {0};
		gint _tmp23_;
		GdkRectangle _tmp24_;
		gint _tmp25_;
		gboolean _tmp26_ = FALSE;
		GraniteWidgetsSourceListItem* _tmp27_;
		gboolean _tmp30_;
		_tmp17_ = self->priv->_data_model;
		_tmp18_ = path;
		_tmp19_ = granite_widgets_source_list_data_model_get_item_from_path (_tmp17_, _tmp18_);
		item = _tmp19_;
		_tmp20_ = path;
		_tmp21_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
		gtk_tree_view_get_cell_area ((GtkTreeView*) self, _tmp20_, _tmp21_, &_tmp22_);
		start_cell_area = _tmp22_;
		_tmp23_ = cell_x;
		_tmp24_ = start_cell_area;
		_tmp25_ = _tmp24_.x;
		cell_x = _tmp23_ - _tmp25_;
		_tmp27_ = item;
		if (_tmp27_ != NULL) {
			GtkTreeViewColumn* _tmp28_;
			GtkTreeViewColumn* _tmp29_ = NULL;
			_tmp28_ = column;
			_tmp29_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
			_tmp26_ = _tmp28_ == _tmp29_;
		} else {
			_tmp26_ = FALSE;
		}
		_tmp30_ = _tmp26_;
		if (_tmp30_) {
			gboolean _tmp31_ = FALSE;
			granite_widgets_source_list_tree_stop_editing (self);
			_tmp31_ = gdk_event_triggers_context_menu ((GdkEvent*) (event));
			if (_tmp31_) {
				GraniteWidgetsSourceListItem* _tmp32_;
				GdkEventButton _tmp33_;
				_tmp32_ = item;
				_tmp33_ = *event;
				granite_widgets_source_list_tree_popup_context_menu (self, _tmp32_, &_tmp33_);
			} else {
				GdkEventButton _tmp34_;
				guint _tmp35_;
				_tmp34_ = *event;
				_tmp35_ = _tmp34_.button;
				if (_tmp35_ == ((guint) GDK_BUTTON_PRIMARY)) {
					GraniteWidgetsSourceListItem* _tmp36_;
					gboolean is_expandable;
					gboolean _tmp37_ = FALSE;
					gboolean _tmp38_;
					gboolean _tmp43_;
					gboolean is_category;
					GdkEventButton _tmp44_;
					GdkEventType _tmp45_;
					_tmp36_ = item;
					is_expandable = G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM);
					_tmp38_ = is_expandable;
					if (_tmp38_) {
						GraniteWidgetsSourceListDataModel* _tmp39_;
						GraniteWidgetsSourceListItem* _tmp40_;
						GtkTreePath* _tmp41_;
						gboolean _tmp42_ = FALSE;
						_tmp39_ = self->priv->_data_model;
						_tmp40_ = item;
						_tmp41_ = path;
						_tmp42_ = granite_widgets_source_list_data_model_is_category (_tmp39_, _tmp40_, NULL, _tmp41_);
						_tmp37_ = _tmp42_;
					} else {
						_tmp37_ = FALSE;
					}
					_tmp43_ = _tmp37_;
					is_category = _tmp43_;
					_tmp44_ = *event;
					_tmp45_ = _tmp44_.type;
					if (_tmp45_ == GDK_BUTTON_PRESS) {
						gboolean _tmp46_;
						_tmp46_ = is_expandable;
						if (_tmp46_) {
							gboolean _tmp47_ = FALSE;
							gboolean _tmp48_ = FALSE;
							gboolean _tmp49_;
							gboolean _tmp54_;
							gboolean _tmp65_;
							gboolean expander_clicked;
							gboolean _tmp66_ = FALSE;
							gboolean _tmp67_;
							gboolean _tmp70_;
							_tmp49_ = is_category;
							if (_tmp49_) {
								_tmp48_ = TRUE;
							} else {
								GtkTreeViewColumn* _tmp50_;
								GtkTreePath* _tmp51_;
								gint _tmp52_;
								gboolean _tmp53_ = FALSE;
								_tmp50_ = column;
								_tmp51_ = path;
								_tmp52_ = cell_x;
								_tmp53_ = granite_widgets_source_list_tree_over_primary_expander (self, _tmp50_, _tmp51_, _tmp52_);
								_tmp48_ = _tmp53_;
							}
							_tmp54_ = _tmp48_;
							if (_tmp54_) {
								_tmp47_ = TRUE;
							} else {
								gboolean _tmp55_ = FALSE;
								GraniteWidgetsSourceListItem* _tmp56_;
								gboolean _tmp57_;
								gboolean _tmp58_;
								gboolean _tmp64_;
								_tmp56_ = item;
								_tmp57_ = granite_widgets_source_list_item_get_selectable (_tmp56_);
								_tmp58_ = _tmp57_;
								if (!_tmp58_) {
									GtkTreeViewColumn* _tmp59_;
									GtkTreePath* _tmp60_;
									GraniteWidgetsSourceListCellRendererIcon* _tmp61_;
									gint _tmp62_;
									gboolean _tmp63_ = FALSE;
									_tmp59_ = column;
									_tmp60_ = path;
									_tmp61_ = self->priv->activatable_cell;
									_tmp62_ = cell_x;
									_tmp63_ = granite_widgets_source_list_tree_over_cell (self, _tmp59_, _tmp60_, (GtkCellRenderer*) _tmp61_, _tmp62_);
									_tmp55_ = !_tmp63_;
								} else {
									_tmp55_ = FALSE;
								}
								_tmp64_ = _tmp55_;
								_tmp47_ = _tmp64_;
							}
							_tmp65_ = _tmp47_;
							expander_clicked = _tmp65_;
							_tmp67_ = expander_clicked;
							if (_tmp67_) {
								GraniteWidgetsSourceListItem* _tmp68_;
								gboolean _tmp69_ = FALSE;
								_tmp68_ = item;
								_tmp69_ = granite_widgets_source_list_tree_toggle_expansion (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp68_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp68_) : NULL);
								_tmp66_ = _tmp69_;
							} else {
								_tmp66_ = FALSE;
							}
							_tmp70_ = _tmp66_;
							if (_tmp70_) {
								result = TRUE;
								_g_object_unref0 (item);
								_g_object_unref0 (column);
								_gtk_tree_path_free0 (path);
								return result;
							}
						}
					} else {
						gboolean _tmp71_ = FALSE;
						gboolean _tmp72_ = FALSE;
						gboolean _tmp73_ = FALSE;
						gboolean _tmp74_ = FALSE;
						gboolean _tmp75_ = FALSE;
						GdkEventButton _tmp76_;
						GdkEventType _tmp77_;
						gboolean _tmp79_;
						gboolean _tmp83_;
						gboolean _tmp87_;
						gboolean _tmp93_;
						gboolean _tmp96_;
						_tmp76_ = *event;
						_tmp77_ = _tmp76_.type;
						if (_tmp77_ == GDK_2BUTTON_PRESS) {
							gboolean _tmp78_;
							_tmp78_ = is_category;
							_tmp75_ = !_tmp78_;
						} else {
							_tmp75_ = FALSE;
						}
						_tmp79_ = _tmp75_;
						if (_tmp79_) {
							GraniteWidgetsSourceListItem* _tmp80_;
							gboolean _tmp81_;
							gboolean _tmp82_;
							_tmp80_ = item;
							_tmp81_ = granite_widgets_source_list_item_get_editable (_tmp80_);
							_tmp82_ = _tmp81_;
							_tmp74_ = _tmp82_;
						} else {
							_tmp74_ = FALSE;
						}
						_tmp83_ = _tmp74_;
						if (_tmp83_) {
							GraniteWidgetsSourceListItem* _tmp84_;
							gboolean _tmp85_;
							gboolean _tmp86_;
							_tmp84_ = item;
							_tmp85_ = granite_widgets_source_list_item_get_selectable (_tmp84_);
							_tmp86_ = _tmp85_;
							_tmp73_ = _tmp86_;
						} else {
							_tmp73_ = FALSE;
						}
						_tmp87_ = _tmp73_;
						if (_tmp87_) {
							GtkTreeViewColumn* _tmp88_;
							GtkTreePath* _tmp89_;
							GtkCellRendererText* _tmp90_;
							gint _tmp91_;
							gboolean _tmp92_ = FALSE;
							_tmp88_ = column;
							_tmp89_ = path;
							_tmp90_ = self->priv->text_cell;
							_tmp91_ = cell_x;
							_tmp92_ = granite_widgets_source_list_tree_over_cell (self, _tmp88_, _tmp89_, (GtkCellRenderer*) _tmp90_, _tmp91_);
							_tmp72_ = _tmp92_;
						} else {
							_tmp72_ = FALSE;
						}
						_tmp93_ = _tmp72_;
						if (_tmp93_) {
							GraniteWidgetsSourceListItem* _tmp94_;
							gboolean _tmp95_ = FALSE;
							_tmp94_ = item;
							_tmp95_ = granite_widgets_source_list_tree_start_editing_item (self, _tmp94_);
							_tmp71_ = _tmp95_;
						} else {
							_tmp71_ = FALSE;
						}
						_tmp96_ = _tmp71_;
						if (_tmp96_) {
							result = TRUE;
							_g_object_unref0 (item);
							_g_object_unref0 (column);
							_gtk_tree_path_free0 (path);
							return result;
						}
					}
				}
			}
		}
		_g_object_unref0 (item);
	}
	_tmp97_ = *event;
	_tmp98_ = GTK_WIDGET_CLASS (granite_widgets_source_list_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TREE_VIEW, GtkTreeView), &_tmp97_);
	result = _tmp98_;
	_g_object_unref0 (column);
	_gtk_tree_path_free0 (path);
	return result;
}


static gboolean granite_widgets_source_list_tree_over_primary_expander (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, gint x) {
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	GtkTreeViewColumn* _tmp5_;
	GraniteWidgetsCellRendererExpander* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeModel* _tmp8_;
	GtkTreeIter _tmp9_;
	GraniteWidgetsCellRendererExpander* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkTreeModel* _tmp13_;
	GtkTreeModel* _tmp14_;
	GtkTreeIter _tmp15_;
	gint _tmp16_ = 0;
	GtkTreePath* _tmp17_;
	gint _tmp18_ = 0;
	gint indentation_level;
	GeeHashMap* _tmp19_;
	gint _tmp20_;
	gpointer _tmp21_ = NULL;
	GraniteWidgetsSourceListCellRendererSpacer* last_spacer_cell;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp22_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (col != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = path;
	_tmp4_ = gtk_tree_model_get_iter (_tmp1_, &_tmp3_, _tmp2_);
	iter = _tmp3_;
	if (!_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = col;
	_tmp6_ = self->priv->primary_expander_cell;
	_tmp7_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp8_ = _tmp7_;
	_tmp9_ = iter;
	granite_widgets_source_list_tree_expander_cell_data_func (self, (GtkCellLayout*) _tmp5_, (GtkCellRenderer*) _tmp6_, _tmp8_, &_tmp9_);
	_tmp10_ = self->priv->primary_expander_cell;
	_tmp11_ = gtk_cell_renderer_get_visible ((GtkCellRenderer*) _tmp10_);
	_tmp12_ = _tmp11_;
	if (!_tmp12_) {
		result = FALSE;
		return result;
	}
	_tmp13_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp14_ = _tmp13_;
	_tmp15_ = iter;
	_tmp16_ = gtk_tree_model_iter_n_children (_tmp14_, &_tmp15_);
	if (_tmp16_ < 1) {
		result = FALSE;
		return result;
	}
	_tmp17_ = path;
	_tmp18_ = gtk_tree_path_get_depth (_tmp17_);
	indentation_level = _tmp18_;
	_tmp19_ = self->priv->spacer_cells;
	_tmp20_ = indentation_level;
	_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
	last_spacer_cell = (GraniteWidgetsSourceListCellRendererSpacer*) _tmp21_;
	_tmp22_ = last_spacer_cell;
	if (_tmp22_ != NULL) {
		gint cell_x = 0;
		gint cell_width = 0;
		GtkTreeViewColumn* _tmp23_;
		GraniteWidgetsSourceListCellRendererSpacer* _tmp24_;
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
		gboolean _tmp27_ = FALSE;
		_tmp23_ = col;
		_tmp24_ = last_spacer_cell;
		_tmp27_ = gtk_tree_view_column_cell_get_position (_tmp23_, (GtkCellRenderer*) _tmp24_, &_tmp25_, &_tmp26_);
		cell_x = _tmp25_;
		cell_width = _tmp26_;
		if (_tmp27_) {
			GraniteWidgetsCellRendererExpander* _tmp28_;
			gint _tmp29_ = 0;
			gint expander_width;
			gboolean _tmp30_ = FALSE;
			gboolean _tmp40_ = FALSE;
			gint _tmp41_;
			gint _tmp42_;
			gboolean _tmp46_;
			_tmp28_ = self->priv->primary_expander_cell;
			_tmp29_ = granite_widgets_source_list_tree_get_cell_width (self, (GtkCellRenderer*) _tmp28_);
			expander_width = _tmp29_ + 1;
			_tmp30_ = granite_widgets_utils_is_left_to_right ((GtkWidget*) self);
			if (_tmp30_) {
				gint _tmp31_;
				gint _tmp32_;
				gint indentation_offset;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
				gint _tmp35_;
				gboolean _tmp39_;
				_tmp31_ = cell_x;
				_tmp32_ = cell_width;
				indentation_offset = _tmp31_ + _tmp32_;
				_tmp34_ = x;
				_tmp35_ = indentation_offset;
				if (_tmp34_ >= _tmp35_) {
					gint _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
					_tmp36_ = x;
					_tmp37_ = indentation_offset;
					_tmp38_ = expander_width;
					_tmp33_ = _tmp36_ <= (_tmp37_ + _tmp38_);
				} else {
					_tmp33_ = FALSE;
				}
				_tmp39_ = _tmp33_;
				result = _tmp39_;
				_g_object_unref0 (last_spacer_cell);
				return result;
			}
			_tmp41_ = x;
			_tmp42_ = cell_x;
			if (_tmp41_ <= _tmp42_) {
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp45_;
				_tmp43_ = x;
				_tmp44_ = cell_x;
				_tmp45_ = expander_width;
				_tmp40_ = _tmp43_ >= (_tmp44_ - _tmp45_);
			} else {
				_tmp40_ = FALSE;
			}
			_tmp46_ = _tmp40_;
			result = _tmp46_;
			_g_object_unref0 (last_spacer_cell);
			return result;
		}
	}
	result = FALSE;
	_g_object_unref0 (last_spacer_cell);
	return result;
}


static gboolean granite_widgets_source_list_tree_over_cell (GraniteWidgetsSourceListTree* self, GtkTreeViewColumn* col, GtkTreePath* path, GtkCellRenderer* cell, gint x) {
	gboolean result = FALSE;
	gint cell_x = 0;
	gint cell_width = 0;
	GtkTreeViewColumn* _tmp0_;
	GtkCellRenderer* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gboolean found;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	gboolean _tmp10_;
	gboolean _tmp14_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (col != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (cell != NULL, FALSE);
	_tmp0_ = col;
	_tmp1_ = cell;
	_tmp4_ = gtk_tree_view_column_cell_get_position (_tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
	cell_x = _tmp2_;
	cell_width = _tmp3_;
	found = _tmp4_;
	_tmp7_ = found;
	if (_tmp7_) {
		gint _tmp8_;
		gint _tmp9_;
		_tmp8_ = x;
		_tmp9_ = cell_x;
		_tmp6_ = _tmp8_ > _tmp9_;
	} else {
		_tmp6_ = FALSE;
	}
	_tmp10_ = _tmp6_;
	if (_tmp10_) {
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp11_ = x;
		_tmp12_ = cell_x;
		_tmp13_ = cell_width;
		_tmp5_ = _tmp11_ < (_tmp12_ + _tmp13_);
	} else {
		_tmp5_ = FALSE;
	}
	_tmp14_ = _tmp5_;
	result = _tmp14_;
	return result;
}


static gint granite_widgets_source_list_tree_get_cell_width (GraniteWidgetsSourceListTree* self, GtkCellRenderer* cell_renderer) {
	gint result = 0;
	GtkRequisition min_req = {0};
	GtkCellRenderer* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (cell_renderer != NULL, 0);
	_tmp0_ = cell_renderer;
	gtk_cell_renderer_get_preferred_size (_tmp0_, (GtkWidget*) self, &_tmp1_, NULL);
	min_req = _tmp1_;
	_tmp2_ = min_req;
	_tmp3_ = _tmp2_.width;
	result = _tmp3_;
	return result;
}


static gboolean granite_widgets_source_list_tree_real_popup_menu (GtkWidget* base) {
	GraniteWidgetsSourceListTree * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (GraniteWidgetsSourceListTree*) base;
	_tmp0_ = granite_widgets_source_list_tree_popup_context_menu (self, NULL, NULL);
	result = _tmp0_;
	return result;
}


static void _granite_widgets_source_list_tree_menu_position_func_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	granite_widgets_source_list_tree_menu_position_func (self, menu, x, y, push_in);
}


static gboolean granite_widgets_source_list_tree_popup_context_menu (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* item, GdkEventButton* event) {
	gboolean result = FALSE;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceListItem* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = item;
	if (_tmp0_ == NULL) {
		GraniteWidgetsSourceListItem* _tmp1_;
		GraniteWidgetsSourceListItem* _tmp2_;
		_tmp1_ = granite_widgets_source_list_tree_get_selected_item (self);
		_tmp2_ = _tmp1_;
		item = _tmp2_;
	}
	_tmp3_ = item;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp4_;
		GtkMenu* _tmp5_ = NULL;
		GtkMenu* menu;
		GtkMenu* _tmp6_;
		_tmp4_ = item;
		_tmp5_ = granite_widgets_source_list_item_get_context_menu (_tmp4_);
		menu = _tmp5_;
		_tmp6_ = menu;
		if (_tmp6_ != NULL) {
			guint32 _tmp7_ = 0U;
			GdkEventButton* _tmp8_;
			guint32 _tmp12_;
			guint32 time;
			guint _tmp13_ = 0U;
			GdkEventButton* _tmp14_;
			guint _tmp17_;
			guint button;
			GtkMenu* _tmp18_;
			GdkEventButton* _tmp19_;
			_tmp8_ = event;
			if (_tmp8_ != NULL) {
				GdkEventButton* _tmp9_;
				guint32 _tmp10_;
				_tmp9_ = event;
				_tmp10_ = (*_tmp9_).time;
				_tmp7_ = _tmp10_;
			} else {
				guint32 _tmp11_ = 0U;
				_tmp11_ = gtk_get_current_event_time ();
				_tmp7_ = _tmp11_;
			}
			_tmp12_ = _tmp7_;
			time = _tmp12_;
			_tmp14_ = event;
			if (_tmp14_ != NULL) {
				GdkEventButton* _tmp15_;
				guint _tmp16_;
				_tmp15_ = event;
				_tmp16_ = (*_tmp15_).button;
				_tmp13_ = _tmp16_;
			} else {
				_tmp13_ = (guint) 0;
			}
			_tmp17_ = _tmp13_;
			button = _tmp17_;
			_tmp18_ = menu;
			gtk_menu_attach_to_widget (_tmp18_, (GtkWidget*) self, NULL);
			_tmp19_ = event;
			if (_tmp19_ != NULL) {
				GtkMenu* _tmp20_;
				guint _tmp21_;
				guint32 _tmp22_;
				_tmp20_ = menu;
				_tmp21_ = button;
				_tmp22_ = time;
				gtk_menu_popup (_tmp20_, NULL, NULL, NULL, NULL, _tmp21_, _tmp22_);
			} else {
				GtkMenu* _tmp23_;
				guint _tmp24_;
				guint32 _tmp25_;
				GtkMenu* _tmp26_;
				_tmp23_ = menu;
				_tmp24_ = button;
				_tmp25_ = time;
				gtk_menu_popup (_tmp23_, NULL, NULL, _granite_widgets_source_list_tree_menu_position_func_gtk_menu_position_func, self, _tmp24_, _tmp25_);
				_tmp26_ = menu;
				gtk_menu_shell_select_first ((GtkMenuShell*) _tmp26_, FALSE);
			}
			result = TRUE;
			_g_object_unref0 (menu);
			return result;
		}
		_g_object_unref0 (menu);
	}
	result = FALSE;
	return result;
}


/**
         * Positions a menu based on an item's coordinates.
         *
         * This function is only used for menu pop-ups triggered by events other than button
         * presses (e.g. key-press events). Since such events provide no coordinates, it is
         * assumed that the item in question is the one currently selected.
         */
static void granite_widgets_source_list_tree_menu_position_func (GraniteWidgetsSourceListTree* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListItem* _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_;
	gboolean _tmp5_;
	GraniteWidgetsSourceListDataModel* _tmp6_;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsSourceListItem* _tmp8_;
	GtkTreePath* _tmp9_ = NULL;
	GtkTreePath* path;
	GtkTreePath* _tmp10_;
	GdkRectangle item_bin_coords = {0};
	GtkTreePath* _tmp11_;
	GtkTreeViewColumn* _tmp12_ = NULL;
	GdkRectangle _tmp13_ = {0};
	GdkRectangle _tmp14_;
	gint _tmp15_;
	GdkRectangle _tmp16_;
	gint _tmp17_;
	gint item_y;
	GdkRectangle _tmp18_;
	gint _tmp19_;
	gint item_x;
	gboolean _tmp20_ = FALSE;
	gboolean is_ltr;
	gboolean _tmp21_;
	gint widget_x = 0;
	gint widget_y = 0;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	GdkWindow* _tmp29_ = NULL;
	gint _tmp30_ = 0;
	gint _tmp31_ = 0;
	gint _tmp32_;
	gint _tmp33_;
	gint _tmp34_ = 0;
	gint _tmp35_ = 0;
	gint _tmp36_;
	gint _tmp37_;
	gint _tmp38_ = 0;
	gint _tmp39_ = 0;
	gboolean _tmp40_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_vala_push_in = TRUE;
	_vala_y = 0;
	_tmp0_ = _vala_y;
	_vala_x = _tmp0_;
	_tmp2_ = granite_widgets_source_list_tree_get_selected_item (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp4_ = FALSE;
		_tmp4_ = gtk_widget_get_realized ((GtkWidget*) self);
		_tmp1_ = !_tmp4_;
	}
	_tmp5_ = _tmp1_;
	if (_tmp5_) {
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		if (push_in) {
			*push_in = _vala_push_in;
		}
		return;
	}
	_tmp6_ = self->priv->_data_model;
	_tmp7_ = granite_widgets_source_list_tree_get_selected_item (self);
	_tmp8_ = _tmp7_;
	_tmp9_ = granite_widgets_source_list_data_model_get_item_path (_tmp6_, _tmp8_);
	path = _tmp9_;
	_tmp10_ = path;
	if (_tmp10_ == NULL) {
		_gtk_tree_path_free0 (path);
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		if (push_in) {
			*push_in = _vala_push_in;
		}
		return;
	}
	_tmp11_ = path;
	_tmp12_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_TREE_COLUMN_ITEM);
	gtk_tree_view_get_cell_area ((GtkTreeView*) self, _tmp11_, _tmp12_, &_tmp13_);
	item_bin_coords = _tmp13_;
	_tmp14_ = item_bin_coords;
	_tmp15_ = _tmp14_.y;
	_tmp16_ = item_bin_coords;
	_tmp17_ = _tmp16_.height;
	item_y = _tmp15_ + (_tmp17_ / 2);
	_tmp18_ = item_bin_coords;
	_tmp19_ = _tmp18_.x;
	item_x = _tmp19_;
	_tmp20_ = granite_widgets_utils_is_left_to_right ((GtkWidget*) self);
	is_ltr = _tmp20_;
	_tmp21_ = is_ltr;
	if (_tmp21_) {
		gint _tmp22_;
		GdkRectangle _tmp23_;
		gint _tmp24_;
		_tmp22_ = item_x;
		_tmp23_ = item_bin_coords;
		_tmp24_ = _tmp23_.width;
		item_x = _tmp22_ + (_tmp24_ - 6);
	}
	_tmp25_ = item_x;
	_tmp26_ = item_y;
	gtk_tree_view_convert_bin_window_to_widget_coords ((GtkTreeView*) self, _tmp25_, _tmp26_, &_tmp27_, &_tmp28_);
	widget_x = _tmp27_;
	widget_y = _tmp28_;
	_tmp29_ = gtk_widget_get_window ((GtkWidget*) self);
	gdk_window_get_origin (_tmp29_, &_tmp30_, &_tmp31_);
	_vala_x = _tmp30_;
	_vala_y = _tmp31_;
	_tmp32_ = _vala_x;
	_tmp33_ = widget_x;
	_tmp34_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp35_ = CLAMP (_tmp33_, 0, _tmp34_);
	_vala_x = _tmp32_ + _tmp35_;
	_tmp36_ = _vala_y;
	_tmp37_ = widget_y;
	_tmp38_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	_tmp39_ = CLAMP (_tmp37_, 0, _tmp38_);
	_vala_y = _tmp36_ + _tmp39_;
	_tmp40_ = is_ltr;
	if (!_tmp40_) {
		GtkRequisition menu_req = {0};
		GtkMenu* _tmp41_;
		GtkRequisition _tmp42_ = {0};
		gint _tmp43_;
		GtkRequisition _tmp44_;
		gint _tmp45_;
		_tmp41_ = menu;
		gtk_widget_get_preferred_size ((GtkWidget*) _tmp41_, &_tmp42_, NULL);
		menu_req = _tmp42_;
		_tmp43_ = _vala_y;
		_tmp44_ = menu_req;
		_tmp45_ = _tmp44_.width;
		_vala_y = _tmp43_ - _tmp45_;
	}
	_gtk_tree_path_free0 (path);
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (push_in) {
		*push_in = _vala_push_in;
	}
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_item_from_model (GtkTreeModel* model, GtkTreeIter* iter) {
	GraniteWidgetsSourceListItem* result = NULL;
	GtkTreeModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	GraniteWidgetsSourceListDataModel* data_model;
	GtkTreeIter _tmp2_;
	GraniteWidgetsSourceListItem* _tmp3_ = NULL;
	g_return_val_if_fail (model != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = model;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL) ? ((GraniteWidgetsSourceListDataModel*) _tmp0_) : NULL);
	data_model = _tmp1_;
	_vala_assert (data_model != NULL, "data_model != null");
	_tmp2_ = *iter;
	_tmp3_ = granite_widgets_source_list_data_model_get_item (data_model, &_tmp2_);
	result = _tmp3_;
	_g_object_unref0 (data_model);
	return result;
}


static void granite_widgets_source_list_tree_spacer_cell_data_func (GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GtkCellRenderer* _tmp0_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp1_;
	GraniteWidgetsSourceListCellRendererSpacer* spacer;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp2_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	GtkTreePath* _tmp8_ = NULL;
	GtkTreePath* path;
	gint level;
	GtkTreePath* _tmp9_;
	GtkCellRenderer* _tmp12_;
	GraniteWidgetsSourceListCellRendererSpacer* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_SPACER) ? ((GraniteWidgetsSourceListCellRendererSpacer*) _tmp0_) : NULL);
	spacer = _tmp1_;
	_tmp2_ = spacer;
	_vala_assert (_tmp2_ != NULL, "spacer != null");
	_tmp3_ = spacer;
	_tmp4_ = granite_widgets_source_list_cell_renderer_spacer_get_level (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_assert (_tmp5_ > 0, "spacer.level > 0");
	_tmp6_ = model;
	_tmp7_ = *iter;
	_tmp8_ = gtk_tree_model_get_path (_tmp6_, &_tmp7_);
	path = _tmp8_;
	level = -1;
	_tmp9_ = path;
	if (_tmp9_ != NULL) {
		GtkTreePath* _tmp10_;
		gint _tmp11_ = 0;
		_tmp10_ = path;
		_tmp11_ = gtk_tree_path_get_depth (_tmp10_);
		level = _tmp11_;
	}
	_tmp12_ = renderer;
	_tmp13_ = spacer;
	_tmp14_ = granite_widgets_source_list_cell_renderer_spacer_get_level (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = level;
	gtk_cell_renderer_set_visible (_tmp12_, _tmp15_ <= _tmp16_);
	_gtk_tree_path_free0 (path);
	_g_object_unref0 (spacer);
}


static void granite_widgets_source_list_tree_name_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GtkCellRenderer* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkCellRendererText* text_renderer;
	GtkCellRendererText* _tmp2_;
	GString* _tmp3_;
	GString* text;
	PangoWeight weight;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_ = NULL;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceListItem* _tmp7_;
	GtkCellRendererText* _tmp16_;
	PangoWeight _tmp17_;
	GtkCellRendererText* _tmp18_;
	GString* _tmp19_;
	const gchar* _tmp20_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_CELL_RENDERER_TEXT) ? ((GtkCellRendererText*) _tmp0_) : NULL);
	text_renderer = _tmp1_;
	_tmp2_ = text_renderer;
	_vala_assert (_tmp2_ != NULL, "text_renderer != null");
	_tmp3_ = g_string_new ("");
	text = _tmp3_;
	weight = PANGO_WEIGHT_NORMAL;
	_tmp4_ = model;
	_tmp5_ = *iter;
	_tmp6_ = granite_widgets_source_list_tree_get_item_from_model (_tmp4_, &_tmp5_);
	item = _tmp6_;
	_tmp7_ = item;
	if (_tmp7_ != NULL) {
		GString* _tmp8_;
		GraniteWidgetsSourceListItem* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GraniteWidgetsSourceListDataModel* _tmp12_;
		GraniteWidgetsSourceListItem* _tmp13_;
		GtkTreeIter _tmp14_;
		gboolean _tmp15_ = FALSE;
		_tmp8_ = text;
		_tmp9_ = item;
		_tmp10_ = granite_widgets_source_list_item_get_name (_tmp9_);
		_tmp11_ = _tmp10_;
		g_string_append (_tmp8_, _tmp11_);
		_tmp12_ = self->priv->_data_model;
		_tmp13_ = item;
		_tmp14_ = *iter;
		_tmp15_ = granite_widgets_source_list_data_model_is_category (_tmp12_, _tmp13_, &_tmp14_, NULL);
		if (_tmp15_) {
			weight = PANGO_WEIGHT_BOLD;
		}
	}
	_tmp16_ = text_renderer;
	_tmp17_ = weight;
	g_object_set (_tmp16_, "weight", (gint) _tmp17_, NULL);
	_tmp18_ = text_renderer;
	_tmp19_ = text;
	_tmp20_ = _tmp19_->str;
	g_object_set (_tmp18_, "text", _tmp20_, NULL);
	_g_object_unref0 (item);
	_g_string_free0 (text);
	_g_object_unref0 (text_renderer);
}


static void granite_widgets_source_list_tree_badge_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GtkCellRenderer* _tmp0_;
	GraniteWidgetsCellRendererBadge* _tmp1_;
	GraniteWidgetsCellRendererBadge* badge_renderer;
	GraniteWidgetsCellRendererBadge* _tmp2_;
	gchar* _tmp3_;
	gchar* text;
	gboolean visible;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	GraniteWidgetsSourceListItem* _tmp6_ = NULL;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceListItem* _tmp7_;
	GraniteWidgetsCellRendererBadge* _tmp29_;
	gboolean _tmp30_;
	GraniteWidgetsCellRendererBadge* _tmp31_;
	const gchar* _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE) ? ((GraniteWidgetsCellRendererBadge*) _tmp0_) : NULL);
	badge_renderer = _tmp1_;
	_tmp2_ = badge_renderer;
	_vala_assert (_tmp2_ != NULL, "badge_renderer != null");
	_tmp3_ = g_strdup ("");
	text = _tmp3_;
	visible = FALSE;
	_tmp4_ = model;
	_tmp5_ = *iter;
	_tmp6_ = granite_widgets_source_list_tree_get_item_from_model (_tmp4_, &_tmp5_);
	item = _tmp6_;
	_tmp7_ = item;
	if (_tmp7_ != NULL) {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		GraniteWidgetsSourceListDataModel* _tmp10_;
		GraniteWidgetsSourceListItem* _tmp11_;
		GtkTreeIter _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp17_;
		gboolean _tmp23_;
		gboolean _tmp24_;
		_tmp10_ = self->priv->_data_model;
		_tmp11_ = item;
		_tmp12_ = *iter;
		_tmp13_ = granite_widgets_source_list_data_model_is_category (_tmp10_, _tmp11_, &_tmp12_, NULL);
		if (!_tmp13_) {
			GraniteWidgetsSourceListItem* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			_tmp14_ = item;
			_tmp15_ = granite_widgets_source_list_item_get_badge (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp9_ = _tmp16_ != NULL;
		} else {
			_tmp9_ = FALSE;
		}
		_tmp17_ = _tmp9_;
		if (_tmp17_) {
			GraniteWidgetsSourceListItem* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_ = NULL;
			gchar* _tmp22_;
			_tmp18_ = item;
			_tmp19_ = granite_widgets_source_list_item_get_badge (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = string_strip (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp8_ = g_strcmp0 (_tmp22_, "") != 0;
			_g_free0 (_tmp22_);
		} else {
			_tmp8_ = FALSE;
		}
		_tmp23_ = _tmp8_;
		visible = _tmp23_;
		_tmp24_ = visible;
		if (_tmp24_) {
			GraniteWidgetsSourceListItem* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			_tmp25_ = item;
			_tmp26_ = granite_widgets_source_list_item_get_badge (_tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strdup (_tmp27_);
			_g_free0 (text);
			text = _tmp28_;
		}
	}
	_tmp29_ = badge_renderer;
	_tmp30_ = visible;
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp29_, _tmp30_);
	_tmp31_ = badge_renderer;
	_tmp32_ = text;
	granite_widgets_cell_renderer_badge_set_text (_tmp31_, _tmp32_);
	_g_object_unref0 (item);
	_g_free0 (text);
	_g_object_unref0 (badge_renderer);
}


static void granite_widgets_source_list_tree_icon_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GtkCellRenderer* _tmp0_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp1_;
	GraniteWidgetsSourceListCellRendererIcon* icon_renderer;
	GraniteWidgetsSourceListCellRendererIcon* _tmp2_;
	gboolean visible;
	GIcon* icon;
	GtkTreeModel* _tmp3_;
	GtkTreeIter _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_ = NULL;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceListItem* _tmp6_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_;
	gboolean _tmp27_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp28_;
	gboolean _tmp29_;
	GIcon* _tmp30_ = NULL;
	gboolean _tmp31_;
	GraniteWidgetsSourceListCellRendererIcon* _tmp33_;
	GIcon* _tmp34_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = renderer;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_CELL_RENDERER_ICON) ? ((GraniteWidgetsSourceListCellRendererIcon*) _tmp0_) : NULL);
	icon_renderer = _tmp1_;
	_tmp2_ = icon_renderer;
	_vala_assert (_tmp2_ != NULL, "icon_renderer != null");
	visible = FALSE;
	icon = NULL;
	_tmp3_ = model;
	_tmp4_ = *iter;
	_tmp5_ = granite_widgets_source_list_tree_get_item_from_model (_tmp3_, &_tmp4_);
	item = _tmp5_;
	_tmp6_ = item;
	if (_tmp6_ != NULL) {
		GraniteWidgetsSourceListDataModel* _tmp7_;
		GraniteWidgetsSourceListItem* _tmp8_;
		GtkTreeIter _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_;
		_tmp7_ = self->priv->_data_model;
		_tmp8_ = item;
		_tmp9_ = *iter;
		_tmp10_ = granite_widgets_source_list_data_model_is_category (_tmp7_, _tmp8_, &_tmp9_, NULL);
		visible = !_tmp10_;
		_tmp11_ = visible;
		if (_tmp11_) {
			GraniteWidgetsSourceListCellRendererIcon* _tmp12_;
			GraniteWidgetsSourceListCellRendererIcon* _tmp13_;
			_tmp12_ = icon_renderer;
			_tmp13_ = self->priv->icon_cell;
			if (_tmp12_ == _tmp13_) {
				GraniteWidgetsSourceListItem* _tmp14_;
				GIcon* _tmp15_;
				GIcon* _tmp16_;
				GIcon* _tmp17_;
				_tmp14_ = item;
				_tmp15_ = granite_widgets_source_list_item_get_icon (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = _g_object_ref0 (_tmp16_);
				_g_object_unref0 (icon);
				icon = _tmp17_;
			} else {
				GraniteWidgetsSourceListCellRendererIcon* _tmp18_;
				GraniteWidgetsSourceListCellRendererIcon* _tmp19_;
				_tmp18_ = icon_renderer;
				_tmp19_ = self->priv->activatable_cell;
				if (_tmp18_ == _tmp19_) {
					GraniteWidgetsSourceListItem* _tmp20_;
					GIcon* _tmp21_;
					GIcon* _tmp22_;
					GIcon* _tmp23_;
					_tmp20_ = item;
					_tmp21_ = granite_widgets_source_list_item_get_activatable (_tmp20_);
					_tmp22_ = _tmp21_;
					_tmp23_ = _g_object_ref0 (_tmp22_);
					_g_object_unref0 (icon);
					icon = _tmp23_;
				} else {
					g_assert_not_reached ();
				}
			}
		}
	}
	_tmp25_ = visible;
	if (_tmp25_) {
		GIcon* _tmp26_;
		_tmp26_ = icon;
		_tmp24_ = _tmp26_ != NULL;
	} else {
		_tmp24_ = FALSE;
	}
	_tmp27_ = _tmp24_;
	visible = _tmp27_;
	_tmp28_ = icon_renderer;
	_tmp29_ = visible;
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp28_, _tmp29_);
	_tmp31_ = visible;
	if (_tmp31_) {
		GIcon* _tmp32_;
		_tmp32_ = icon;
		_tmp30_ = _tmp32_;
	} else {
		_tmp30_ = NULL;
	}
	_tmp33_ = icon_renderer;
	_tmp34_ = _tmp30_;
	g_object_set ((GtkCellRendererPixbuf*) _tmp33_, "gicon", _tmp34_, NULL);
	_g_object_unref0 (item);
	_g_object_unref0 (icon);
	_g_object_unref0 (icon_renderer);
}


/**
         * Controls expander visibility.
         */
static void granite_widgets_source_list_tree_expander_cell_data_func (GraniteWidgetsSourceListTree* self, GtkCellLayout* layout, GtkCellRenderer* renderer, GtkTreeModel* model, GtkTreeIter* iter) {
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListItem* _tmp2_ = NULL;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceListItem* _tmp3_;
	GtkCellRenderer* _tmp16_;
	GraniteWidgetsCellRendererExpander* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (renderer != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = model;
	_tmp1_ = *iter;
	_tmp2_ = granite_widgets_source_list_tree_get_item_from_model (_tmp0_, &_tmp1_);
	item = _tmp2_;
	_tmp3_ = item;
	if (_tmp3_ != NULL) {
		GraniteWidgetsSourceListItem* _tmp4_;
		GraniteWidgetsSourceListExpandableItem* _tmp5_;
		GraniteWidgetsSourceListExpandableItem* expandable_item;
		GraniteWidgetsSourceListExpandableItem* _tmp6_;
		_tmp4_ = item;
		_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListExpandableItem*) _tmp4_) : NULL);
		expandable_item = _tmp5_;
		_tmp6_ = expandable_item;
		if (_tmp6_ != NULL) {
			gboolean _tmp7_ = FALSE;
			GtkCellRenderer* _tmp8_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_;
			GtkCellRenderer* _tmp14_;
			gboolean _tmp15_;
			_tmp8_ = renderer;
			g_object_get (_tmp8_, "is-expander", &_tmp9_, NULL);
			_tmp10_ = _tmp9_;
			if (_tmp10_) {
				GraniteWidgetsSourceListExpandableItem* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
				_tmp11_ = expandable_item;
				_tmp12_ = granite_widgets_source_list_expandable_item_get_collapsible (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp7_ = _tmp13_;
			} else {
				_tmp7_ = FALSE;
			}
			_tmp14_ = renderer;
			_tmp15_ = _tmp7_;
			g_object_set (_tmp14_, "is-expander", _tmp15_, NULL);
		}
		_g_object_unref0 (expandable_item);
	}
	_tmp16_ = renderer;
	_tmp17_ = self->priv->primary_expander_cell;
	if (_tmp16_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GTK_TYPE_CELL_RENDERER, GtkCellRenderer)) {
		GtkCellRenderer* _tmp18_;
		GraniteWidgetsSourceListDataModel* _tmp19_;
		GtkTreeIter _tmp20_;
		gboolean _tmp21_ = FALSE;
		_tmp18_ = renderer;
		_tmp19_ = self->priv->_data_model;
		_tmp20_ = *iter;
		_tmp21_ = granite_widgets_source_list_data_model_is_iter_at_root_level (_tmp19_, &_tmp20_);
		gtk_cell_renderer_set_visible (_tmp18_, !_tmp21_);
	} else {
		GtkCellRenderer* _tmp22_;
		GraniteWidgetsCellRendererExpander* _tmp23_;
		_tmp22_ = renderer;
		_tmp23_ = self->priv->secondary_expander_cell;
		if (_tmp22_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GTK_TYPE_CELL_RENDERER, GtkCellRenderer)) {
			GtkCellRenderer* _tmp24_;
			GraniteWidgetsSourceListDataModel* _tmp25_;
			GraniteWidgetsSourceListItem* _tmp26_;
			GtkTreeIter _tmp27_;
			gboolean _tmp28_ = FALSE;
			_tmp24_ = renderer;
			_tmp25_ = self->priv->_data_model;
			_tmp26_ = item;
			_tmp27_ = *iter;
			_tmp28_ = granite_widgets_source_list_data_model_is_category (_tmp25_, _tmp26_, &_tmp27_, NULL);
			gtk_cell_renderer_set_visible (_tmp24_, _tmp28_);
		} else {
			g_assert_not_reached ();
		}
	}
	_g_object_unref0 (item);
}


static GraniteWidgetsSourceListDataModel* granite_widgets_source_list_tree_get_data_model (GraniteWidgetsSourceListTree* self) {
	GraniteWidgetsSourceListDataModel* result;
	GraniteWidgetsSourceListDataModel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_model;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_tree_set_data_model (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListDataModel* value) {
	GraniteWidgetsSourceListDataModel* _tmp0_;
	GraniteWidgetsSourceListDataModel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_data_model);
	self->priv->_data_model = _tmp1_;
	g_object_notify ((GObject *) self, "data-model");
}


static GraniteWidgetsSourceListItem* granite_widgets_source_list_tree_get_selected_item (GraniteWidgetsSourceListTree* self) {
	GraniteWidgetsSourceListItem* result;
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->selected;
	result = _tmp0_;
	return result;
}


static void granite_widgets_source_list_tree_set_selected_item (GraniteWidgetsSourceListTree* self, GraniteWidgetsSourceListItem* value) {
	GraniteWidgetsSourceListItem* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	granite_widgets_source_list_tree_set_selected (self, _tmp0_, TRUE);
	g_object_notify ((GObject *) self, "selected-item");
}


static gboolean granite_widgets_source_list_tree_get_editing (GraniteWidgetsSourceListTree* self) {
	gboolean result;
	GtkCellRendererText* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->text_cell;
	g_object_get ((GtkCellRenderer*) _tmp0_, "editing", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static PangoEllipsizeMode granite_widgets_source_list_tree_get_ellipsize_mode (GraniteWidgetsSourceListTree* self) {
	PangoEllipsizeMode result;
	GtkCellRendererText* _tmp0_;
	PangoEllipsizeMode _tmp1_ = 0;
	PangoEllipsizeMode _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->text_cell;
	g_object_get (_tmp0_, "ellipsize", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}


static void granite_widgets_source_list_tree_set_ellipsize_mode (GraniteWidgetsSourceListTree* self, PangoEllipsizeMode value) {
	GtkCellRendererText* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->text_cell;
	_tmp1_ = value;
	g_object_set (_tmp0_, "ellipsize", _tmp1_, NULL);
	g_object_notify ((GObject *) self, "ellipsize-mode");
}


static void granite_widgets_source_list_tree_class_init (GraniteWidgetsSourceListTreeClass * klass) {
	GParamSpecInt* _tmp0_;
	GParamSpecInt* _tmp1_;
	GParamSpecInt* _tmp2_;
	GParamSpecInt* _tmp3_;
	GParamSpecInt* _tmp4_;
	GParamSpecInt* _tmp5_;
	granite_widgets_source_list_tree_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListTreePrivate));
	GTK_TREE_VIEW_CLASS (klass)->cursor_changed = granite_widgets_source_list_tree_real_cursor_changed;
	GTK_TREE_VIEW_CLASS (klass)->row_activated = granite_widgets_source_list_tree_real_row_activated;
	GTK_WIDGET_CLASS (klass)->key_release_event = granite_widgets_source_list_tree_real_key_release_event;
	GTK_WIDGET_CLASS (klass)->button_press_event = granite_widgets_source_list_tree_real_button_press_event;
	GTK_WIDGET_CLASS (klass)->popup_menu = granite_widgets_source_list_tree_real_popup_menu;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_tree_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_tree_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_tree_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL, g_param_spec_object ("data-model", "data-model", "data-model", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM, g_param_spec_object ("selected-item", "selected-item", "selected-item", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING, g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE, g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("item_selected", GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
	_tmp0_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEVEL_INDENTATION, "Level Indentation", "Space to add at the beginning of every indentation level. Must be an e" \
"ven number.", 1, 50, 6, G_PARAM_READABLE);
	_tmp1_ = _tmp0_;
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp1_);
	_g_param_spec_unref0 (_tmp1_);
	_tmp2_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_LEFT_PADDING, "Left Padding", "Padding added to the left side of the tree. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
	_tmp3_ = _tmp2_;
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp3_);
	_g_param_spec_unref0 (_tmp3_);
	_tmp4_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_TREE_STYLE_PROP_EXPANDER_SPACING, "Expander Spacing", "Space added between an item and its expander. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
	_tmp5_ = _tmp4_;
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp5_);
	_g_param_spec_unref0 (_tmp5_);
}


static void granite_widgets_source_list_tree_instance_init (GraniteWidgetsSourceListTree * self) {
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_TREE_GET_PRIVATE (self);
}


static void granite_widgets_source_list_tree_finalize (GObject* obj) {
	GraniteWidgetsSourceListTree * self;
	GtkCellRendererText* _tmp0_;
	guint _tmp1_ = 0U;
	GtkCellRendererText* _tmp2_;
	guint _tmp3_ = 0U;
	GraniteWidgetsSourceListDataModel* _tmp4_;
	guint _tmp5_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
	_tmp0_ = self->priv->text_cell;
	g_signal_parse_name ("editing-started", GTK_TYPE_CELL_RENDERER, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkCellRenderer*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_started_gtk_cell_renderer_editing_started, self);
	_tmp2_ = self->priv->text_cell;
	g_signal_parse_name ("editing-canceled", GTK_TYPE_CELL_RENDERER, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GtkCellRenderer*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled, self);
	_tmp4_ = self->priv->_data_model;
	g_signal_parse_name ("item-updated", GRANITE_WIDGETS_SOURCE_LIST_TYPE_DATA_MODEL, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _granite_widgets_source_list_tree_on_model_item_updated_granite_widgets_source_list_data_model_item_updated, self);
	_g_object_unref0 (self->priv->_data_model);
	_g_object_unref0 (self->priv->selected);
	_g_object_unref0 (self->priv->editable_entry);
	_g_object_unref0 (self->priv->text_cell);
	_g_object_unref0 (self->priv->icon_cell);
	_g_object_unref0 (self->priv->activatable_cell);
	_g_object_unref0 (self->priv->badge_cell);
	_g_object_unref0 (self->priv->primary_expander_cell);
	_g_object_unref0 (self->priv->secondary_expander_cell);
	_g_object_unref0 (self->priv->spacer_cells);
	G_OBJECT_CLASS (granite_widgets_source_list_tree_parent_class)->finalize (obj);
}


/**
     * The tree that actually displays the items.
     *
     * All the user interaction happens here.
     */
static GType granite_widgets_source_list_tree_get_type (void) {
	static volatile gsize granite_widgets_source_list_tree_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_tree_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListTree), 0, (GInstanceInitFunc) granite_widgets_source_list_tree_instance_init, NULL };
		GType granite_widgets_source_list_tree_type_id;
		granite_widgets_source_list_tree_type_id = g_type_register_static (GTK_TYPE_TREE_VIEW, "GraniteWidgetsSourceListTree", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_tree_type_id__volatile, granite_widgets_source_list_tree_type_id);
	}
	return granite_widgets_source_list_tree_type_id__volatile;
}


static void _vala_granite_widgets_source_list_tree_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL:
		g_value_set_object (value, granite_widgets_source_list_tree_get_data_model (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM:
		g_value_set_object (value, granite_widgets_source_list_tree_get_selected_item (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_EDITING:
		g_value_set_boolean (value, granite_widgets_source_list_tree_get_editing (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE:
		g_value_set_enum (value, granite_widgets_source_list_tree_get_ellipsize_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_tree_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceListTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_TYPE_TREE, GraniteWidgetsSourceListTree);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_DATA_MODEL:
		granite_widgets_source_list_tree_set_data_model (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_SELECTED_ITEM:
		granite_widgets_source_list_tree_set_selected_item (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_TREE_ELLIPSIZE_MODE:
		granite_widgets_source_list_tree_set_ellipsize_mode (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void granite_widgets_source_list_class_init (GraniteWidgetsSourceListClass * klass) {
	granite_widgets_source_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsSourceListPrivate));
	GRANITE_WIDGETS_SOURCE_LIST_CLASS (klass)->item_selected = granite_widgets_source_list_real_item_selected;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_finalize;
	/**
	     * Root-level expandable item.
	     *
	     * This item contains the first-level source list items. It //only serves as an item container//.
	     * It is used to add and remove items to/from the widget.
	     *
	     * Internally, it allows the source list to connect to its {@link Granite.Widgets.SourceList.ExpandableItem.child_added}
	     * and {@link Granite.Widgets.SourceList.ExpandableItem.child_removed} signals in order to monitor
	     * new children additions/removals.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ROOT, g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * The current selected item.
	     *
	     * Setting it to //null// un-selects the previously selected item, if there was any.
	     * {@link Granite.Widgets.SourceList.ExpandableItem.expand_with_parents} is called on the
	     * item's parent to make sure it's possible to select it.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_SELECTED, g_param_spec_object ("selected", "selected", "selected", GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Text ellipsize mode.
	     *
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE, g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Whether an item is being edited.
	     *
	     * @see Granite.Widgets.SourceList.start_editing_item
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_EDITING, g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	     * Sort direction to use along with the sort function.
	     *
	     * @see Granite.Widgets.SourceList.set_sort_func
	     * @since 0.2
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION, g_param_spec_enum ("sort-direction", "sort-direction", "sort-direction", GTK_TYPE_SORT_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Emitted when the source list selection changes.
	     *
	     * @param item Selected item; //null// if nothing is selected.
	     * @since 0.2
	     */
	g_signal_new ("item_selected", GRANITE_WIDGETS_TYPE_SOURCE_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListClass, item_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
}


static void granite_widgets_source_list_instance_init (GraniteWidgetsSourceList * self) {
	GraniteWidgetsSourceListExpandableItem* _tmp0_;
	self->priv = GRANITE_WIDGETS_SOURCE_LIST_GET_PRIVATE (self);
	_tmp0_ = granite_widgets_source_list_expandable_item_new ("");
	self->priv->_root = _tmp0_;
}


static void granite_widgets_source_list_finalize (GObject* obj) {
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
	_g_object_unref0 (self->priv->_root);
	_g_object_unref0 (self->priv->tree);
	G_OBJECT_CLASS (granite_widgets_source_list_parent_class)->finalize (obj);
}


/**
 * A widget that can display a list of items organized in categories.
 *
 * The source list widget consists of a collection of items, some of which are also expandable (and
 * thus can contain more items). All the items displayed in the source list are children of the widget's
 * root item. The API is meant to be used as follows:
 *
 * 1. Create the items you want to display in the source list, setting the appropriate values for their
 * properties. The desired hierarchy is achieved by creating expandable items and adding items to them.
 * These will be displayed as descendants in the widget's tree structure. The expandable items that are
 * not nested inside any other item are considered to be at root level, and should be added to
 * the widget's root item.<<BR>>
 *
 * Expandable items located at the root level are treated as categories, and only support text.
 *
 * ''Example''<<BR>>
 * The final tree will have the following structure:
 * {{{
 * Libraries
 *   Music
 * Stores
 *   My Store
 *      Music
 *      Podcasts
 * Devices
 *   Player 1
 *   Player 2
 * }}}
 *
 * {{{
 * var library_category = new Granite.Widgets.SourceList.ExpandableItem ("Libraries");
 * var store_category = new Granite.Widgets.SourceList.ExpandableItem ("Stores");
 * var device_category = new Granite.Widgets.SourceList.ExpandableItem ("Devices");
 *
 * var music_item = new Granite.Widgets.SourceList.Item ("Music");
 *
 * // "Libraries" will be the parent category of "Music"
 * library_category.add (music_item);
 *
 * // We plan to add sub-items to the store, so let's use an expandable item
 * var my_store_item = new Granite.Widgets.SourceList.ExpandableItem ("My Store");
 * store_category.add (my_store_item);
 *
 * var my_store_podcast_item = new Granite.Widgets.SourceList.Item ("Podcasts");
 * var my_store_music_item = new Granite.Widgets.SourceList.Item ("Music");
 *
 * my_store_item.add (my_store_music_item);
 * my_store_item.add (my_store_podcast_item);
 *
 * var player1_item = new Granite.Widgets.SourceList.Item ("Player 1");
 * var player2_item = new Granite.Widgets.SourceList.Item ("Player 2");
 *
 * device_category.add (player1_item);
 * device_category.add (player2_item);
 * }}}
 *
 * 2. Create a source list widget.<<BR>>
 * {{{
 * var source_list = new Granite.Widgets.SourceList ();
 * }}}
 *
 * 3. Add root-level items to the {@link Granite.Widgets.SourceList.root} item.
 * This item only serves as a container, and all its properties are ignored by the widget.
 *
 * {{{
 * // This will add the main categories (including their children) to the source list. After
 * // having being added to be widget, any other item added to any of these items
 * // (or any other child item in a deeper level) will be automatically added too.
 * // There's no need to deal with the source list widget directly.
 *
 * var root = source_list.root;
 *
 * root.add (library_category);
 * root.add (store_category);
 * root.add (device_category);
 * }}}
 *
 * The steps mentioned above are enough for initializing the source list. Future changes to the items'
 * properties are ''automatically'' reflected by the widget.
 *
 * Final steps would involve connecting handlers to the source list events, being
 * {@link Granite.Widgets.SourceList.item_selected} the most important, as it indicates that
 * the selection was modified.
 *
 * It is strongly recommended to pack the source list into the GUI using the
 * {@link Granite.Widgets.ThinPaned} widget. It has aesthetic advantages and offers a wider
 * re-size handle than {@link Gtk.Paned}. This is usually done as follows:
 * {{{
 * var pane = new Granite.Widgets.ThinPaned ();
 * pane.pack1 (source_list, true, false);
 * pane.pack2 (content_area, true, false);
 * }}}
 *
 * @since 0.2
 * @see Granite.Widgets.ThinPaned
 */
GType granite_widgets_source_list_get_type (void) {
	static volatile gsize granite_widgets_source_list_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceList), 0, (GInstanceInitFunc) granite_widgets_source_list_instance_init, NULL };
		GType granite_widgets_source_list_type_id;
		granite_widgets_source_list_type_id = g_type_register_static (GTK_TYPE_SCROLLED_WINDOW, "GraniteWidgetsSourceList", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_type_id__volatile, granite_widgets_source_list_type_id);
	}
	return granite_widgets_source_list_type_id__volatile;
}


static void _vala_granite_widgets_source_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ROOT:
		g_value_set_object (value, granite_widgets_source_list_get_root (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SELECTED:
		g_value_set_object (value, granite_widgets_source_list_get_selected (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE:
		g_value_set_enum (value, granite_widgets_source_list_get_ellipsize_mode (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_EDITING:
		g_value_set_boolean (value, granite_widgets_source_list_get_editing (self));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION:
		g_value_set_enum (value, granite_widgets_source_list_get_sort_direction (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_source_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsSourceList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST, GraniteWidgetsSourceList);
	switch (property_id) {
		case GRANITE_WIDGETS_SOURCE_LIST_ROOT:
		granite_widgets_source_list_set_root (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SELECTED:
		granite_widgets_source_list_set_selected (self, g_value_get_object (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_ELLIPSIZE_MODE:
		granite_widgets_source_list_set_ellipsize_mode (self, g_value_get_enum (value));
		break;
		case GRANITE_WIDGETS_SOURCE_LIST_SORT_DIRECTION:
		granite_widgets_source_list_set_sort_direction (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



